﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10.2
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim CommentColor As Int = 0xFF008000 ' Green
	Dim NumberColor As Int = 0xFF800080 ' Purple
	Dim StringColor As Int = 0xFFA31515 ' Reddish
	Dim KeywordColor As Int = 0xFF0000FF ' Blue
	Dim ScriptColor As Int = 0xFF0060E0 'Blueish
	Public ErrorColor As Int = 0xffff6060 ' Desaturated red for visibility
	Public SearchColor As Int = 0xff40e0d0 ' MediumAquamarine
	'Public SearchColor As Int = 0xff90cfc9 ' Dark Turquoisy, same as selected text

	
	Public AC_NONE As Int = 0 ' none
	Public AC_BASIC As Int = 1 ' name and parentheses
	Public AC_PARAMS As Int = 2 ' name, parentheses and commas
	Public AC_FULL As Int = 3 ' name, parentheses, commas and param names
	
	Dim BOM As Int : 	BOM = 65279 ' Byte Order Mark for Windows UTF-8 files
	
End Sub

Public Sub AddSyntax(edtSource As CodeEditorView)
	
'	'Keywords B4AScript	
	Dim scriptwordlist As List
	Dim sb As StringBuilder
	sb.Initialize
	scriptwordlist = File.ReadList(File.DirAssets, "BasicIDEKeywordsHighlight.txt")
	Dim s As String = scriptwordlist.Get(0)
	scriptwordlist.Set(0, s.Replace(Chr(BOM), "")) ' remove BOM if present in case file is from Windows
	
	' add all the keywordslist entries into a string pattern
	sb.Append("(\b(")
	For i = 0 To scriptwordlist.Size - 1
		sb.Append(scriptwordlist.Get(i)).append("|")
	Next
	' remove last pipe character
	sb.Remove(sb.Length-1, sb.Length)
	' complete the pattern and add it
	sb.Append(")\b)")
	edtSource.AddSyntaxPattern(sb.ToString, KeywordColor, True)

	' Keywords - Script module functions
	Dim scriptwordlist As List
	Dim sb As StringBuilder
	sb.Initialize
	scriptwordlist = File.ReadList(File.DirAssets, "BasicIDEScriptHighlight.txt")
	Dim s As String = scriptwordlist.Get(0)
	scriptwordlist.Set(0, s.Replace(Chr(BOM), "")) ' remove BOM if present in case file is from Windows
	
	' add all the keywordslist entries into a string pattern
	sb.Append("(\b(")
	For i = 0 To scriptwordlist.Size - 1
		sb.Append(scriptwordlist.Get(i)).append("|")
	Next
	' remove last pipe character	sb.Remove(sb.Length-1, sb.Length)	
	sb.Remove(sb.Length-1, sb.Length)
	' complete the pattern and add it
	sb.Append(")\b)")
	edtSource.AddSyntaxPattern(sb.ToString, ScriptColor, True)
	
	' Numbers - integer, decimal, scientific and hex 
	edtSource.AddSyntaxPattern("(\b\d+[\.]?\d*([eE]\-?\d+)?[lLdDfF]?\b|\b0x[a-fA-F\d]+\b)", NumberColor, False)
	
	'Strings - strings using either ' or " as the delimiters
	edtSource.AddSyntaxPattern("(\'(?:[^\']|\'\')*\'|\'(?:\\.|[^\\\'])*(\'|\\b))", StringColor, True)
	edtSource.AddSyntaxPattern("(\" & Chr(34) & "(?:[^\" & Chr(34) & "]|\" & Chr(34) & "\" & Chr(34) & ")*\" & Chr(34) & "|\" & Chr(34) & "(?:\\.|[^\\\" & Chr(34) & "])*(\" & Chr(34) & "|\\b))", StringColor, True)
	
	' Comments - lines beginning with whitespace and "REM " or "#"
	' The patterns are applied in the order in which they are added.
	' Adding these last prevents keywords in the comments being highlighted so avoiding complex keyword regexes.
	
	' using these we highlight the line numbers as well, which does't look good
	'edtSource.AddSyntaxPattern("^[0-9 :]*\s*(#.*)", CommentColor, True)
	'edtSource.AddSyntaxPattern("^[0-9 :]*\s*(rem .*)", CommentColor, True)
	
	' these match line numbered comments, the line numbers are not included in the match as it looks better
	' this will also wrongly match a string containing " : rem aaa" Or " : #aaa"
	' this is pretty unlikely, and is cosmetic anyway, so we'll use this for now
	edtSource.AddSyntaxPattern(" :\s*#.*", CommentColor, True)
	edtSource.AddSyntaxPattern(" :\s*rem .*", CommentColor, True)
	
	' these match comments at the start of a line without line numbers
	' this is unambiguous and won't cause any false matches
	edtSource.AddSyntaxPattern("^\s*#.*", CommentColor, True)	
	edtSource.AddSyntaxPattern("^\s*rem .*", CommentColor, True)
	
End Sub


Public Sub AddAutoComplete(edtSource As CodeEditorView, mode As Int, globalviews As List)
	' we will add all the words in the keyword list as autocomplete entried
	Dim keywordlist As List
	keywordlist.Initialize
	
	If mode < AC_BASIC Or mode > AC_FULL Then
		' we can't disable it so we give it nothing to match
		edtSource.AddAutoCompleteWords(Array As String())	
		Return
	End If
	
	' add B4AScript keywordsto keywordslist
	Dim wordlist As List
	wordlist = File.ReadList(File.DirAssets, "BasicIDEKeywordsAutocomplete.txt")
	Dim s As String = wordlist.Get(0)
	wordlist.Set(0, s.Replace(Chr(BOM), "")) ' remove BOM if present in case file is from Windows	
	keywordlist.AddAll(wordlist)
	
	' add Script module additional functions to keywordslist
	Dim wordlist As List
	wordlist = File.ReadList(File.DirAssets, "BasicIDEScriptAutocomplete.txt")
	Dim s As String = wordlist.Get(0)
	wordlist.Set(0, s.Replace(Chr(BOM), "")) ' remove BOM if present in case file is from Windows	
	keywordlist.AddAll(wordlist)
	
	If globalviews.Size > 0 Then
		keywordlist.AddAll(globalviews)
	End If

	keywordlist.SortCaseInsensitive(True) ' need this as autocomplete doesn't seem to sort properly
	' add all the keywordslist entries into a string array
	Dim keywords(keywordlist.Size) As String
	For i = 0 To keywords.Length - 1
		keywords(i) = keywordlist.Get(i)
		keywords(i) = AdjustEntry(keywordlist.Get(i), mode)
		keywords(i) = keywords(i).Replace(",", ", ")
		If mode = AC_PARAMS Then
			keywords(i) = keywords(i).Replace("(", "( ")
		End If
	Next

	' and finally add the string array containing all the autocomplete words
	edtSource.AddAutoCompleteWords(keywords)
End Sub


Sub AdjustEntry(entry As String, mode As Int) As String
	Dim idx1  As Int
	Dim name, params, commas As String
	Select mode
		Case  AC_FULL ' name, parentheses, commas and param names
			Return entry
						
		Case AC_PARAMS ' name, parentheses and commas
			idx1 = entry.IndexOf("(")
			If idx1 < 0 Then
				Return entry ' no parentheses
			End If
			name = entry.SubString2(0, idx1) 
			params = entry.SubString(idx1)
			commas = "("
			idx1 = params.IndexOf(",")
			Do While idx1 > 0 
				commas = commas & ","
				idx1 = params.IndexOf2(",", idx1+1)			
			Loop			
			commas = commas & ")"
			
			Return name & commas
		Case AC_BASIC ' name and parentheses
			idx1 = entry.IndexOf("(")
			If idx1 > 0 Then
				entry = entry.SubString2(0, idx1) & "()"
			End If
			Return entry
			
	End Select	
	Return entry 'should never get here but satisifies the compiler
End Sub
