﻿Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=2.52
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
' ignore '9 Unused variable', '12:Sub not used', '33:DoEVents is deprecated', '34 Modal dialogs deprecated' warnings
	#IgnoreWarnings:  9, 12, 33, 34
#End Region


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.


	Dim Blib As BasicLib
	Dim StackSize As Int = 15                                   
	
	Private GPS As GNSS
	Public GPSAvailable As Boolean
	Private GpsStarted As Boolean ' shows actual state of GPS
	Private GPSWasRunning As Boolean ' shows if GPS was running when Paused
	Private GPSLocation As Location ' latest GPS location
	Private Bdsats, Gasats, Glsats, Gpsats As String ' comma delimited string of satellites visible in each constellation
	' GNSSSatType.Prn field is a string to match type of prn parameter in GNSSSatPrn or Map lookup fails
	Type GNSSSatType (Prn As String, Azimuth As Float, Elevation As Float, UsedInFix As Boolean, Snr As Int)
	Dim GNSSSatsList As List ' sortable list of GNSSSatType built from GPSSatellites or GNSSSatellitesInfo
	Dim GNSSSatsMap As Map ' key = prn : value = GNSSSatType for satellite
	Private OSGB As GPStoOSGB
	Dim Latitude, Longitude As Double
	Dim GridRef As String
	
	
	Dim GlobalVarsMap As Map ' saves global values over Pause and Resume, used by Save/Restore Array/Global
	
	Dim TheBitmap As Bitmap ' one bitmap	
	Dim TheList As List ' one list
	Dim TheMap As Map ' one Map
	Dim TheMatcher As Matcher ' one regular expression Matcher
	Dim TheStringBuilder As StringBuilder ' one StringBuilder	
	Dim TheTypeface As Typeface ' one typeface
	Dim Timer1 As Timer ' one timer
	Dim TimerWasRunning As Boolean
		
	Dim ColourNames As Colours
	Dim arraysX As ArraysExtra
	
	'Phone library things
	Dim ThePhone As Phone
	Dim ThePhoneVibrate As PhoneVibrate
	Dim ThePhoneWakeState As PhoneWakeState
	
	Dim SensorToNameMap As Map ' key = PhoneSensors : value = SensorName. Used to look up sensor type in SensorChanged event
	Dim NameToSensorMap As Map ' key = SensorName : value = PhoneSensors. Used to look up Phonesensor in StartSensor and StopSensor

	Dim FirstRunFlag As Boolean	'First run of a script, even if Activity Create FirstTime is False
	Dim Restarting As Boolean ' The script is restarting the Activity using RestartActivity
	Dim ScriptDir As String = "" ' Used by Chain to locate the script file to be invoked
	Public Alongside As Boolean
	Public ErrorLineNumber As Int = 0 ' The line where an error occurred or 0 if no error
	Public ErrorLineCode As String = "" ' The code of the line where an error occurred or "" if no error	

	Dim EditorFileName As String ' set by Main on run with the file name of the program in the editor
	Dim Program As String ' set by Main or Chain with the script code to run
	Dim Args(0) As String
	Dim Output As String ' set by Print statement in script code

	Dim ProgramFileName As String 'Set by Main or Chain to the file name of the program actually running
	Type VarType (Name As String, Ranks As String, IsArray As Boolean) ' used in displaying variable values 	

	Type TypeNumString(sortvalue As Double, othervalue As String) ' use for sorting two arrays in step
	Type TypeStringString(sortvalue As String, othervalue As String)
	
	Dim LastSensorValues() As Float ' The values array passed to the latest Sensor_Changed event
	
	Dim InputFileColor As Int = Colors.Black
	Dim InputFileTextSize As Float = 0
	
	' Included file error reporting support
	Type IncludedFile (name As String, firstline As Int, lastline As Int)
	Dim IncludedFileList As List
	Dim LastMainCodeLine As Int

End Sub


Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim ViewMap As Map ' holds all views, keys are lower case view names, values are the view references

	Dim TheCanvas As Canvas ' one canvas
	
	Dim Clipboard As BClipboard
	
	Dim aw As Int ' screen width
	Dim ah As Int ' screen height
	Dim activityorientation As String
	Dim input As String ' last dialog input
	
	Dim starting As Boolean ' used to detect and ignore the first Ended event after the initial block has completed
	Dim Obj1 As Reflector
	Dim IME As IME2
End Sub


#Region Activity

' we check this as the parameter should be a string containing the view name
' but it is very easy to just type the view name itself which is then treated as a variable
' designer layouts have a variable declared for each view that contains the lower cased view name
' it is lower cased for use in events where the sender name is lower cased
Sub ViewMapGet(viewname As String) As Object
	Dim o As Object = ViewMap.Get(viewname)
	If o <> Null Then
		Return o	
	End If
	Dim msg As String = Blib.LineNumber & ": " & Blib.ProgramLine(Blib.LineNumber)
	msg = msg & CRLF & CRLF & "A view referenced in line " & Blib.LineNumber & " does not exist. Ensure that you passed a valid name."
	MsgboxAsync(msg, "View not found")	
	Return Null	
End Sub

' we check this as the parameter should be a string containing the array name
' but it is very easy to just type the array name itself which is then treated as a variable
' we don't check those few functions where a zero length array might be expected
' we treat a passed zero length array as suspect, if necesary a script should check before calling
Sub BlibGetArray(arrayname As String) As String()
	Dim ia(0) As String
	ia = Blib.GetArray(arrayname)
	If ia.Length <> 0 Then Return ia
	Dim msg As String = Blib.LineNumber & ": " & Blib.ProgramLine(Blib.LineNumber)
	msg = msg & CRLF & CRLF & "An array referenced at line " & Blib.LineNumber & " has a length of 0 or does not exist. Ensure that you passed a valid name."
	MsgboxAsync(msg, "Array not found")	
	Return ia	
End Sub

'special for Async functions to allow a blank string parameter when no other parameters are needed
'instead of erroring we return an array of one item to allow a params(0) value return
Sub BlibGetAsyncArray(arrayname As String) As String()
	Dim ia(0) As String
	ia = Blib.GetArray(arrayname)
	If ia.Length <> 0 Then Return ia
	Dim ia(1) As String
	Return ia	
End Sub


Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = ""	 ' Otherwise we briefly see 'Basic IDE'

	' first time actions for this activity
	If FirstTime Then
		Timer1.Initialize("Timer", 1000)
		Blib.Initialize("Blib")
		GPS.Initialize("GPS")
		AddNewSysCalls
	End If

	' First time actions for this program, including loading it into Blib
	' FirstRunFlag is set True when Main starts this Activity and set to False in the Pause event
	' We need this as returning to the IDE from a script and then restarting does not set FirstTime
	' As we need to do first time things for a script we have FirstRunFlag separate from FirstTime
	' FirstRunFlag is also set True when a script calls RestartActivity or Chain.
	' Restarting is set True when a script calls RestartActivity or Chain.
	If FirstRunFlag Then
		If Not(Restarting) Then ' First run of a program
			StateManager.ResetAll
			GlobalVarsMap.Initialize
			TheStringBuilder.Initialize
			TheList.Initialize
			TheMap.Initialize
			SensorToNameMap.Initialize
			NameToSensorMap.Initialize
			ColourNames.Initialize
			GPSWasRunning = False	
		End If
		ErrorLineNumber = 0
		ErrorLineCode = ""
		GNSSSatsList.Initialize
		GNSSSatsMap.Initialize
		TheTypeface = Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_NORMAL)
		Timer1.Interval = 1000 ' set timer defaults for first program run
		Timer1.Enabled = False ' belt and braces!
		TimerWasRunning = False
		Blib.Step = False
		Blib.BreakAtLine = 0
		Blib.StackDepth = StackSize
		LoadIncludedCode
		Dim ok As Boolean = Blib.LoadCodeAsString(Program)
		If ok Then
			Output = ""
		Else
			Blib_Ended(Blib.ErrorString)
			Return
		End If
	End If	
	
	' activity (re)creation actions
	ViewMap.Initialize
	ViewMap.Put("activity", Activity)
	aw = Activity.Width
	ah = Activity.Height
	If aw < ah Then
		activityorientation = "Portrait"
	Else
		activityorientation = "Landscape"
	End If
	IME.Initialize("IME")
	Blib.Run(Args) ' the program must have loaded OK in order to get to here
	TimerWasRunning = Timer1.Enabled ' in case it was enabled in the initial code block
End Sub

Sub LoadIncludedCode
	Dim NativeMe As JavaObject
	NativeMe.InitializeContext
	IncludedFileList.Initialize
	Dim includes As List
	includes.Initialize
	' split the main code into individual lines
	' Splitting strings removes trailing new lines but as we split the main and included programs separately we remove trailing new lines from each
	' but if we concatenate the programs and send the result to BasicLib it only removes the trailing newlines from the last include
	 'so we remove the trailing new lines from each program string so the line numbers of the split arrays and the final program agree
	Program = RemoveTrailingNewLines(Program)
	Dim CodeLines() As String = NativeMe.RunMethod("StringSplit", Array (Program)) 'removes trailing sp
	' save the last line number for correcting included file line numbers on error
	LastMainCodeLine = CodeLines.Length
	'find the includes
	For Each line As String In CodeLines
		If line.Trim.StartsWith("#include ") Then
			Dim name As String = line.SubString2(9, line.Length)
			If Not(name.ToLowerCase.EndsWith(".b4s")) Then
				name = name & ".b4s"
			End If
			If includes.IndexOf(name) < 0 Then
				includes.Add(name)
			End If
		End If		
	Next
	' now add the code for each included file to the end of the main code
	' we record the new first line number of each included file to use if an error is reported
	' if scriptname does not end with the suffix '.b4s' then Chain will add that suffix to scriptname.
	' like Chain, the new includes are loaded from the folder specified in the ScriptDir process global variable.
	' nested incudes are not supported
	Dim NextFirstLine As Int = LastMainCodeLine + 1
	For Each include As String In includes
		Dim code As String = FileReadString(ScriptDir, include)
		If code.StartsWith("!ERROR!") Then
			MsgboxAsync("Included program '" & include & "' not found in" & CRLF & ScriptDir, "Include Error")
			Wait For MsgBox_Result(Result As Int)
			Activity.Finish
		End If
		code = RemoveTrailingNewLines(code)
		Dim IncludeCodeLines() As String =  NativeMe.RunMethod("StringSplit", Array (code))
		Dim Inc As IncludedFile
		Inc.Initialize
		Inc.name = include
		Inc.firstline = NextFirstLine
		NextFirstLine = NextFirstLine + IncludeCodeLines.Length
		Inc.lastline = NextFirstLine - 1
		IncludedFileList.Add(Inc)
		Program = Program & code
	Next
End Sub

'This is probably unnecessary and Regex.Split would be OK but this is what BasicLib does so we do the same
#If JAVA
public String[] StringSplit(String program) {
  return program.split("\n");
}
#End If

Sub RemoveTrailingNewLines(code As String) As String
	Do While code.EndsWith(CRLF)
		code = code.SubString2(0, code.Length - 1)
	Loop
	Return code & CRLF	
End Sub


Sub Activity_Resume
	If Blib.CanCall("Activity_Resume") Then ' check if the Sub exists
		Blib.Call("Activity_Resume", Null) 
	End If
	Restarting = False
	FirstRunFlag = False
	Timer1.Enabled = TimerWasRunning
	If GPSWasRunning Then
		StartGNSS
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If Blib.CanCall("Activity_Pause") Then ' check if the Sub exists
		Dim params(1) As String
		params(0) = UserClosed
		Blib.Call("Activity_Pause", params) 
	End If
	TimerWasRunning = Timer1.Enabled
	Timer1.Enabled = False
	GPSWasRunning = GpsStarted
	StopGNSS
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If Blib.CanCall("Activity_KeyPress") Then
		Dim rtn As String
		Dim params(1) As String
		params(0) = KeyCode
		rtn = Blib.Call("Activity_Keypress", params)
		If rtn.ToLowerCase = "true" Then
			Return True
		Else
			Return False
		End If
	End If
	Return False
End Sub

#End Region


#Region BasicLib Events

Sub Blib_Loaded(error As String) 'Error is an empty string if the script loaded without error	
	If error <> "" Then
		Dim msg As String = "Error at line " & Blib.LineNumber & CRLF
		msg = msg & "Code - " & Blib.ProgramLine(Blib.LineNumber) 
		msg = msg & "Error - " & Blib.ErrorString 
		MsgboxAsync(msg,"Error loading script")
		Wait For MsgBox_Result(Result As Int)		
		Activity.Finish
	End If
End Sub

Sub Blib_Starting 'The script has initialised its variables and is about to start executing
	starting = True
End Sub

Sub Blib_Break(linenumber As Int) 'The script has stopped at linenumber
	Dim msg As String= "Break at line " & Blib.linenumber & " : "  & Blib.ProgramLine(Blib.linenumber) & CRLF	
	msg = msg & GetVariableVals(True) & CRLF	
'	msg = msg & "Step to step one line" & CRLF
'	msg = msg & "Run to run and keep break" & CRLF
'	msg = msg & "Cancel to run and clear break"	
	' Modal Msgbox2 because we rely on it to keep the program halted
	Dim Result As Int = Msgbox2(msg,"Break", "Step", "Run", "", Null)
	If Result = DialogResponse.NEGATIVE Then ' Cancel Break and Run
		Blib.BreakAtLine = 0
	Else If Result = DialogResponse.POSITIVE Then ' Step
		Blib.Step = True
	Else If Result = DialogResponse.CANCEL Then ' Run
		Blib.Step = False			
	End If	
End Sub

Sub Blib_Stepped(linenumber As Int) 'The script has stepped to linenumber
	Dim msg As String = "Stepped to line " & Blib.linenumber & " : "  & Blib.ProgramLine(Blib.linenumber) & CRLF
	msg = msg & GetVariableVals(True) & CRLF
	msg = msg & "Continue stepping?"
	' Modal Msgbox2 because we rely on it to keep the program halted
	Dim ret As String = Msgbox2(msg,"Stepped", "Yes", "No", "", Null)
	If ret <> DialogResponse.POSITIVE Then
		Blib.Step = False
	End If
End Sub

Sub GetVariableVals(showglobals As Boolean) As String
	Dim GlobalVars, LocalVars, Printed As String
	Dim LocalsArr(0), GlobalsArr(0), varval As String
	Dim vtype As VarType
	GlobalVars = Blib.GetGlobalVars
	LocalVars = Blib.GetLocalVars
	GlobalsArr = Regex.Split(",", GlobalVars)
	LocalsArr = Regex.Split(",", LocalVars)
	GlobalVars = "GLOBAL VARIABLES" & CRLF
	LocalVars = "LOCAL VARIABLES" & CRLF
	Printed = ""
	If showglobals And GlobalsArr(0) <> "" Then
		For Each var In GlobalsArr
			vtype = ParseVar(var)
			GlobalVars = GlobalVars & vtype.Name
			If vtype.IsArray Then
				GlobalVars = GlobalVars & vtype.Ranks
			End If
			GlobalVars = GlobalVars & " = '" & Blib.GetGlobal(vtype.Name).Replace(Chr(10), "\n") & "'"
			If vtype.IsArray Then
				GlobalVars = GlobalVars  & " ... "
			End If
			GlobalVars = GlobalVars  & CRLF
		Next
	End If
	If LocalsArr(0) <> "" Then
		For Each var In LocalsArr
			varval =  Blib.GetLocal(var)
			If varval = Null Then
				LocalVars = LocalVars & var & " = Null" & CRLF
			Else
				LocalVars = LocalVars & var & " = '" & varval.Replace(Chr(10), "\n") & "'" & CRLF
			End If
		Next
	End If
	If Output <> "" Then
		Printed = "PRINT OUTPUT" & CRLF & Output
	Else
			Printed = ""
	End If	
	Return LocalVars & CRLF & GlobalVars & CRLF & Printed
End Sub

Sub ParseVar(var As String) As VarType
	Dim vparts(2) As String '= Regex.Split("\(", var)
	Dim idx As Int = var.IndexOf("(")
	vparts(0) = var.SubString2(0, idx)
	vparts(1) = var.SubString(idx)	
	Dim vtype As VarType
	vtype.IsArray = True
	vtype.Name = vparts(0)
	vtype.Ranks = vparts(1).Replace(":", ",")
	If vtype.Ranks = "(1,0,0)" Then vtype.IsArray = False
	Return vtype	
End Sub

Sub Blib_Ended(error As String) 'Error is an empty string if the script terminated without error
	If starting And error = "" Then ' don't stop after initial code block exits except on error
		starting = False
		Return
	End If
	ErrorLineNumber = 0 ' this says 'no error' on return to the editor
	ErrorLineCode = ""
	If Blib.ErrorString <> "" Then
	' We seem to have an error so show the error info first before any print output
	' It might be in a different file to that in the editor This could be because
	' 1) Run Program was used by the user to run a specific program with a different one in the editor
	' 2) #include was used by the original progam so several files were concatenated into a single program
	' 3) A program used Chain to start another  program		
		ErrorLineNumber = Blib.LineNumber
		ErrorLineCode =  Blib.ProgramLine(Blib.LineNumber)
		If ErrorLineNumber > LastMainCodeLine Then
			' the error is in an included file - lets find its name and correct the error line number
			Dim filename As String = "Unknown"
			Dim linenumber As Int = 0
			For Each IncFile As IncludedFile In IncludedFileList
				If IncFile.firstline <= ErrorLineNumber And IncFile.lastline >= ErrorLineNumber Then
					filename = IncFile.name
					linenumber = ErrorLineNumber - IncFile.firstline +1					
				End If				
			Next			
			Dim msg As String = "Include file - " & filename & CRLF
			msg =msg & "Error at line " & linenumber & CRLF
			msg = msg & "Code - " & ErrorLineCode ' already got a CRLF
			msg = msg & "Error - " & Blib.ErrorString
			ErrorLineNumber = linenumber ' in case file is in editor
			ProgramFileName = filename
		Else
			Dim msg As String = "Program file - " & ProgramFileName & CRLF
			msg  = msg & "Error at line " & ErrorLineNumber & CRLF
			msg = msg & "Code - " & ErrorLineCode ' already got a CRLF
			msg = msg & "Error - " & Blib.ErrorString
		End If
		If ProgramFileName.ToLowerCase <> EditorFileName.ToLowerCase Then
			ErrorLineNumber = 0	' stop editor trying to display the line in error as it's not in the editor			
		End If
		Msgbox(msg,"Ended with error")
		'Can't use Async here as if the user closed the Activity it will return and immediately close the Activity and the Async dialog
		'MsgboxAsync(msg,"Ended with error")
		'Wait For MsgBox_Result(Result As Int)
	End If
	If Output <> "" Then
		Msgbox(Output, "Ended - Print Output")
		'Can't use Async here as if the user closed the Activity it will return and immediately close the Activity and the Async dialog
		'MsgboxAsync(Output, "Ended - Print Output")
		'Wait For MsgBox_Result(Result As Int)
	End If
	Activity.Finish
End Sub

Sub Blib_Message(message As String, subject As String)
	' This event is raised the the script Msgbox and Print keywords
	' Print automatically uses the subject "print" and it can be added to Msgbox programmatically
	' If the subject "print" we add the message to the output buffer without displaying it
	If subject.ToLowerCase = "print" Then
		If message.ToLowerCase.StartsWith("<clear>") Then
			Output = message.SubString(7)
			If Output <> "" Then 
				Output = Output & CRLF
			End If
		Else If message.ToLowerCase.StartsWith("<delete>") Then
			Dim  txt As String = Output
			Dim idx As Int = txt.LastIndexOf(CRLF)
			If (idx >= 0) Then
				idx = txt.LastIndexOf2(CRLF, idx-1)
			End If			
			If (idx >= 0) Then
				txt = txt.Substring2(0, idx + 1)
			Else
				txt = ""
			End If
			Output = txt & message.SubString(8) & CRLF
		Else
			Output = Output & message & CRLF 
		End If
	Else
		' Modal Msgbox because the Script program and Debugging Functions expect to halt the program until Msgbox is dismissed
		Msgbox(message, subject)
	End If
End Sub

#End Region


#Region Script support Subs

Sub AddView(o As Object, name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim v As View
	If parent = "" Then
		Activity.AddView(o, left, top, width, height)
		ViewMap.Put(name.ToLowerCase, o)
	Else
		v = ViewMapGet(parent.ToLowerCase)
		If v.IsInitialized Then
			If v Is Panel Then
				Dim p As Panel
				p = v
				p.AddView(o, left, top, width, height)
				ViewMap.Put(name.ToLowerCase, o)
			Else
				Dim msg As String = "Attempt at line " & Blib.LineNumber & " to add '" & name & "' to '" & parent & " which is not a Panel"
				MsgboxAsync(msg, "Panel not found")				
			End If
		End If
	End If
End Sub

#End Region


#Region HTML Contents

' Subs below are called by the running script
' Do Edit -> Outlining -> Collapse All then expand the regions below to conveniently see what functions are available

''<a name="top"></a>
''<b><u>BasicIDE B4AScript Language Extensions v6.00</u></b><br>
''<a href="#events">Script Events</a><br>
''<a href="#functions">General Functions</a><br>
''<a href="#strings">String, Numeric and Logical Functions</a><br>
''<a href="#activity">Activity and Device Functions</a><br>
''<a href="#phone">Phone Interaction Functions</a><br>
''<a href="#array">Array Functions</a><br>
''<a href="#collections">Collection Functions</a><br>
''<a href="#file">File Functions</a><br>
''<a href="#gnss">GNSS Functions</a><br>
''<a href="#sensors">Sensor Functions</a><br>
''<a href="#view">Add and Remove View Functions</a><br>
''<a href="#shared">Shared View Functions</a><br>
''<a href="#check">CheckBox, RadioButton and ToggleButton Functions</a><br>
''<a href="#edittext">EditText Functions</a><br>
''<a href="#graphics">Graphics and Image Functions</a><br>
''<a href="#imageview">ImageView and ScaleImageView Functions</a><br>
''<a href="#listview">ListView Functions</a><br>
''<a href="#listandspin">ListView and Spinner Functions</a><br>
''<a href="#progressbar">ProgressBar Functions</a><br>
''<a href="#regex">Regular Expression Functions</a><br>
''<a href="#scrollview">ScrollView Functions</a><br>
''<a href="#seekbar">SeekBar Functions</a><br>
''<a href="#spinner">Spinner Functions</a><br>
''<a href="#tabhost">TabHost Functions</a><br>
''<a href="#table">Table Functions</a><br>
''<a href="#textview">Textview Functions</a><br>
''<a href="#timer">Timer Functions</a><br>
''<a href="#user">User Interaction Functions</a><br>
''<a href="#async">Async User Interaction Functions</a><br>
''<a href="#debugging">Debugging Functions</a><br>
''<a href="#colors">Color Names and Constants</a><br>
''<a href="#key">KeyCode Functions and Constants</a><br>
''<a href="#gravity">Gravity Constants</a><br>
''<a href="#typeface">Typeface Constants</a><br>
''<a href="#csensors">Sensor Constants</a><br>

#End Region


#Region Script Events

''<a name="events"></a>
''@H:SCRIPT EVENTS
''
''If a Sub of any of these names are defined in the program then it will be called at the appropriate time.
''The 'who' parameter will be set to the lower cased name of the view that caused the event.
''Use Template.b4s as a starting point for a project and enter the event code as needed.

''@N:Activity_Create
''There is no supported Activity_Create sub.
''Instead the inital block of code block from the beginning of the script up to the first Sub statement is run.
''GetFirstTime returns True the first time the initial code block is run after a program is started.
''This block of code will be run again whenever the Activity is re-created

''@N:Activity_Pause(userclosed)
''"Sub activity_pause(userclosed)" is called if implemented. userclosed will be True if the [Back] button was pressed.

''@N:Activity_Resume
''"Sub activity_resume" is called if implemented.

''@N:Activity_Keypress(keycode)
''"Sub activity_keypress(keycode)" is called if implemented.
''Keycode will contain the system key code of the key pressed, and may be tested using the KEYCODE FUNCTIONS and KEYCODE CONSTANTS.
''Return True from Activity_Keypress(keycode) to consume the keystroke (ie. not allow the system to continue processing it.)
''
''Example:
''Sub Activity_Keypress(keycode)
''&nbsp;&nbsp;# process numbers only, all others ignored
''&nbsp;&nbsp;If keycode = Key_isNumber(keycode)
''&nbsp;&nbsp;&nbsp;&nbsp;# process the keystroke here...
''&nbsp;&nbsp;&nbsp;&nbsp;# then consume the keystroke
''&nbsp;&nbsp;&nbsp;&nbsp;Return true
''&nbsp;&nbsp;End If
''End Sub

''@N:Button_Click(who)
''All Button Click events are vectored to a single BasicLib sub "Sub button_click(who)".

''@N:Check_CheckedChange(who, checked)
''All Checkbox CheckedChange events are vectored to a single BasicLib sub "Sub check_checkedchange(who, checked)".

''@N:Edit_EnterPressed(who)
''All EditText EnterPressed events are vectored to a single BasicLib sub "Sub edit_enterpressed(who)".

''@N:Edit_TextChanged(who, oldtext, newtext)
''All EditText TextChanged events are vectored to a single BasicLib sub "Sub edit_textchanged(who, oldtext, newtext)".

''@N:Edit_FocusChanged(who, hasfocus)
''All Edittext FocusChanged events are vectored to a single BasicLib sub "Sub edit_focuschanged(who, hasfocus)".

''@N:HSV_Changed(who, position)
''All HorizontalScrollView ScrollChanged events are vectored to a single BasicLib sub "Sub hsv_scrollchanged(who, position)".

''@N:ImageView_Click(who)
''All ImageView Click events are vectored to a single BasicLib sub "Sub imageview_click(who)".

''@N:ImageView_LongClick(who)
''All ImageView LongClick events are vectored to a single BasicLib sub "Sub imageview_longclick(who)".

''@N:Label_Click(who)
''All Label Click events are vectored to a single BasicLib sub "Sub label_click(who)".

''@N:Gnss_Status(beidou, galileo, glonass, gps)
''GNSS Status events are vectored to BasicLib sub "Gnss_Status(beidou, galileo, glonass, gps)"'

''@N:Gnss_LocationChanged(latitude, longitude, ukgridref)
''GNSS LocationChanged events are vectored to BasicLib sub "Sub Gnss_LocationChanged(latitude, longitude, ukgridref)".

''@N:Listview_ItemClick(who, position, value)
''All ListView ItemClick events are vectored to a single BasicLib sub "Sub listview_itemclick(who, position, value)".

''@N:Menu_Click(menutext)
''All menu item click events are vectored to a single BasicLib sub "Sub menu_click(menutext)".

''@N:Panel_Click(who)
''All Panel Click events are vectored to a single BasicLib sub "Sub panel_click(who)".

''@N:Radio_CheckedChange(who, checked)
''All RadioButton CheckedChange events are vectored to a single BasicLib sub "Sub radio_checkedchange(who, checked)".

''@N:ScaleImageView_Click(who, viewx, viewy, imagex, imagey)
''All ScaleImageView Click events are vectored to a single BasicLib sub "Sub scaleimageview_click(who, viewx, viewy, imagex, imagey)".

''@N:ScaleImageView_LongClick(who, viewx, viewy, imagex, imagey)
''All ScaleImageView LongClick events are vectored to a single BasicLib sub "Sub scaleimageview_longclick(who, viewx, viewy, imagex, imagey)".

''@N:Seekbar_ValueChanged(who, userchanged)
''All SeekBar ValueChanged events are vectored to a single BasicLib sub "Sub seekbar_valuechanged(who, value, userchanged)".

''@N:Sensor_Changed(who, value0, value1, value2)
''All Sensor SensorChanged events are vectored to a single BasicLib sub "Sensor_Changed(who, value0, value1, value2)".

''@N:Spinner_ItemClick(who, position, value)
''All Spinner ItemClick events are vectored to a single BasicLib sub "Sub spinner_itemclick(who, position, value)".

''@N:Tabhost_TabChanged(who)
''All TabHost TabChanged events are vectored to a single BasicLib sub "Sub tabhost_tabchanged(who)".

''@N:Table_CellClick(who, col, row)
''All Table CellClick events are vectored to a single BasicLib sub "Sub table_cellclick(who, col, row)".

''@N:Table_CellLongClick(who, col, row)
''All Table CellLongClick events are vectored to a single BasicLib sub "Sub table_celllongclick(who, col, row)".

''@N:Table_HeaderClick(who, col)
''All Table Table_HeaderClick events are vectored to a single BasicLib sub "Sub table_headerclick(who, col)".

''@N:Table_HeaderLongClick(who, col)
''All Table Table_HeaderLongClick events are vectored to a single BasicLib sub "Sub table_headerlongclick(who, col)".

''@N:Table_ScrollChanged(who, pox, posy)
''All Table ScrollChanged events are vectored to a single BasicLib sub "Sub table_scrollhanged(who, posx, posy)".

''@N:Timer_Tick
''All Timer tick events are vectored to a single BasicLib sub "Sub timer_tick".

''@N:Toggle_Changed(who, checked)
''All ToggleButton CheckedChange events are vectored to a single BasicLib sub "Sub toggle_changed(who, checked)".

''@N:Event Templates
''Here are all the event Sub templates to copy and paste if desired.
''Note that code for these events is already included in the Template.b4s file.
''
''Sub activity_pause(userclosed) 
''End Sub
''
''Sub activity_resume
''End Sub 
''
'Sub activity_keypress(keycode)
''End Sub 
''
''Sub button_click(who)
''End Sub 
''
''Sub check_checkedchange(who, checked)
''End Sub 
''
''Sub edit_enterpressed(who)
''End Sub
''
''Sub edit_textchanged(who, old, new)
''End Sub
''
''Sub edit_focuschanged(who, hasfocus)
''End Sub
''
''Sub gnss_status(beidou, galileo, glonass, gps)
''End Sub
''
''Sub gnss_locationchanged(latitude, longitude, ukgridref)
''End Sub
''
''Sub hsv_scrollchanged(who, position)
''End Sub
''
''Sub imageview_click(who)
''End Sub
''
''Sub imageview_longclick(who)
''End Sub
''
''Sub label_click(who)
''End Sub
 ''
''Sub listview_itemclick(who, pos, value)
''End Sub
''
''Sub menu_click(menutext)
''End Sub
''
''Sub panel_click(who)
''End Sub
''
''Sub radio_checkedchange(who, checked)
''End Sub 
''
''Sub scaleimageview_click(who, viewx, viewy, imagex, imagey)
''End Sub
''
''Sub scaleimageview_longclick(who, viewx, viewy, imagex, imagey)
''End Sub
''
''Sub seekbar_valuechanged(who, pos, value)
''End Sub
''
''Sub sensor_changed(who, value0, value1, value2)
''End Sub
''
''Sub spinner_itemclick(who, pos, value)
''End Sub
''
''Sub tabhost_tabchanged(who)
''End Sub 
''
''Sub Sub table_cellclick(who, col, row)
''End Sub
''
''Sub Sub table_celllongclick(who, col, row)
''End Sub 
''
''Sub Sub table_headerclick(who, col)
''End Sub 
''
''Sub Sub table_headerlongclick(who, col)
''End Sub 
''
''Sub Sub table_scrollchanged(who, posx, posy)
''End Sub 
''
''Sub timer_tick
''End Sub 
''
''Sub toggle_changed(who, checked)
''End Sub 

#End Region


#Region General System Functions

''<a name="functions"></a>
''@H:GENERAL SYSTEM FUNCTIONS


''@N:ClipboardGetText As returnvalue
''Returns True if the system clipboard conatains text.
Sub ClipboardGetText As String
	Return Clipboard.getText
End Sub

''@N:ClipboardHasText As returnvalue
''Returns any text on the system clipboard.
Sub ClipboardHasText As String
	Return Clipboard.hasText
End Sub

''@N:ClipboardSetText(text)
'Set text on the system clipboard
Sub ClipboardSetText(text As String)
	Clipboard.setText(text)
End Sub

''@N:CloseApplication
''On Android 4+ will close all the activities.
''When called in a script this will exit the application without resuming the IDE activity.
''AppClose in contrast will just close this activity and return to the Main activity.
Sub CloseApplication
Dim jo As JavaObject
jo.InitializeContext
	jo.RunMethod("finishAffinity", Null)
End Sub

''@N:IfThenElse(condition, truepart, falsepart) As returnvalue
''IfThenElse is a function that performs an If...Else...End If as a one line statement. 
''IfThenElse has 3 parts: a condition, a True part and a False part.
''The condition is evaluated, and if it evaluates true, the true part is returned, otherwise the false part is returned.
''It should not replace an If block that makes tests to ensure an error will not result. 
''This is because both True part and False part are evaluated when the function is called.
''Example:
''# instead of this...
''If a = 5 Then
''&nbsp;&nbsp;b = b + 1
''Else
''&nbsp;&nbsp;b = b - 1
''Endif
''# use this...
''b = b + IfThenElse(a = 5, 1, -1)
Sub IfThenElse(condition As String, truepart As String, falsepart As String) As String
	'condition = condition.ToLowerCase
	If condition = "true" Then
		Return truepart
	End If
	Return falsepart
End Sub

''@N:HideKeyboard
''Hides the soft keyboard.
Sub HideKeyboard
	IME.HideKeyboard
End Sub

#End Region


#Region String, Numeric and Logical functions

''<a name="strings"></a>
''@H:STRING, NUMERIC AND LOGICAL FUNCTIONS


''@N:FormatNumber(Number, MinimumIntegers, MaximumFractions) As returnvalue
''Converts the specified number to a string.
''This is an exposure of the B4A NumberFormat keyword to BAScript.
''The string will include at least MinimumIntegers and at most MaximumFractions digits.
''Example: Log(NumberFormat(12345.6789, 0, 2)) = "12345.68", Log(NumberFormat(1, 3 ,0)) = "001"
''Note there is also the B4AScript Format function that formats numbers using a Java DecimalFormat object.
Sub FormatNumber(Number As String, MinimumIntegers As String, MaximumFractions As String) As String
	Return NumberFormat(Number, MinimumIntegers, MaximumFractions)
End Sub

''@N:FormatNumber2(Number, MinimumIntegers, MaximumFractions, MinimumFractions, UseGrouping) As returnvalue
''Converts the specified number to a string.
''This is an exposure of the B4A NumberFormat2 keyword.
''The string will include at least MinimumIntegers, at most MaximumFractions and at least MinimumFractions digits.
''UseGrouping if True groups every three integers.
''Example: Log(NumberFormat2(12345.67, 0, 3, 3, False)) = "12345.670"
''Note there is also the B4AScript Format function that formats numbers using a Java DecimalFormat object.
Sub FormatNumber2(Number As String, MinimumIntegers As String, MaximumFractions As String, MinimumFractions As String, UseGrouping As String) As String
	Return NumberFormat2(Number, MinimumIntegers, MaximumFractions, MinimumFractions, UseGrouping)
End Sub

''@N:IntToBinary(intvalue) As returnvalue
''This function implements the conversion of Int32 integer values to binary literal strings.
''This is an exposure of the B4A Bit.ToBinaryString function.
Sub IntToBinary(intvalue As String) As String
	Return Bit.ToBinaryString(intvalue)
End Sub

''@N:IntToHex(intvalue) As returnvalue
''This function implements the conversion of Int32 integer values to hexadecimal literal strings.
''This is an exposure of the B4A Bit.ToHexString function.
Sub IntToHex(intvalue As String) As String
	Return Bit.ToHexString(intvalue)
End Sub

''@N:IntFromHex(hexstring) As returnvalue
''Unlike the Basic4ppc BasicLib library the B4A BasicLib library does not support Hex literals.
''This function implements the conversion of hexadecimal literal strings to Int32 values.
''Int32 is used as the basis for conversion as hex numbers are primarily used for convenient representation of ARGB colour values.
''The signed Int32 values returned from IntFromHex will round trip to double values and back.
''The formats, 'abcd', '#abcd' and '0xabcd' are accepted and all are case insensitive.
''If numstring exceeds eight characters only the rightmost eight are used in the conversion.
''ParseInt can also convert strings to integer values using a specified radix.
Sub IntFromHex(hexstring As String) As String
	hexstring = hexstring.ToLowerCase
	hexstring = hexstring.Replace("#", "").Replace("0x", "")
	Dim hexnum As Int = 0
	For i = 0 To hexstring.Length -1
		hexnum = Bit.ShiftLeft(hexnum, 4)
		hexnum = Bit.Or(hexnum, Bit.ParseInt(hexstring.CharAt(i), 16))
	Next
	Return hexnum
End Sub

''@N:ParseInt(numstring, radix) As returnvalue
''Parses numstring as an unsigned integer using the specified integer radix.
''This is an exposure of the B4A Bit.ParseInt function.
''Radix should be between 2 and 36.
''Unlike IntFromHex the resulting integer is always positive.
''A NumberFormatExeption error occurs if the resulting Int32 value would represent a negative number.
''If numstring starts with a minus chaacter the resulting integer value will be negative,
Sub ParseInt(numstring As String, radix As String) As String
	Return Bit.ParseInt(numstring, radix)
End Sub

''@N:SBAppend(text)
''Append 'text' to the end of the StringBuilder object.
Sub SBAppend(text As String)
	If TheStringBuilder.IsInitialized Then
		TheStringBuilder.Append(text)
	End If
End Sub

''@N:SBInitialize
''There is a single StringBuilder object which can be used as many times as needed.
''Initialize (or reinitialize) the StringBuilder object.
''If the StringBuilder object is already initialized, it will be reinitialized and its text reset to blank.
''StringBuilder contents persist over Activity pause and resume and when chaining programs.
Sub SBInitialize
	TheStringBuilder.Initialize
End Sub


''@N:SBInsert(offset, text)
''Insert 'text' at the offset specified, in the StringBuilder object.
Sub SBInsert(offset As String, text As String)
	If TheStringBuilder.IsInitialized Then
		TheStringBuilder.Insert(offset, text)
	End If
End Sub

''@N:SBLength As returnvalue
''Returns the length of the text in the StringBuilder object.
Sub SBLength As String
	If TheStringBuilder.IsInitialized Then
		Return TheStringBuilder.Length
	Else
		Return -1
	End If
End Sub

''@N:SBRemove(start, end)
''Remove the text starting at 'start' offset up to, but not including, the 'end' offset, of the StringBuilder object.
Sub SBRemove(startoffset As String, endoffset As String)
	If TheStringBuilder.IsInitialized Then
		TheStringBuilder.Remove(startoffset, endoffset)
	End If
End Sub

''@N:SBToString As returnvalue
''Returns the text in the StringBuilder object.
Sub SBToString As String
	If TheStringBuilder.IsInitialized Then
		Return TheStringBuilder.ToString
	Else
		Return ""
	End If
End Sub

''@N:StrTrim(string) As returnvalue
''Returns a string that has had white space trimmed from the start and end of the passed string.
''Ex. StrTrim("  123 ") returns "123"
Sub StrTrim(str As String) As String
	Return str.Trim
End Sub

''@N:ShiftLeft(intvalue, places) As returnvalue
''Shifts intvalue left by the number of places.
Sub ShiftLeft(IntValue As String, Places As String) As String
	Return Bit.ShiftLeft(IntValue, Places)
End Sub

''@N:ShiftRight(intvalue, places) As returnvalue
''Shifts intvalue right by the number of places.
Sub ShiftRight(IntValue As String, Places As String) As String
	Return Bit.ShiftRight(IntValue, Places)
End Sub

''@N:ShiftRightUnsigned(intvalue, places) As returnvalue
''Shifts intvalue right unsigned by the number of places.
Sub ShiftRightUnsigned(IntValue As String, Places As String) As String
	Return Bit.UnsignedShiftRight(IntValue, Places)
End Sub



#End Region


#Region Activity functions

''<a name="activity"></a>
''@H:ACTIVITY AND DEVICE FUNCTIONS
''
''As well as the following functions the standard view functions for the activity may be be accessed by 
'' using the pre-allocated view name 'Activity'.
''
''Each script runs in its this 'Script' activity so 'activity' and 'script' are synonymous in this help documentation.

''@N:ActivityFinish
''Closes the activity and return directly to the editor. This may sometimes be required but should be avoided.
''Calling this bypasses the normal Blib_Ended code that will display any Print output and any error message.
''Close a script without events by calling CloseAfterThis and close a script with events by AppClose.
Sub ActivityFinish
	Activity.Finish
End Sub

''@N:CanCall(subname) As returnvalue
''Returns True if Sub subname exists and can be called by the current program otherwise returns False.
Sub CanCall(subname As String) As String
	Return Blib.CanCall(subname)
End Sub

''@N:Chain(scriptname)
''Close the activity and recreate it running the new script identified by scriptname.
''If scriptname does not end with the suffix '.b4s' then Chain will add that suffix to scriptname.
''The new script is loaded from the folder specified in the ScriptDir process global variable.
''BasicIDE sets ScriptDir to File.DirRootExternal & "/BasicIDE" plus an optional project folder. 
''The Map, List, Stringbuilder and Global values saved by SaveArray/Global are preserved for the new program to use.
''GetFirstTime and GetRestarting will both be True in the new activity. 
''When testing a program that is going to be invoked by Chain ensure that the code is saved before running.
''This is because the code for a Chain invocation is loaded from the file system, not from the editor.
Sub Chain(scriptname As String)
	If Not(scriptname.ToLowerCase.EndsWith(".b4s")) Then
		scriptname = scriptname & ".b4s"
	End If		
	Dim NewProgram As String = FileReadString(ScriptDir, scriptname)
	If NewProgram.StartsWith("!ERROR!") Then
		MsgboxAsync("Program '" & scriptname & "' not found in" & CRLF & ScriptDir, "Chain Error")
		Return
	End If
	ProgramFileName = scriptname
	Program = NewProgram
	FirstRunFlag = True
	RestartActivity
End Sub

''@N:GetActivityHeight As returnvalue
''Get the actual height of the activity. This is the same value as GetHeight('Activity')
''This is not necessarily the same as the physical display height from GetLayoutValues unless the activity is full-screen.
Sub GetActivityHeight As String
	Return ah
End Sub

''@N:GetActivityWidth As returnvalue
''Get the actual width of the activity. This is the same value as GetWidth('Activity')
''This is not necessarily the same as the physical display width from GetLayoutValues unless the activity is full-screen.
Sub GetActivityWidth As String
	Return aw
End Sub

Sub IsSplitMode As Boolean
	Dim jo As JavaObject
	jo.InitializeContext
	Try
		Return jo.RunMethod("isInMultiWindowMode", Null)
	Catch
		Return False
	End Try
End Sub

Sub IsPortrait As Boolean
	Dim jo As JavaObject
	jo.InitializeContext
	jo = jo.RunMethod("getResources", Null)
	jo = jo.RunMethod("getConfiguration", Null)
	Dim i As Int = jo.GetField("orientation")
	If i = 2 Then
		Return False
	End If
	Return True
End Sub


Sub StartActivityAlongSide(act As Object)
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	Dim jin As JavaObject
	Dim in As Intent = jin.InitializeNewInstance("android.content.Intent", Array(ctxt, act))
	'add flags here
	' Manifest must target API 29 if both activities are to be focussed - and its a bit useless if that aren't
	in.Flags = in.Flags + 0x00001000 +  0x10000000 ' FLAG_ACTIVITY_LAUNCH_ADJACENT + FLAG_ACTIVITY_NEW_TASK
	StartActivity(in)
End Sub

''@N:CloseAfterThis
''Closes the activity and returns directly to the editor. This may be required by a Non-UI script.
''Calling this bypasses the normal Blib_Ended code that will display any Print output and any error message.
''Close a script without events by calling CloseAfterThis and close a script with events by AppClose.
Sub CloseAfterThis
	starting = False
End Sub

''@N:CloseMenu
''Closes the Activity menu. This is added for symmetry with OpenMenu but seems of little practical use.
Sub CloseMenu
	Activity.CloseMenu
End Sub

''@N:GetAllViews(arrayname)
''Returns the names of all the current views in the named array.
''The array does not need to be declared with Dim, if it does not already exist it will be created.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub GetAllViews(arrayname As String)
	Dim arrViews(ViewMap.Size) As String
  Dim i As Int = 0
	For Each k As String In ViewMap.keys
		arrViews(i) = k
		i = i + 1
	Next
	Blib.ShareArray(arrayname, arrViews)	
End Sub

''@N:GetFirstTime As returnvalue
''GetFirstTime is usually used by the initial code block for this script that is run whenever the Script activity is created.
''GetFirstTime is almost the equivalent of the parameter FirstTime in Activity_Create for B4A.
''B4A FirstTime cannot be used as it is only True for the first invocation of the Script activity by the IDE.
''Thereafter whenever the IDE restarts a script after editing it B4A FirstTime will be always be False.
''GetFirstTime is set True when the IDE starts a script or when a running script Chains to another script.
''GetFirstTime is set to False after the next Activity_Resume completes so is True in the Resume event.
''If GetFirstTime is False then the activity has been recreated after a device rotation or for some other reason.
''If GetRestarting is False then this script is the invocation of the first script of a program by the IDE.
''Future invocations of this script by chaining from another will have both GetFirstTime and GetRestarting set True.
Sub GetFirstTime As String
	Return FirstRunFlag
End Sub

''@N:GetLayoutValues As returnvalue
''Get the layout values for this device in a comma separated string "width, height, scale".
''The "width and height values seem unhelpful as they do not reflect either the physical screen nor the activity size.
''The scale value is the device scale value of ScreenDpi/160. This is the value also returned by GetScreenScale
''Using the GetWidth and GetHeight activity values seems much more useful to a program when placing views.
Sub GetLayoutValues As String
	Dim l As LayoutValues
	l = GetDeviceLayoutValues
	Return l.Width & "," & l.Height & "," & l.Scale
End Sub

''@N:GetOrientation As returnvalue
''Returns the orientation of the device as either 'Portrait' or 'Landscape'.
Sub GetOrientation As String
	Return activityorientation
End Sub

''@N:GetRestarting As returnvalue
''Returns True if this script is being restarted because the script called RestartActivity.
''It is also True if this script called Chain to start another script.
''This is set to False after the next Activity_Resume completes so is True in the next Pause event.
''It will also be True when the next intial code block of either the restarted or the chained script runs.
''If the script was started by being chained from another GetFirstTime is also True.
''Thereafter re-creations of this script will find this is False.
Sub GetRestarting As String
	Return Restarting
End Sub

''@N:GetScreenScale As returnvalue
''Get the scaling value (density) for this device which is ScreenDpi/160.
Sub GetScreenScale As String
	Return GetDeviceLayoutValues.Scale
End Sub

''@N:OpenMenu
''Opens the Activity menu.
Sub OpenMenu
	Activity.OpenMenu
End Sub

''@N:ResetState(stateid)
''Remove the stored state of the views of the activity identified by stateid.
' stateid is an arbitrary name that should uniquely identify the Activity whose state is saved.
''RestoreState(stateid) will now return False as no state is now saved.
Sub ResetState(stateid As String)
	StateManager.ResetState(stateid)
End Sub

''@N:RestartActivity
''This closes and restarts the Activity so Activity_Create will run again.
''Note that Pause is now called with UserClosed in the Pause event set True.
''GetRestarting can be used to determine if the activity was restarted.
''GetRestarting is set to False after the next Activity_Resume completes so is True in the Pause and Resume events.
Sub RestartActivity
	Restarting = True
Activity.Finish
	If Alongside Then
		StartActivityAlongSide(Me)
	Else
		StartActivity(Me)
	End If	
End Sub

''@N:RestoreState(stateid, timeout) As returnvalue
''Restore the saved state of the views of the activity identified by stateid.
''stateid is an arbitrary name that should uniquely identify the Activity whose state was saved.
''Returns True if the view states are restored otherwise returns False.
''If the last save was longer ago than timeout then don't restore.
''Pass 0 for an unlimited timeout period.
Sub RestoreState(stateid As String, timeout As String) As String
	Return StateManager.RestoreState(Activity, stateid, timeout)
End Sub

''@N:SaveState(stateid)
''Save the state of the views of the current activity with the saved state identified by stateid.
''stateid is an arbitrary name that should uniquely identify the Activity whose state is saved.
''This eases the problem of saving and restoring the state of views when the device is rotated.
Sub SaveState(stateid As String)
	StateManager.SaveState(Activity, stateid)
End Sub

''@N:SetActivityBackground(orientation, radius, colorsarrayname) As returnvalue
''Set the Background property of the Activity to the GradientDrawable.
''Returns false if less than two colors are in the array otherwise returns true.
''Orientation can be one of the following:
''"TOP_BOTTOM", "TR_BL" (Top-Right to Bottom-Left), "RIGHT_LEFT", "BR_TL" (Bottom-Right to Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left to Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left to Bottom-Right)
Sub SetActivityBackground(Orientation As String, radius As String, colorsarrayname As String) As String
	Dim cols(0) As String
	Dim G As GradientDrawable
	cols = BlibGetArray(colorsarrayname)
	If cols.Length >= 2 Then
		Dim colints(cols.Length) As Int
		For I = 0 To cols.Length - 1
			colints(I) = cols(I)
		Next
		G.Initialize(Orientation, colints)
		G.CornerRadius = radius
		Activity.Background = G
		Return True
	End If
	Return False
End Sub

''@N:SetActivityTitle(title)
''Sets the activity title text in the activity's title label.
Sub SetActivityTitle(title As String)
	Activity.title = title
End Sub

''@N:SetOrientation(orientation)
''Sets the available orientations of the screen for this activity.
''Orientation is -1 = unspecified, 0 = Landscape, 1 = Portrait.
Sub SetOrientation(orientation As String)
	ThePhone.SetScreenOrientation(orientation)
End Sub

#End Region


#Region Array Functions

''<a name="array"></a>
''@H:ARRAY FUNCTIONS

''@N:FillArray(arrayname, start, length, value)
''Fully or partially fills the specified array with the specified value.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub FillArray(arrayname As String, start As String, len As String, value As String)
	Dim ia(0) As String
	ia = BlibGetArray(arrayname)
	arraysX.Fill(ia, start, len, value)
	Blib.ShareArray(arrayname, ia)
End Sub

''@N:SearchArray(arrayname, value) As returnvalue
''Searches the specified array for the specified value using the binary search algorithm.
''The array must be sorted into ascending order using cCaseSensitive or cNumbers otherwise the result may not be accurate.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub SearchArray(arrayname As String, value As String) As String
	Dim ia(0), res As String
	ia = BlibGetArray(arrayname)
	res = arraysX.BinarySearch(ia, value)
	Return res
End Sub

''@N:SortArray(arrayname, sorttype)
''Sort the specified array into ascending order in the specified manner. 
''One of cCaseSensitive (0), cCaseUnensitive (1) or cNumbers (2).
''cCaseInsensitive is also accepted as a synonym for cCaseUnensitive.
''Note that for use with SearchArray cCaseSensitive or cNumbers should be used otherwise the result may not be accurate.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub SortArray(arrayname As String, sorttype As String)
	Dim ia(0) As String
	ia = BlibGetArray(arrayname)
	arraysX.SortStringArray(ia, sorttype)
	Blib.ShareArray(arrayname, ia)
End Sub


''@N:SortArrays2(sortarrayname, otherarrayname, sorttype)
''Sort the first specified array into ascending order in the specified manner. 
''One of cCaseSensitive (0), cCaseUnensitive (1) or  cNumbers (2).
''cCaseInsensitive is also accepted as a synonym for cCaseUnsensitive.''
''The  second array will be kept 'in step' with the first by similarly reordering its contents.
''One obvious use for this is to sort the keys array of a MapToArrays while keeping the values array in step.
''Note that for use of the sorted array with SearchArray cCaseSensitive or cNumbers should be used otherwise the result may not be accurate.
''A common mistake is to try to use a reference to an array, arrayname is the name of the array as a String.
Sub SortArrays2(sortarrayname As String, otherarrayname As String, sorttype As String)
	Dim sorted(0) As String
	sorted = BlibGetArray(sortarrayname)
	Dim other(0) As String
	other = BlibGetArray(otherarrayname)		
	Dim l As List
	l.Initialize
	' if we are sorting numbers
	If  sorttype = cNumbers Then
		For i = 0 To sorted.Length - 1
			Dim tn As TypeNumString
			tn.Initialize
			tn.sortvalue = sorted(i)
			tn.othervalue = other(i)
			l.Add(tn)		
		Next
		l.SortType("sortvalue", True)
		For i = 0 To sorted.Length - 1
			tn = l.Get(i)
			sorted(i) = tn.sortvalue
			other(i) = tn.othervalue
		Next
	Else
		'we are sorting strings
		For i = 0 To sorted.Length - 1
			Dim ts As TypeStringString
			ts.Initialize
			ts.sortvalue = sorted(i)
			ts.othervalue = other(i)
			l.Add(ts)
		Next
		If sorttype = cCaseInsensitive Then
			l.SortTypeCaseInsensitive("sortvalue", True)
		Else
			l.SortType("sortvalue", True)
		End If
		For i = 0 To sorted.Length - 1
			ts = l.Get(i)
			sorted(i) = ts.sortvalue
			other(i) = ts.othervalue
		Next
	End If		
	Blib.ShareArray(sortarrayname, sorted)
	Blib.ShareArray(otherarrayname, other)
End Sub

'cCaseSensitive (0) and cCaseUnsensitive (1) are defined in B4Script, cNumbers is not.
Sub cNumbers As String
	Return 2
End Sub

'cCaseUnsensitive was an original Erel typo that got stuck in Basic4ppc. 
'This is the same value with a more English name.
Sub cCaseInsensitive As String
	Return 1
End Sub

#End Region


#Region Collection & Persistence Functions

''<a name="collections"></a>
''@H:COLLECTION & PERSISTENCE FUNCTIONS
''
''There is a single Map object which contains key value pairs and can be indexed in insertion order.
''Map key lookups are case-sensitive.
''Map contents persist over Activity pause and resume and when chaining programs.
''
''There is a single List object which can grow or shrink in size according to the number of items.
''List contents persist over Activity pause and resume and when chaining programs.
''
''This section includes functions for persisting values over Activity recreation.
''The Activity Functions section has methods for persisting the state of views over Activity recreation.


''@N:ListAdd(item)
''Add the item to the List.
Sub ListAdd(item As String)
	TheList.Add(item)
End Sub

''@N:ListClear
''Clears the contents of the List.
Sub ListClear
	TheList.Clear''@N:ListClear
End Sub

''@N:ListFromArray(arrayname)
''Sets the List to the contents of the named array.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub ListFromArray(arrayname As String)
	Dim strarray() As String = BlibGetArray(arrayname)
	TheList	= strarray
End Sub

''@N:ListGet(index) As returnvalue
''Get the item at index in the List.
Sub ListGet(index As String) As String
	Return TheList.Get(index)
End Sub

''@N:ListInsertAt(index, item)
''Inserts the item into the list at index.
Sub ListInsertAt(index As String, item As String)
	TheList.InsertAt(index, item)
End Sub

''@N:ListRemoveAt(index)
''Removes the item at index from the List.
Sub ListRemoveAt(index As String)
	TheList.RemoveAt(index)
End Sub
	
''@N:ListSize As returnvalue
''Returns the number of items in the List.
Sub ListSize As String
	Return TheList.Size
End Sub

''@N:ListSort(ascending)
''Case-sensitively sorts the items in the List, in ascending order if ascending is True.
Sub ListSort(ascending As String)
	TheList.Sort(ascending)
End Sub

''@N:ListSortCaseInsensitive(ascending)
''Case-insensitively sorts the items in the List, in ascending order if ascending is True.
Sub ListSortCaseInsensitive(ascending As String)
	TheList.SortCaseInsensitive(ascending)
End Sub

''@N:ListToArray(arrayname)
''Sets the contents of the named array to those of the List.
''The array does not need to be declared with Dim, if it does not already exist it will be created.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub ListToArray(arrayname As String)
	Dim arrArgs(TheList.Size) As String
	For i = 0 To arrArgs.Length - 1
		arrArgs(i) = TheList.Get(i)
	Next
	Blib.ShareArray(arrayname, arrArgs)
End Sub

''@N:MapClear
''Clears the contents of the Map
Sub MapClear
	TheMap.Clear
End Sub

''@N:MapFromArrays(keysarrrayname, valuesarrayname)
''Clear the Map then set it to the keys and values in the named arrays
Sub MapFromArrays(keys As String, values As String)
	Dim keysarray() As String = BlibGetArray(keys)
	Dim valsarray() As String = BlibGetArray(values)
	TheMap.Clear
	For i = 0 To keysarray.Length - 1
		TheMap.Put(keysarray(i), valsarray(i))
	Next
End Sub

''@N:MapGet(key) As returnvalue
''Get the value at the key/value item  in the Map or an empty string if the key is not present.
Sub MapGet(key As String) As String
	Dim val As Object
	val = TheMap.Get(key)
	If val = Null Then Return ""
	Return val
End Sub

''@N:MapKeyAt(index) As returnvalue
''Returns the key of the item at index or an empty string if the item is not present.
''The index values organise the items in order of insertion.
Sub MapKeyAt(index As String) As String
	Dim key As Object
	key = TheMap.GetKeyAt(index)
	If key = Null Then Return ""
	Return key
End Sub	

''@N:MapPut(key, value)
''Puts the key and value as an item into the Map.
Sub MapPut(key As String, value As String)
	TheMap.Put(key, value)		
End Sub

''@N:MapSize As returnvalue
''Returns the number of items in the Map.
Sub MapSize As String
	Return TheMap.Size
End Sub

''@N:MapToArrays(keysarrrayname, valuesarrayname)
''Set the keys and values arrays to the contents of the Map.
''The arrays do not need to be declared with Dim, if they do not already exist they will be created.
Sub MapToArrays(keys As String, values As String)
	Dim keysarray(TheMap.Size) As String
	Dim valsarray(TheMap.Size) As String
	For i = 0 To TheMap.Size - 1
		keysarray(i) = TheMap.GetKeyAt(i)
		valsarray(i) = TheMap.GetValueAt(i)
	Next
	Blib.ShareArray(keys, keysarray)
	Blib.ShareArray(values, valsarray)
End Sub

''@N: MapValueAt(index) As returnvalue
''Returns the value of the item at index or an empty string if the item is not present.
''The index values organise the items in order of insertion.
Sub MapValueAt(index As String) As String
	Dim val As Object
	val = TheMap.GetValueAt(index)
	If val = Null Then Return ""
	Return val
End Sub

''@N:RestoreArray(arrayname)
''Restore the saved contents of the named array.
''This can used to persist program values during Activity pause and resume and when chaining programs.
''The array does not need to be declared with Dim, if it does not already exist it will be created.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub RestoreArray(arrayname As String)
	arrayname = arrayname.ToLowerCase
	Blib.ShareArray(arrayname, GlobalVarsMap.Get(arrayname))
End Sub

''@N:RestoreGlobal(globalname)
''Restore the saved contents of the named global variable.
''This can used to persist program values during Activity pause and resume and when chaining programs.
''A common mistake is to try to use a reference to the variable, globalname is the name of the variable as a String.
Sub RestoreGlobal(globalname As String)
	globalname = globalname.ToLowerCase
	Blib.SetGlobal(globalname, GlobalVarsMap.Get(globalname))
End Sub

''@N:RestoreValue(valuename) As returnvalue
''Returns the saved contents of the named value.
''This can used to persist values during Activity pause and resume and when chaining programs.
''This uses the same mechanism as RestoreGlobal so care should be taken to avoid a name clash with a Global variable.
''If the named value does not exist then the string 'null' is returnd.
Sub RestoreValue(valuename As String) As String
	valuename = valuename.ToLowerCase
	Return GlobalVarsMap.Get(valuename)
End Sub

''@N:SaveArray(arrayname)
''Save the contents of the named array so it can be restored on activity re-creation or whenever required.
''All the program arrays and global variables are reset when the first code block is run again to recreate the views.
''This can used to persist program values during Activity pause and resume and when chaining programs.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
Sub SaveArray(arrayname As String)
	arrayname = arrayname.ToLowerCase
	GlobalVarsMap.Put(arrayname, BlibGetArray(arrayname))
End Sub

''@N:SaveGlobal(globalname)
''Save the contents of the named global variable so it can be restored on activity re-creation or whenever required.
''All the program arrays and global variables are reset when the first code block is run again to recreate the views.
''This can used to persist program values during Activity pause and resume and when chaining programs.
''A common mistake is to try to use a reference to the variable, globalname is the name of the variable as a String.
Sub SaveGlobal(globalname As String)
	globalname = globalname.ToLowerCase
	GlobalVarsMap.Put(globalname, Blib.GetGlobal(globalname))
End Sub

''@N:SaveValue(valuename, value)
''Save the the named value so it can be restored on activity re-creation or whenever required.
''This can used to persist values during Activity pause and resume and when chaining programs.
''This uses the same mechanism as SaveGlobal so care should be taken to avoid a name clash with a Global variable.
Sub SaveValue(valuename As String, value As String)
	valuename = valuename.ToLowerCase
	GlobalVarsMap.Put(valuename, value)
End Sub

#End Region


#Region File functions
''<a name="file"></a>
''@H:FILE FUNCTIONS

''@N:FileCopy(sourcedir, sourcefilename, destdir, destfilename) As returnvalue
''Copies the SourceFilename file in the SourceDir directory to the DestFilename directory and sets the name to DestFilename.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Sub FileCopy(sourcedir As String, sourcefname As String, destdir As String, destfname As String) As String
	Try
		File.Copy(sourcedir, sourcefname, destdir, destfname)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileDelete(dir, filename) As returnvalue
''Deletes the specified file. If the file name is a directory then it must be empty in order to be deleted.
''Returns true if the file was successfully deleted otherwise False.
''Files in the assets folder cannot be deleted.
''If an exception was raised the exception message is returned instead of True or False
Sub FileDelete(dir As String, filename As String) As String
	Try
		Return File.Delete(dir, filename)
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileDirAssets As returnvalue
''Returns a reference to the files added with the Files Manager. These files are read-only.
''This is actually the string "AssetsDir" which B4A OpenInput(Dir, String) treats specially as a Dir parameter.
''This is why FileGetPath does not support FileDirAssets as it then lacks the unique name that OpenInput looks for.
Sub FileDirAssets As String
	Return File.DirAssets
End Sub

''@N:FileDirDefaultExternal As returnvalue
''Returns the application default external folder which is based on the package name.
''The folder is created if needed.
Sub FileDirDefaultExternal As String
	Return File.DirDefaultExternal
End Sub

''@N:FileDirInternal As returnvalue
''Returns the internal private storage folder.
''FileSafeDirDefaultExternal is a better alternative.
Sub FileDirInternal As String
	Return File.DirInternal
End Sub

''@N:FileDirInternalCache As returnvalue
''Returns the internal private storage cache folder.
''This data will be deleted automatically if the device runs low on storage.
Sub FileDirInternalCache As String
	Return File.DirInternalCache
End Sub

''@N:FileDirRootExternal As returnvalue
''Returns the root folder of the external storage media.
''Apps targetting API 29+ will not get permission to access FileDirRootExternal, even with the STORAGE permission.
''BasicIDE currently target API 28 for this reason
Sub FileDirRootExternal As String
	Return File.DirRootExternal
End Sub

''@N:FileExists(dir, filename) As returnvalue
''Returns true if the specified FileName exists in the specified folder.
''Note that the Android file system is case sensitive.
Sub FileExists(dir As String, filename As String) As String
	Return File.Exists(dir, filename)
End Sub

''@N:FileExternalWritable As returnvalue
''Tests the external media, or SDCard (some devices call this Internal Storage), for readibility and writability.
''Returns True if the storage can be written and read otherwise False.
Sub FileExternalWritable As String
	Return File.ExternalWritable
End Sub

''@N:FileGetPath(dir, filename) As returnvalue
''Returns the fully qualified pathname of the filename. This does not support the Assets directory.
Sub FileGetPath(dir As String, filename As String) As String
	If dir <> FileDirAssets Then
		Return File.Combine(dir, filename)
	End If
	Return ""
End Sub

''@N:FileIsDirectory(dir, filename) As returnvalue
''Tests whether the specified file is a directory.
Sub FileIsDirectory(dir As String, filename As String) As String
	Return File.IsDirectory(dir, filename)
End Sub

''@N:FileListFiles(dir, filesarrayname) As returnvalue
''Fills an array with a list with all the files and directories which are stored in the specified path.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
''The array does not need to be declared with Dim, if it does not already exist it will be created.
Sub FileListFiles(dir As String, filesarrayname As String) As String
	Try
		Dim l As List
		l = File.ListFiles(dir)
		Dim Arr(l.Size) As String
		For I = 0 To Arr.Length - 1
			Arr(I) = l.Get(I)
		Next
		Blib.ShareArray(filesarrayname, Arr)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileMakeDir(parentdir, dir) As returnvalue
''Creates the given folder (dir can be a path like "dir1/dir2", it creates all folders as needed).
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Sub FileMakeDir(parentdir As String, dir As String) As String
	Try
		File.MakeDir(parentdir, dir)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileReadList(dir, filename, listarrayname) As returnvalue
''Reads the entire file and fills a named array with all lines as strings.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
''The array does not need to be declared with Dim, if it does not already exist it will be created.
Sub FileReadList(dir As String, fileName As String, listarrayname As String) As String
	Try
		Dim l As List
		l = File.ReadList(dir, fileName)
		Dim A(l.Size) As String
		For I = 0 To A.Length - 1
			A(I) = l.Get(I)
		Next
		Blib.ShareArray(listarrayname, A)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileReadString(dir, filename) As returnvalue
''Reads the entire file and returns it as a string if successful.
''Otherwise returns the exception message of the exception that was raised prefixed by !ERROR!.
Sub FileReadString(dir As String, fileName As String) As String
	Try
		Return File.ReadString(dir, fileName)
	Catch
		Return "!ERROR! : " & LastException.Message
	End Try
End Sub

''@N:FileRename(dir, oldfilename, newfilename) As returnvalue
''Renames the old filename to the new filename.
''Note that this method uses the B4A File.Copy and File.Delete methods internally.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Sub FileRename(dir As String, oldfname As String, newfname As String) As String
	Try
		File.Copy(dir, oldfname, dir, newfname)
		File.Delete(dir, oldfname)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileWriteList(dir, filename, listarrayname) As returnvalue
''Writes each item in the List as a single line to a  new file.
''Note that a value containing CRLF will be saved as two lines which will return two items when read with ReadList.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Sub FileWriteList(dir As String, filename As String, listarrayname As String) As String
	Try
		Dim A(0) As String
		A = BlibGetArray(listarrayname)
		File.WriteList(dir, filename, A)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileWriteString(dir, filename, text) As returnvalue
''Writes the given text to a new file.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Sub FileWriteString(dir As String, filename As String, Text As String) As String
	Try
		File.WriteString(dir, filename, Text)
		Return ""
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:FileSafeDirDefaultExternal(subfolder) As returnvalue
''Returns the path To the app's default folder on the secondary storage device.
''The path to File.DirInternal will be returned if there is no secondary storage available.
''This is a better alternative to File.DirDefaultExternal as it requires no permission.
''SubFolder is the name of sub folder that will be created for your app. Pass an empty string if not needed.
Sub FileSafeDirDefaultExternal(subfolder As String) As String
	Dim rp As RuntimePermissions
	Return rp.GetSafeDirDefaultExternal(subfolder)
End Sub

#End Region 


#Region GNSS functions
''<a name="gnss"></a>
''@H:GNSS FUNCTIONS
''
''The GNSS is automatically disabled on activity pause and, if it was running when paused, re-enabled on activity resume.
''There are two events raised by the GNSS when running, Status and locationChanged.
''
''GNSS LocationChanged events call Sub Gnss_LocationChanged(latitude, longitude, ukgridref).
''Latitude and longitude are WGS84 coordinates and ukgridref is a 5 digit UK National Grid code with 1m resolution.
''
''GNSS Status events call script Sub Gnss_Status(beidou, galileo, glonass, gps).
''Each Gnss_Status parameter is a string in the format 'numberused/numbervisible'.
''This event, even if not passed to a script event, creates a list of satellites visible and their status.
''GNSSSats returns the length of this list and GNSSSatAt returns a comma separated string of satellite data.
''This list of satellites is sorted by PRN so the satelites of each constellation are contiguous.
''The list can be accessed using GNSSSats to determine the length and GNSSSatAt to access the data by index/
''The satellites are also added to a map with the prn as the key and the satellite data as the value.
''The map can be accessed using GNSSSatPrn to specify the required satellite data. An empty string will be returned for an invalid prn.
''Galileo PRNs have 300 added and are in the range 301 to 326.
''Beidou PRNs have 200 added and are in the range 201 to 237.
''Glonass FCNs/OSNs have 64 added and are in the range 65 to 88 or possibly 157 to 172.
''GPS PRNs are unadjusted and are in the range 1 to 32.
''The list is fully updated before the Gnss_Status event Sub is invoked.
''It can be accessed from anywhere and at any time.

''@N:GNSSAccuracy As returnvalue
''Returns the accuracy of the GNSS fix.
Sub GNSSAccuracy As String
	Return GPSLocation.Accuracy
End Sub

''@N:GNSSAltitude As returnvalue
''Returns the altitude of the GNSS fix.
Sub GNSSAltitude As String
	Return GPSLocation.Altitude
End Sub


''@N:GNSSAvailable As returnvalue
''Returns True if GNSS is available on the device and the user has permitted its use.
Sub GNSSAvailable As String
	Return GNSSAvailable
End Sub

''@N:GNSSRunning As returnvalue
''Returns True if GNSS is presently enabled and running.
Sub GNSSRunning As String
	Return GpsStarted
End Sub

''@N:GNSSSats As returnvalue
''Returns the number of satellites for which information is available.
''The satellite information is held in a list sorted by unadjusted Prn.
''Each satellite in the list can be accessed using GNSSSatAt.
Sub GNSSSats As String
	Return GNSSSatsList.Size
End Sub

''@N:GNSSSatAt(index) As returnvalue
''Returns the information for the satellite at index in the list of available satellites.
''Returns a comma separated string containing 'Prn,Azimuth,Elevation,UsedInFix,Snr' for the satellite.
''Curiously despite being declared as Float the azimuth and elevation appear to be integer values.
Sub GNSSSatAt(index As String) As String
	Dim sat As GNSSSatType = GNSSSatsList.Get(index)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(sat.Prn).Append(",")
	sb.Append(sat.Azimuth).Append(",")
	sb.Append(sat.Elevation).Append(",")
	sb.Append(sat.UsedInFix).Append(",")
	sb.Append(sat.Snr)	
	Return sb.ToString
End Sub

''@N:GNSSSatPrn(prn) As returnvalue
''Returns the information for the satellite with the secified Prn from the map built by the Gnss_Status event.
''The prn should be adjusted for constellation as described above.
''Returns a comma separated string containing 'Prn,Azimuth,Elevation,UsedInFix,Snr' for the satellite.
''If the prn does not exit in the map an empty string is returned.
''Curiously despite being declared as Float the azimuth and elevation appear to be integer values.
Sub GNSSSatPrn(prn As String) As String
	Dim sat As GNSSSatType = GNSSSatsMap.Get(prn)
	If sat = Null Then Return ""
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(sat.Prn).Append(",")
	sb.Append(sat.Azimuth).Append(",")
	sb.Append(sat.Elevation).Append(",")
	sb.Append(sat.UsedInFix).Append(",")
	sb.Append(sat.Snr)	
	Return sb.ToString	
End Sub


''@N:GNSSSatsVisible(constellation) As returnvalue
''Return a comma separated string of the adjusted PRNs of the satellites visible in the constellation.
''Prns used in the fix will be suffixed by an asterisk.
''Galileo is 3 : Beidou is 2 : Glonass is 1 : GPS is 0
Sub GNSSSatsVisible(constellation As String) As String
	Select constellation
		Case "0"
			Return Gpsats
		Case "1"
			Return Glsats
		Case "2"
			Return Bdsats
		Case "3"
			Return Gasats
	End Select
	Return ""
End Sub

''@N:StartGNSS
''Start the GNSS.
Public Sub StartGNSS
	If GpsStarted = False Then
		GPS.Start(0, 0)
		GpsStarted = True
	End If
End Sub

''@N:StopGNSS
''Stop the GNSS.
Public Sub StopGNSS
	If GpsStarted Then
		GPS.Stop
		GpsStarted = False
	End If
End Sub

''@N:These constants return the values needed for the GNSSSatsVisible functions
''They may be used instead of hard coding numeric values.
''
''@GnssGalileo = 3
''@GnssBeidou = 2
''@GnssGlonass = 1
''@GnssGPS = 0

Sub GnssBeidou As String
	Return 2
End Sub

Sub GnssGalileo As String
	Return 3
End Sub

Sub GnssGlonass As String
	Return 1
End Sub

Sub GnssGPS As String
	Return 0
End Sub

Public Sub CreateGNSSSatType (Prn As Int, Azimuth As Float, Elevation As Float, UsedInFix As Boolean, Snr As Float) As GNSSSatType
	Dim t1 As GNSSSatType
	t1.Initialize
	t1.Prn = Prn
	t1.Azimuth = Azimuth
	t1.Elevation = Elevation
	t1.UsedInFix = UsedInFix
	t1.Snr = Snr
	Return t1
End Sub

'Sub GPS_GpsStatus(Satellites As List)
'	GPSSatellites = Satellites ' save it for possible further processing
'	Dim Bd, Bdused, Ga, GaUsed, Gl, GlUsed, Gp, GpUsed As Int
'	Bdsats = "" : Gasats = "" : Glsats = "" : Gpsats = ""
'	GNSSSatsList.Clear
'	For i = 0 To GPSSatellites.Size - 1
'		Dim Satellite As GPSSatellite = GPSSatellites.Get(i)
'		Dim sat As GNSSSatType = CreateGNSSSatType(Satellite.Prn, Satellite.Azimuth, Satellite.Elevation, Satellite.UsedInFix, Satellite.Snr)
'		GNSSSatsList.Add(sat)
'		Dim Prn As Int = Satellite.Prn
'		If Prn > 300 Then 'Galileo
'			Ga = Ga + 1
'			Gasats = Gasats & Prn
'			If Satellite.UsedInFix Then
'				 GaUsed = GaUsed + 1
'				 Gasats = Gasats & "*"
'			End If
'			Gasats = Gasats & ","			
'		Else If Prn > 200 Then ' Beidou
'			Bd = Bd + 1
'			Bdsats = Bdsats & Prn
'			If Satellite.UsedInFix Then
'				Bdused = Bdused + 1
'				Bdsats = Bdsats & "*"				
'			End If
'			Bdsats = Bdsats & ","			
'		Else If Prn > 64 Then ' Glonass
'			Gl = Gl + 1
'			Glsats = Glsats & Prn
'			If Satellite.UsedInFix Then
'				GlUsed = GlUsed + 1
'				Glsats = Glsats & "*"
'			End If
'			Glsats = Glsats & ","
'		Else ' GPS
'			Gp = Gp + 1
'			Gpsats = Gpsats & Prn
'			If Satellite.UsedInFix Then
'				GpUsed = GpUsed + 1
'				Gpsats = Gpsats & "*"				
'			End If
'			Gpsats = Gpsats & ","
'		End If
'	Next
'	GNSSSatsList.SortType("Prn", True)
'	If Bdsats.Length > 1 Then Bdsats = Bdsats.SubString2(0, Bdsats.Length - 1)
'	If Gasats.Length > 1 Then Gasats = Gasats.SubString2(0, Gasats.Length - 1)
'	If Glsats.Length > 1 Then Glsats = Glsats.SubString2(0, Glsats.Length - 1)
'	If Gpsats.Length > 1 Then Gpsats = Gpsats.SubString2(0, Gpsats.Length - 1)
'	If Blib.CanCall("Gnss_Status") Then ' check if the Sub exists
'		Dim params(4) As String
'		params(0) = Bdused & "/" & Bd
'		params(1) = GaUsed & "/" & Ga
'		params(2) = GlUsed & "/" & Gl
'		params(3) = GpUsed & "/" & Gp
'		Blib.Call("Gnss_Status", params)
'	End If
'End Sub


Sub GPS_GnssStatus (SatelliteInfo As GnssStatus) ' Only raised for API 24 and later devices.
	Dim Bd, Bdused, Ga, GaUsed, Gl, GlUsed, Gp, GpUsed As Int
	Bdsats = "" : Gasats = "" : Glsats = "" : Gpsats = ""
	GNSSSatsList.Clear
	GNSSSatsMap.Clear
	For i = 0 To SatelliteInfo.SatelliteCount - 1
		Dim sat As GNSSSatType = CreateGNSSSatType(SatelliteInfo.Svid(i), SatelliteInfo.Azimuth(i), SatelliteInfo.Elevation(i), _
			SatelliteInfo.UsedInFix(i),  SatelliteInfo.Cn0DbHz(i))
		GNSSSatsList.Add(sat)
		Dim Cons As Int = SatelliteInfo.ConstellationType(i)
		If Cons = SatelliteInfo.CONSTELLATION_GALILEO Then 'Galileo
			sat.Prn = sat.Prn + 300
			Ga = Ga + 1
			Gasats = Gasats & sat.Prn
			If sat.UsedInFix Then
				GaUsed = GaUsed + 1
				Gasats = Gasats & "*"
			End If
			Gasats = Gasats & ","
		Else If Cons = SatelliteInfo.CONSTELLATION_BEIDOU Then ' Beidou
			sat.Prn = sat.Prn + 200
			Bd = Bd + 1
			Bdsats = Bdsats & sat.Prn
			If sat.UsedInFix Then
				Bdused = Bdused + 1
				Bdsats = Bdsats & "*"
			End If
			Bdsats = Bdsats & ","
		Else If Cons = SatelliteInfo.CONSTELLATION_GLONASS Then ' Glonass
			sat.Prn = sat.Prn + 64
			Gl = Gl + 1
			Glsats = Glsats & sat.Prn
			If sat.UsedInFix Then
				GlUsed = GlUsed + 1
				Glsats = Glsats & "*"
			End If
			Glsats = Glsats & ","
		Else ' GPS
			Gp = Gp + 1
			Gpsats = Gpsats & sat.Prn
			If sat.UsedInFix Then
				GpUsed = GpUsed + 1
				Gpsats = Gpsats & "*"
			End If
			Gpsats = Gpsats & ","
		End If
		GNSSSatsMap.Put(sat.Prn, sat)
	Next
	GNSSSatsList.SortType("Prn", True)
	If Bdsats.Length > 1 Then Bdsats = Bdsats.SubString2(0, Bdsats.Length - 1)
	If Gasats.Length > 1 Then Gasats = Gasats.SubString2(0, Gasats.Length - 1)
	If Glsats.Length > 1 Then Glsats = Glsats.SubString2(0, Glsats.Length - 1)
	If Gpsats.Length > 1 Then Gpsats = Gpsats.SubString2(0, Gpsats.Length - 1)
	If Blib.CanCall("Gnss_Status") Then ' check if the Sub exists
		Dim params(4) As String
		params(0) = Bdused & "/" & Bd
		params(1) = GaUsed & "/" & Ga
		params(2) = GlUsed & "/" & Gl
		params(3) = GpUsed & "/" & Gp
		Blib.Call("Gnss_Status", params)
	End If
End Sub


Sub GPS_LocationChanged(Location1 As Location)
	GPSLocation = Location1  ' save it for possible further processing
	Dim Latitude, Longitude As Double
	Latitude = Location1.Latitude
	Longitude = Location1.Longitude
	OSGB.WGS84toOSGB36(Latitude, Longitude, 0)
	Dim GridRef As String = OSGB.OSGB36toNGR(OSGB.NewLatitude, OSGB.NewLongitude)
	If Blib.CanCall("Gnss_LocationChanged") Then ' check if the Sub exists
		Dim params(4) As String
		params(0) = Latitude
		params(1) = Longitude
		params(2) = GridRef
		Blib.Call("Gnss_LocationChanged", params)
	End If
End Sub

#End Region


#Region GPStoOSGB functions

''@N:NEtoNGR(easting, northing) As returnvalue
''Converts a Northing and Easting To a 5 digit National Grid Reference.
''Doesn't change any transformation properties.
''Returns the 5 digit National Grid reference.
Sub NEtoNGR(east As String, north As String) As String
	Return OSGB.NEtoNGR(east, north)	
End Sub

''@N:NGRtoOSGB36(gridref) As returnvalue
''Converts an OS national grid reference to OSGB36 decimal lat and long.
''Returns a comma separated string of latitude then longitude.
'The grid reference can be 2, 3, 4 or  5 digits precision, spaces are ignored.
''Sets the Northing and Easting properties.) As String
Sub NGRtoOSGB36(ngr As String) As String
	Return OSGB.NGRtoOSGB36(ngr)
End Sub

''@N:OSGB36toNGR(OSGBlong, OSGBlong) As returnvalue
''Converts OSGB36 decimal lat and long to a 5 digit OS national grid reference.
''Sets the Northing and Easting properties.
''Returns the 5 digit National Grid reference.
Sub OSGB36toNGR(OSGBlat As String, OSGBlong As String) As String
	Return OSGB.NEtoNGR(OSGBlat, OSGBlong)
End Sub

''@N:WGS84toOSGB36(WGSlat, WGSlong, WGSalt) As returnvalue
''Converts WGS84 decimal lat, long and altitude to OSGB36 decimal lat, decimal long And ODN Altitude.
''Returns a comma separated string of latitude then longitude.
' Sets the NewLatitude, NewLongitude And NewAltitude properties.
''South latitudes and West longitudes are -ve.
''Sets the Northing and Easting properties.
Sub WGS84toOSGB36(WGSlat As String, WGSlong As String, WGSalt As String ) As String
	Return OSGB.WGS84toOSGB36(WGSlat, WGSlong, WGSalt)
End Sub

''@N:OSGB36toWGS84(OSGBlat, OSGBlong, OSGBalt) As returnvalue
''Converts OSGB decimal lat, long and ODN altitude to WGS84 decimal lat, decimal long and Altitude.
''Returns a comma separated string of latitude then longitude.
''Sets the NewLatitude, NewLongitude And NewAltitude properties.
''South latitudes and West longitudes are -ve.
''Sets the Northing and Easting properties.
Sub OSGB36toWGS84(OSGBlat As String, OSGBlong As String, OSGBalt As String) As String
	Return OSGB.OSGB36toWGS84(OSGBlat, OSGBlong, OSGBalt)
End Sub

''
''@The following properties hold the last transformation results.

''@N:NewAltitude As returnvalue
''Returns the Altitude value resulting from the latest OSGB36toWGS84 or WGS84toOSGB36 transformation.
''The altitude is metres WGS84 ellipsoid or ODN Newlyn depending on the direction of transformation.
Sub NewAltitude As String
	Return OSGB.NewAltitude
End Sub

''@N:NewLatitude As returnvalue
''Returns the Longitude value resulting from the latest OSGB36toWGS84 or WGS84toOSGB36 transformation.
Sub NewLatitude As String
	Return OSGB.NewLatitude
End Sub

''@N:NewLongitude As returnvalue
''Returns the Longitude value resulting from the latest OSGB36toWGS84 or WGS84toOSGB36 transformation.
Sub NewLongitude As String
	Return OSGB.NewLongitude
End Sub


''@N:Easting As returnvalue
''Returns the Easting value resulting from the latest NGRtoOSGB36 or OSGB36toNGR transformation.
Sub Easting As String
	Return OSGB.Easting
End Sub

''@N:Northing As returnvalue
''Returns the Northing value resulting from the latest NGRtoOSGB36 or OSGB36toNGR transformation.
Sub Northing As String
	Return OSGB.Northing
End Sub


#End Region


#Region Sensor functions
''<a name="sensors"></a>
''@H:SENSOR FUNCTIONS
''
''Sensor constants are available in B4Script to support the nine most common sensor types available on Android.
''All SensorChanged events are vectored to a single BasicLib sub "Sensor_Changed(who, value0, value1, value2)".
''Most sensors return either a single value or three values. 
''Some sensors may return more than three value which may be obtained by invoking GetSensorValues.
''Light, Pressure, Temperature and Proximity return a single value found in value0 of the event parameters
''Accelerometer, Magnetic, Orientation, Gyroscope and Gravity return three values, X, Y and Z in the event value0, value1 and value2 parameters.
''For Orientation the parameter values are  X = Yaw, Y = Pitch, Z = Roll 
''All the sensors that are available are returned by GetSensors.
''The first three sensor values are available as parameters to the SensorChanged event.

''@N:AddSensor(sensortype, sensorname)
''Make a sensor type available to the program.
''sensortype is a Sensor constant or integer value to define the sensor type.
''sensornameName is a string to identify the sensor to the progam. It will be returned lower-cased as 'who' in the Sensor_Changed event.
''AddSensor should be called within a GetFirstTime conditional block so the sensor is added only once when the program is invoked.
Sub AddSensor(SensorType As String, Name As String)
	Name = Name.ToLowerCase
	Dim ps As PhoneSensors
	ps.Initialize(SensorType)
	SensorToNameMap.Put(ps, Name)
	NameToSensorMap.Put(Name, ps)
End Sub

''@N:GetSensors As returnvalue
''Return a string containing details of all the sensor types available to the program.
''Within the string the details for each sensor are enclosed by braces, {},  and terminated by a CRLF character.
''Within the braces are values for the sensor: Sensor name, vendor, version, type, maxRange, resolution, power and minDelay.
''These values are presented as comma separated declarations of the form: Sensor name="Some sensor", ...,type=1,...
''Type is the integer value of the Sensor constant used to identify the sensor when invoking AddSensor.
Sub GetSensors As String
	Dim NativeMe As JavaObject
	NativeMe.InitializeContext
	Dim returnlist As List
	returnlist = NativeMe.RunMethod("getSensorList",Null)
	Dim sensors As String = ""
	For i = 0 To returnlist.Size - 1
		sensors = sensors & returnlist.Get(i) & CRLF
	Next
	Return sensors.SubString2(0, sensors.Length - 1)
End Sub

#If Java
import java.util.List;
import android.hardware.Sensor;
import android.hardware.SensorManager;
SensorManager sMgr;
public List getSensorList() {
	sMgr = (SensorManager) getSystemService(SENSOR_SERVICE);
	List<Sensor> list = sMgr.getSensorList(Sensor.TYPE_ALL);                 
	return list;
} 	
#End If

''@N:GetSensorValues As returnvalue
''Returns a list of the sensor values passed to the latest SensorChanged event as a comma separated string.
Sub GetSensorValues As String
	Dim values As String = ""
	For i = 0 To LastSensorValues.Length - 1
		values = values & LastSensorValues(i) & ","
	Next
	Return values.SubString2(0, values.Length - 1)
End Sub


''@N:StartSensor(sensorname) As returnvalue
''Start the sensor listening for changes.
''Returns True if the sensor is supported otherwise False.
''StartSensor should be called in Activity_Resume
Sub StartSensor(SensorName As String) As String
	'Start listening for SensorChanged events.
	'Returns True if the sensor is supported, False otherwise.
	SensorName = SensorName.ToLowerCase
	Dim ps As PhoneSensors
	ps = NameToSensorMap.Get(SensorName)
	If ps <> Null Then
		Return ps.StartListening("Sensor")
	Else
		Return False
	End If
End Sub
		
''@N:StopSensor(sensorname)
''Stop the sensor listening for changes.
''StopSensor should be called in Activity_Pause.
Sub StopSensor(SensorName As String)
	'Stop listening for SensorChanged events.
	Dim ps As PhoneSensors
	ps = NameToSensorMap.Get(SensorName.ToLowerCase)
	If ps <> Null Then
		ps.StopListening
	End If
End Sub

Sub Sensor_SensorChanged (Values() As Float)
	LastSensorValues = Values
	If Blib.CanCall("Sensor_Changed") Then
		Dim ps As PhoneSensors
		'Get the PhoneSensors object that raised this event.
		ps = Sender
		Dim params(4) As String
		params(0) = SensorToNameMap.Get(ps) ' get name of sensor
		params(1) = Values(0)
		If Values.Length > 2 Then		' return the first three values
			params(2) = Values(1)
			params(3) = Values(2)
		Else
			params(2) = 0
			params(3) = 0
		End If
		Blib.Call("Sensor_Changed", params)
	End If
End Sub

#End Region


#Region Add and Remove View Functions and Events

''<a name="view"></a>
''@H:ADD AND REMOVE VIEW FUNCTIONS
''
''The Add view functions use four parameters; name, left, top, width, height, and parent.
''Parent can be the Activity, a Panel or a Tab in a TabHost.
''Parent should be an empty string (ie. "") if adding to the activity.

''@N:AddButton(buttonname, left, top, width, height, parent)
''Add a Button to the activity or a panel.
Sub AddButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As Button
	b.Initialize("Button")
	b.Tag = name.ToLowerCase
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub button_click(sender)" when any Button Click event is raised. 
Sub Button_Click
	If Blib.CanCall("button_click") Then
		Dim v As View
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("button_click", params)
	End If
End Sub

''@N:AddCheckBox(checkboxname, left, top, width, height, parent)
''Add a CheckBox to the activity or a panel.
Sub AddCheckBox(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As CheckBox
	b.Initialize("CheckBox")
	b.Tag = name.ToLowerCase	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub check_checkedchange(sender, checked)" when any CheckBox CheckedChanged event is raised 
Sub CheckBox_CheckedChange(Checked As Boolean)
	If Blib.CanCall("check_checkedchange") Then
		Dim v As View
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = Checked
		Blib.Call("check_checkedchange", params)
	End If
End Sub

''@N:AddEditText(edittextname, left, top, width, height, parent)
''Add an EditText to the activity or a panel.
Sub AddEditText(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim e As EditText
	e.Initialize("EditText")
	e.Tag = name.ToLowerCase
	e.Gravity = Gravity.NO_GRAVITY
	Dim jo As JavaObject
	jo = e
	jo.RunMethod("setImeOptions", Array(33554432)) ' IME_FLAG_NO_FULLSCREEN 
	AddView(e, name, left, top, width, height, parent)
End Sub

'Call the script "Sub edit_textchanged(sender, oldtext, newtext)" when any EditText TextChanged event is raised 
Sub EditText_TextChanged (Old As String, New As String)
	If Blib.CanCall("edit_textchanged") Then
		Dim v As View
		v = Sender
		Dim params(3) As String
		params(0) = v.Tag
		params(1) = Old
		params(2) = New
		Blib.Call("edit_textchanged", params)
	End If
End Sub

'Call the script "Sub edit_enterpressed(sender)" when any EditText EnterPressed event is raised 
Sub EditText_EnterPressed
	If Blib.CanCall("edit_enterpressed") Then
		Dim v As View
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("edit_enterpressed", params)
	End If
End Sub

'Call the script "Sub edit_focuschanged(who, hasfocus)
Sub EditText_FocusChanged(HasFocus As Boolean)
	If Blib.CanCall("edit_focuschanged") Then
		Dim v As View
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = HasFocus
		Blib.Call("edit_focuschanged", params)
	End If
End Sub

''@N:AddHorizontalScrollView(horizontalscrollname, left, top, width, height, parent)
''Add a Horizontal ScrollView to the activity or panel.
''The inner panel width is set to the given width, it can be changed later as required using GetPanel.
Sub AddHorizontalScrollView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim s As HorizontalScrollView
	s.Initialize(width, "HSV")
	s.Tag = name.ToLowerCase
	AddView(s, name, left, top, width, height, parent)
End Sub

'Call the script "Sub hsv_scrollchanged(sender, position)" when any HorizontalScrollView ScrollChanged event is raised. 
Sub HSV_ScrollChanged(position As Int)
	If Blib.CanCall("hsv_scrollchanged") Then
		Dim v As View
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = position
		Blib.Call("hsv_scrollchanged", params)
	End If
End Sub

''@N:AddImageView(imagename, left, top, width, height, parent)
''Add an ImageView to the activity or a panel.
Sub AddImageView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim I As ImageView
	I.Initialize("ImageView")
	I.Tag = name.ToLowerCase	
	AddView(I, name, left, top, width, height, parent)
End Sub

Sub ImageView_Click
	'The user has tapped on the view.
	If Blib.CanCall("imageview_click") Then
		Dim v As ImageView
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("imageview_click", params)
	End If
End Sub

Sub ImageView_LongClick
	'The user has long pressed on the view.
	If Blib.CanCall("imageview_longclick") Then
		Dim v As ImageView
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("imageview_longclick", params)
	End If
End Sub

''@N:AddLabel(labelname, left, top, width, height, parent)
''Add a Label to the activity or a panel.
Sub AddLabel(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim l As Label
	l.Initialize("Label")
	l.Tag = name.ToLowerCase	
	AddView(l, name, left, top, width, height, parent)
End Sub

'Call the script "Sub label_click(sender)" when any Label Click event is raised. 
Sub Label_Click
	If Blib.CanCall("label_click") Then
		Dim v As View
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("label_click", params)
	End If
End Sub

''@N:AddListView(listviewname, left, top, width, height, parent)
''Add a ListView to the activity or a panel.
Sub AddListView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ListView
	S.Initialize("ListView")
	S.Tag = name.ToLowerCase	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub listview_itemclick(sender, position, value)" when any ListView ItemClick event is raised 
Sub ListView_ItemClick(position As Int, value As Object)
	If Blib.CanCall("listview_itemclick") Then
		Dim v As View
		v = Sender
		Dim params(3) As String
		params(0) = v.Tag
		params(1) = position
		params(2) = value
		Blib.Call("listview_itemclick", params)
	End If
End Sub

''@N:AddMenuItem(menutext)
''Add a MenuItem to the Activity.
Sub AddMenuItem(menutext As String)
	Activity.AddMenuItem(menutext, "Menu")
End Sub

'All menu_click events are sent here
Sub Menu_Click
	If Blib.CanCall("menu_click") Then
		Dim params(1) As String
		params(0) = Sender
		Blib.Call("menu_click", params)
	End If
End Sub

''@N:AddPanel(panelname, left, top, width, height, parent)
''Add a Panel to the activity or a panel.
''The Panel Elevation is set to 1 otherwise Labels (and maybe other views) can be drawn over it.
''Use GetElevation and SetElevation to solve any other such problems that might arise.
Sub AddPanel(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim p As Panel
	p.Initialize("Panel")
	p.Tag = name.ToLowerCase	
	p.Elevation = 1.0 'ignore
	AddView(p, name, left, top, width, height, parent)
End Sub

'Call the script "Sub panel_click(sender)" when any Panel_Click event is raised. 
Sub Panel_Click
	If Blib.CanCall("panel_click") Then
		Dim v As View
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("panel_click", params)
	End If
End Sub

''@N:AddProgressBar(progressbarname, left, top, width, height, parent)
''Add a ProgressBar to the activity or a panel.
Sub AddProgressBar(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim p As ProgressBar
	p.Initialize("ProgressBar")
	p.Tag = name.ToLowerCase
	AddView(p, name, left, top, width, height, parent)
End Sub

''@N:AddRadioButton(radiobuttonname, left, top, width, height, parent)
''Add a RadioButton to the activity or a panel.
Sub AddRadioButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As RadioButton
	b.Initialize("RadioButton")
	b.Tag = name.ToLowerCase	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub radio_checkedchanged(sender, checked)" when any RadioButton CheckedChange event is raised 
Sub RadioButton_CheckedChange(Checked As Boolean)
	If Blib.CanCall("radio_checkedchange") Then
		Dim v As View
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = Checked
		Blib.Call("radio_checkedchange", params)
	End If
End Sub

''@N:AddScaleImageView(scaleimageviewname, left, top, width, height, parent)
''Supported gestures are:
''One finger drag to pan, Two finger pinch to zoom And double tap to zoom in And out.
''Pan While zooming, seamless switch between pan And zoom And fling momentum after panning.
''Quick scale (one finger zoom - quick double tap Then drag)	
''The Click and LongClick event parameters are as follows.
''The viewx and viewy parameters are the pixel position of the point clicked on the ScaleImageView itself.
''The imagex and imagey parameters are the pixel position of the point clicked on the original full size image.
Sub AddScaleImageView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ScaleImageView
	S.Initialize("ScaleImageView")
	S.Tag = name.ToLowerCase
	S.DoubleTapZoomDuration = 250
	S.Orientation = S.ORIENTATION_USE_EXIF
	S.PanLimit = S.PAN_LIMIT_CENTER	
	AddView(S, name, left, top, width, height, parent)
	
End Sub

Sub ScaleImageView_Click
	'The user has tapped on the view. Use either the imagex/y or or viewx/y parameters for the coordinates.
	If Blib.CanCall("scaleimageview_click") Then
		Dim v As ScaleImageView
		v = Sender
		Dim params(5) As String
		params(0) = v.Tag
		params(1) = NumberFormat2(v.ClickViewX, 1, 0, 0, False)
		params(2) = NumberFormat2(v.ClickViewY, 1, 0, 0, False)
		params(3) = NumberFormat2(v.ClickImageX, 1 , 0, 0, False)
		params(4) = NumberFormat2(v.ClickImageY, 1, 0, 0, False)
		Blib.Call("scaleimageview_click", params)
	End If
End Sub

Sub ScaleImageView_LongClick
	'The user has tapped on the view. Use either the imagex/y or or viewx/y parameters for the coordinates.
	If Blib.CanCall("scaleimageview_longclick") Then
		Dim v As ScaleImageView
		v = Sender
		Dim params(5) As String
		params(0) = v.Tag
		params(1) = NumberFormat2(v.ClickViewX, 1, 0, 0, False)
		params(2) = NumberFormat2(v.ClickViewY, 1, 0, 0, False)
		params(3) = NumberFormat2(v.ClickImageX, 1 , 0, 0, False)
		params(4) = NumberFormat2(v.ClickImageY, 1, 0, 0, False)
		Blib.Call("scaleimageview_longclick", params)
	End If
End Sub

''@N:AddScrollView(scrollviewname, left, top, width, height, parent)
''Add a ScrollView to the activity or a panel.
''The inner panel height is set to the given height, it can be changed later as required using GetPanel.
Sub AddScrollView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ScrollView
	S.Initialize2(height,"ScrollView")
	S.Tag = name.ToLowerCase
	AddView(S, name, left, top, width, height, parent)
End Sub

''@N:AddScrollView2D(scrollviewname, left, top, width, height, parent)
''Add a ScrollView2D to the activity or a panel.
''The inner panel width is set to the given width, it can be changed later as required using GetPanel.
''The inner panel height is set to the given height, it can be changed later as required using GetPanel.
Sub AddScrollView2D(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ScrollView2D
	S.Initialize(width, height, "ScrollView2D")
	S.FadingEdges(False)	
	S.Tag = name.ToLowerCase
	AddView(S, name, left, top, width, height, parent)
End Sub

''@N:AddSeekBar(seekbarname, left, top, width, height, parent)
''Add a SeekBar to the activity or a panel.
Sub AddSeekBar(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As SeekBar
	S.Initialize("SeekBar")
	S.Tag = name.ToLowerCase	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub seekbar_valuechanged(sender, value, userchanged)" when any SeekBar ValueChanged event is raised 
Sub SeekBar_ValueChanged(value As Int, userchanged As Boolean)
	If Blib.CanCall("seekbar_valuechanged") Then
		Dim v As View
		v = Sender
		Dim params(3) As String
		params(0) = v.Tag
		params(1) = value
		params(2) = userchanged
		Blib.Call("seekbar_valuechanged", params)
	End If
End Sub

''@N:AddSpinner(spinnername, left, top, width, height, parent)
''Add a Spinner to the activity or a panel.
''Note that you must add an item to a Spinner or it hangs on drop down.
Sub AddSpinner(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As Spinner
	S.Initialize("Spinner")
	S.Tag = name.ToLowerCase	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub spinner_itemclick(sender, position, value)" when any Spinner ItemClick event is raised 
Sub Spinner_ItemClick(position As Int, value As Object)
	If Blib.CanCall("spinner_itemclick") Then
		Dim v As View
		v = Sender
		Dim params(3) As String
		params(0) = v.Tag
		params(1) = position
		params(2) = value
		Blib.Call("spinner_itemclick", params)
	End If
End Sub

''@N:AddTabHost(tabhostname, left, top, width, height, parent)
''Add a TabHost to the activity or a panel.
Sub AddTabHost(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim T As TabHost
	T.Initialize("TabHost")
	T.Tag = name.ToLowerCase	
	AddView(T, name, left, top, width, height, parent)
End Sub

'Call the script "Sub tabhost_tabchanged(Sender)" when any TabHost TabChanged event is raised 
Sub TabHost_TabChanged
	If Blib.CanCall("tabhost_tabchanged") Then
		Dim v As TabHost
		v = Sender
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("tabhost_tabchanged", params)
	End If
End Sub

''@N:AddTable2D(tablename, left, top, width, height, parent)
''Add a Table to the activity or a panel. The Table is added with the default of 4 columns specified.
''Call ResizeTable to change the number of columns in the Table.
''The Table cam be sorted in ascending or descending order by tapping the header as long as EnableSort is True.
Sub AddTable2D(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim T As Table2D
	Dim v As View
	T.Initialize(Me, "Table")
	'We treat Table differently as it is not a real View object so we can't use AddView()
	If parent = "" Then
		v = Activity
	Else
		v = ViewMapGet(parent.ToLowerCase)
	End If
	T.AddToView(v, left, top, width, height, 4)
	T.Tag = name.ToLowerCase	
	ViewMap.Put(name.ToLowerCase, T)
End Sub

'Call the script "Sub table_cellclick(Sender, col, row)" when any Table CellClick event is raised 
Sub Table_CellClick(col As Int, row As Int)
	If Blib.CanCall("table_cellclick") Then
		Dim v As Table2D
		v = Sender
		Dim params(3) As String
		params(0) = v.Tag
		params(1) = col
		params(2) = row
		Blib.Call("table_cellclick", params)
	End If
End Sub

'Call the script "Sub table_celllongclick(Sender, col, row)" when any Table CellLongClick event is raised 
Sub Table_CellLongClick(col As Int, row As Int)
	If Blib.CanCall("table_celllongclick") Then
		Dim v As Table2D
		v = Sender
		Dim params(3) As String
		params(0) = v.Tag
		params(1) = col
		params(2) = row
		Blib.Call("table_celllongclick", params)
	End If
End Sub

'Call the script "Sub table_headerclick(Sender, col)" when any Table HeaderClick event is raised 
Sub Table_HeaderClick(col As Int)
	If Blib.CanCall("table_headerclick") Then
		Dim v As Table2D
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = col
		Blib.Call("table_headerclick", params)
	End If
End Sub

'Call the script "Sub table_headerlongclick(Sender, col)" when any Table HeaderLongClick event is raised 
Sub Table_HeaderLongClick(col As Int)
	If Blib.CanCall("table_headerlongclick") Then
		Dim v As Table2D
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = col
		Blib.Call("table_headerlongclick", params)
	End If
End Sub

''@N:AddToggleButton(togglebuttonname, left, top, width, height, parent)
''Add a ToggleButton to the activity or a panel.
''Although SetText will set the displayed text of a ToggleButton when the state changes
''the text set by SetTextOff/On appropriate to the state of the button will be displayed.
''If SetTextOff/On  are not invoked then the displayed texts default to ON  and OFF.
''An initial SetChecked call should be made after LoadLayout to set the state and displayed text.
''BasicIDE Designer will include SetChecked(tglname, False) in LoadLayout.
Sub AddToggleButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As ToggleButton
	b.Initialize("ToggleButton")
	Dim jo As JavaObject = b
	jo.RunMethod("setAllCaps", Array As Object( False))	
	b.Tag = name.ToLowerCase
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub toggle_change(sender, checked)" when any ToggleButton CheckedChanged event is raised 
Sub ToggleButton_CheckedChange(Checked As Boolean)
	If Blib.CanCall("toggle_checkedchange") Then
		Dim v As View
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = Checked
		Blib.Call("toggle_checkedchange", params)
	End If
End Sub

''@N:RemoveAllViewsEntirely
''Removes all views from the Activity and from the program.
Sub RemoveAllViewsEntirely
	Dim v As View
	Dim S As Int
	Do While ViewMap.Size > 0
		S = ViewMap.Size - 1
		v = ViewMap.GetValueAt(S)
		v.RemoveView
		ViewMap.Remove(ViewMap.GetKeyAt(S))
	Loop
End Sub

''@N:RemoveView(viewname)
''Removes the named view from its parent, but doesn't destroy it. 
''Used primarily for hiding a panel containing views to be used for popup help screens and custom input dialogs.
Sub RemoveView(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.RemoveView
	End If
End Sub

''@N:RemoveViewEntirely(viewname)
''Completely remove the named view its parent and from the program. It will no longer be available to the program.
Sub RemoveViewEntirely(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.RemoveView
	End If
	ViewMap.Remove(viewname)
End Sub


#End Region


#Region Shared View functions

''<a name="shared"></a>
''@H:SHARED VIEW FUNCTIONS
''
''These functions apply to all views except Table because it is not a real View object.
''However Left, Right, Top, Bottom, Width, Height and Visible have special code to support using them on a Table.
''These primarily exist so that autoscaling and designer scripts will work on Table as well as regular views.
''
''There is a pre-allocated name 'Activity' for the activity that can also be used for these functions.

''@N:BringToFront(viewname)
''Bring the named view to the front of the Z order.
Sub BringToFront(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.BringToFront
	End If
End Sub

''@N:GetBottom(viewname) As returnvalue
''Get the Bottom property of the named view.
Sub GetBottom(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Top + v.Height - 1
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Top + t.Height - 1
	End If
	Return -1

End Sub

''@N:GetElevation(viewname) As returnvalue
''Get the GetElevation property of the named view.
''Some views may be unexepectedly drawn over other views. Elevation is probably to blame.
''Use GetElevation and SetElevation to investigate and solve any such problems.
Sub GetElevation(viewname As String) As String
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		Dim jo As JavaObject
		jo = v
		Return jo.RunMethod("getElevation", Null)
	End If
	Return -1
End Sub

''@N:GetEnabled(viewname) As returnvalue
''Get the Enabled property of the named view.
Sub GetEnabled(viewname As String) As String
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		Return v.Enabled
	End If
	Return -1
End Sub

''@N:GetHeight(viewname) As returnvalue
''Get the Height property of the named view.
Sub GetHeight(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Height
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Height
	End If
	Return -1
End Sub

''@N:GetLeft(viewname) As returnvalue
''Get the Left property of the named view.
Sub GetLeft(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Left
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Left
	End If
	Return -1
End Sub

''@N:GetParent(viewname) As returnvalue
''Get the lower cased name of the parent of the named view or an empty string if there is no parent.
''If not the Activity the parent will always be a Panel.
Sub GetParent(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		If v.Parent <> Null Then
			Dim p As Panel = v.Parent
			For i = 0 To ViewMap.Size - 1
				If ViewMap.GetValueAt(i) = p Then
					Return ViewMap.GetKeyAt(i)
				End If
			Next
		End If
	End If
	Return ""
End Sub

''@N:GetPadding(viewname) As returnvalue
''Get the padding values of the named view or an empty string if there is no padding.
''The padding values are returned as a comma separated string.
Sub GetPadding(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Dim p() As Int = v.Padding
		Return p(0) & ","  & p(1) & "," & p(2) & "," & p(3)		
	End If
	Return ""
End Sub


''@N:GetRight(viewname) As returnvalue
''Gets the Right property of the named view.
Sub GetRight(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Left + v.Width - 1
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Left + t.Width - 1
	End If
	Return -1
End Sub

''@N:GetTop(viewname) As returnvalue
''Get the Top property of the named view.
Sub GetTop(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Top
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Top
	End If
	Return -1
End Sub

''@N:GetVisible(viewname) As returnvalue
''Get the Visible property of the named view.
Sub GetVisible(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Visible
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Visible
	End If
	Return -1
End Sub

''@N:GetWidth(viewname) As returnvalue
''Get the Width property of the named view.
Sub GetWidth(viewname As String) As String
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Return v.Width
	else if o Is Table2D Then
		Dim t As Table2D = o
		Return t.Width
	End If
	Return -1
End Sub

''@N:Invalidate(viewname)
''Invalidate the named view.
''Invalidate graphics updates to a view through Canvas drawing routines so a CallDoEvents will repaint the View.
''See GRAPHICS FUNCTIONS for more info.
Sub Invalidate(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.Invalidate
	End If
End Sub

''@N:IsView(viewname) As returnvalue
''Returns true if the named view exists, otherwise false.
Sub IsView(viewname As String) As String
	Return ViewMap.ContainsKey(viewname.ToLowerCase)
End Sub

''@N:RequestFocus(viewname)
''Set the focus to the named view. Only views with editable text and a cursor may receive focus.
Sub RequestFocus(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		If v.RequestFocus Then
			IME.ShowKeyboard(v)
		End If
	End If
End Sub

''@N:SendToBack(viewname)
''Send the named view to the back of the Z order.
Sub SendToBack(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.SendToBack
	End If
End Sub

''@N:SetBackground(viewname, radius, color)
''Set the Background property of the named view to a ColorDrawable.
Sub SetBackground(viewname As String, radius As String, Color As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		Dim C As ColorDrawable
		C.Initialize(Color, radius)
		v.Background = C
	End If
End Sub

''@N:SetBackgroundGradient(viewname, orientation, radius, colorsarrayname) As returnvalue
''Set the Background property of the named view to a GradientDrawable.
''Returns false if less than two colors are in the array or name not found otherwise returns true.
''Orientation can be one of the following: 
''"TOP_BOTTOM", "TR_BL" (Top-Right to Bottom-Left), "RIGHT_LEFT", "BR_TL" (Bottom-Right to Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left t0 top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left to Bottom-Right)
Sub SetBackgroundGradient(viewname As String, Orientation As String, radius As String, colorsarrayname As String) As String
	Dim v As View
	Dim cols(0) As String
	Dim G As GradientDrawable
	v = ViewMapGet(viewname.ToLowerCase)
	cols = BlibGetArray(colorsarrayname)
	If v.IsInitialized And cols.Length >= 2 Then
		Dim colints(cols.Length) As Int
		For I = 0 To cols.Length - 1
			colints(I) = cols(I)
		Next
		G.Initialize(Orientation, colints)
		G.CornerRadius = radius
		v.Background = G
		Return True
	End If
	Return False
End Sub

''@N:SetBackgroundImage(viewname) As returnvalue
''Set the BackgroundImage of the view to the present bitmap. See GRAPHICS FUNCTIONS for more info.
''Return true if both view and bitmap are initialised otherwise return false.
Sub SetBackgroundImage(viewname As String) As String
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized And TheBitmap.IsInitialized Then
		v.SetBackgroundImage(TheBitmap)
		Return True
	End If
	Return False
End Sub

''@N:SetBottom(viewname, bottom)
''Set the Bottom property of the named view.
Sub SetBottom(viewname As String, bottom As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.top = v.Height - bottom + 1
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.top = t.Height - bottom + 1
	End If
End Sub

''@N:SetColor(viewname, radius, color)
''Set the Background property of the named view to a ColorDrawable.
''This is the same as SetBackground.
Sub SetColor(viewname As String, radius As String, Color As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		Dim C As ColorDrawable
		C.Initialize(Color, radius)
		v.Background = C
	End If	
End Sub

''@N:SetElevation(viewname, elevation)
''Set the Elevation property of the named view.
''Some views may be unexepectedly drawn over other views. Elevation will probably be to blame.
''Use GetElevation and SetElevation to investigate and solve any such problems.
Sub SetElevation(viewname As String, elevation As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		Dim jo As JavaObject
		jo = v
		Dim ef As Float = elevation
		jo.RunMethod("setElevation", Array As Object(ef))
	End If
End Sub

''@N:SetEnabled(viewname, enabled)
''Set the true/false Enabled property of the named view.
Sub SetEnabled(viewname As String, state As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.Enabled = state
	End If
End Sub

''@N:SetHeight(viewname, height)
''Set the Height property of the named view.
Sub SetHeight(viewname As String, height As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.Height = height
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.Height = height
	End If
End Sub

''@N:SetLeft(viewname, left)
''Set the Left property of the named view.
Sub SetLeft(viewname As String, left As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.left = left
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.left = left
	End If
End Sub

''@N:SetParent(viewname, parent)
''Removes the named view from its existing parent, if any, and adds it to the specified parent.
''If the new parent is not a Panel then the view is added to the Activity.
''The view retains its original size and position values which may not be appropriate for the new parent.
''You can add views to a ScrollView Panel obtained by GetPanel.
''You can add views to a TabHost Tab using the panel name specified by AddTab.
Sub SetParent(viewname As String, parent As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		v.RemoveView
	End If	
	Dim p As View
	p = ViewMapGet(parent.ToLowerCase)
	If p.IsInitialized  Then
		If p Is Panel Then
			Dim pnl As Panel
			pnl = p
			pnl.AddView(v, v.Left, v.Top, v.Width, v.Height)
		End If
	Else
		Activity.AddView(v, v.Left, v.Top, v.Width, v.Height)
	End If
End Sub

''@N:SetPadding(viewname, paddingvalues)
''Set the padding values of the named view.
''The values are provided in paddingvalues as four integer values in a comma separated string.
Sub SetPadding(viewname As String, paddingvalues As String) 
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		Dim p() As String = Regex.Split(",", paddingvalues)
		v.Padding = Array As Int(p(0), p(1), p(2), p(3))	
	End If
End Sub


''@N:SetRight(viewname, right)
''Set the Right property of the named view.
Sub SetRight(viewname As String, right As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.Left = right - v.Width + 1
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.Left = right - t.Width + 1
	End If
End Sub

''@N:SetTop(viewname, top)
''Set the Top property of the named view.
Sub SetTop(viewname As String, top As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.Top = top
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.Top = top
	End If
End Sub

''@N:SetVisible(viewname, visible)
''Set the true/false Visible property of the named view.
Sub SetVisible(viewname As String, visible As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.Visible = visible
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.Visible = visible
	End If
End Sub

''@N:SetWidth(viewname, width)
''Set the Width property of the named view.
Sub SetWidth(viewname As String, width As String)
	Dim o As Object
	o = ViewMapGet(viewname.ToLowerCase)
	If o Is View Then
		Dim v As View = o
		v.Width = width
	else if o Is Table2D Then
		Dim t As Table2D = o
		t.Width = width
	End If
End Sub

#End Region


#Region CheckBox, RadioButton and ToggleButton functions

''<a name="check"></a>
''@H:CHECKBOX, RADIOBUTTON AND TOGGLEBUTTON FUNCTIONS
''
''CheckBox, RadioButton and ToggleButton support Set/GetChecked in addition to the Shared View functions.
''Note that ToggleButton will display text assigned by SetText but this will be overwritten when the state changes.

''@N:GetChecked(viewname) As returnvalue
''Get the Checked state of a CheckBox, RadioButton or ToggleButton.
Sub GetChecked(viewname As String) As String
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		If v Is CheckBox Then
			Dim C As CheckBox
			C = v
			Return C.Checked
		Else If v Is RadioButton Then
			Dim r As RadioButton
			r = v
			Return r.Checked
		Else If v Is ToggleButton Then
			Dim T As ToggleButton
			T = v
			Return T.Checked
		End If
	End If
	Return False
End Sub

''@N:SetChecked(viewname, checkedstate)
''Set the Checked state of a CheckBox, RadioButton or ToggleButton.
Sub SetChecked(viewname As String, checked As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		If v Is CheckBox Then
			Dim C As CheckBox
			C = v
			C.checked = checked
		Else If v Is RadioButton Then
			Dim r As RadioButton
			r = v
			r.checked = checked		
		Else If v Is ToggleButton Then
			Dim T As ToggleButton
			T = v
			T.checked = checked		
		End If
	End If
End Sub

''@N:SetTextOff(togglebuttonname, text)
''Sets the text that will appear in the OFF mode of a ToggleButton.
Sub SetTextOff(viewname As String, Text As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized And v Is ToggleButton Then
		Dim b As ToggleButton
		b = v
		b.TextOff = Text			
	End If
End Sub

''@N:SetTextOn(togglebuttonname, text)
''Sets the text that will appear in the ON mode of a ToggleButton.
Sub SetTextOn(viewname As String, Text As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized And v Is ToggleButton Then
		Dim b As ToggleButton
		b = v
		b.TextOn = Text	
	End If
End Sub

#End Region


#Region EditText functions

''<a name="edittext"></a>
''@H:EDITTEXT FUNCTIONS
''
''EditText supports these functions in addition to the View and TextView functions.

''@N:GetSelectionStart(edittextname) As returnvalue
''Gets the selection start position (or the cursor position) of the EditText.
''Returns -1 if there is no selection or cursor.
Sub GetSelectionStart(name As String) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		Return e.SelectionStart		
	End If
	Return -1
End Sub

''@N:SelectAll(edittextname)
''Selects all text of the named edittext view.
Sub SelectAll(name As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.SelectAll
	End If
End Sub

''@N:SelectText(edittextname, selectionstart, selectionlength)
''Selects text within the named edittext, starting at offset selectionstart and extending selectionlength characters.
Sub SelectText(name As String, start As String, length As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		'Dim st As Int = start, en As Int = start + length
		e = v
		Obj1.Target = e
		Obj1.RunMethod3("setSelection", start, "java.lang.int", start + length, "java.lang.int")
	End If
End Sub

''@N:SetForceDoneButton(edittextname, forcestate)
''Force the EditText virtual keyboard action key to display Done by setting this value to True.
Sub SetForceDoneButton(name As String, forcestate As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.ForceDoneButton = forcestate			
	End If	
End Sub

''@N:SetHint(edittextname, hinttext)
''Set the text that will appear when the EditText is empty.
Sub SetHint(name As String, hint As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.hint = hint			
	End If	
End Sub

''@N:SetHintColor(edittextname, hintcolor)
''Set the color of the text that will appear when the EditText is empty.
Sub SetHintColor(name As String, hintcolor As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.hintcolor = hintcolor			
	End If
End Sub

''@N:SetInputType(edittextname, inputtype)
''Set the value of the EditText InputType property.
''NONE = 0; TEXT = 1; NUMBERS = 2; _PHONE = 3; DECIMAL_NUMBERS = 12290;
Sub SetInputType(name As String, inputtype As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.inputtype = inputtype			
	End If
End Sub

''@N:SetPasswordMode(edittextname, state)
''Set the true or false value of the EditText PasswordMode property.
Sub SetPasswordMode(name As String, state As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.PasswordMode = state			
	End If
End Sub

''@N:SetSelectionStart(edittextname, startposition)
''Sets the selection start position (or the cursor position) of the EditText.
Sub SetSelectionStart(name As String, selectionstart As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.selectionstart = selectionstart			
	End If
End Sub

''@N:SetSingleLine(edittextname, singlelinestate)
''Set the true/false value of the EditText SingleLine property.
Sub SetSingleLine(name As String, state As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.SingleLine = state			
	End If
End Sub

''@N:SetWrap(edittextname, wrapstate)
''Set the true/false value of the EditText Wrap property.
Sub SetWrap(name As String, state As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is EditText Then
		Dim e As EditText
		e = v
		e.Wrap = state			
	End If
End Sub

#End Region


#Region Graphics and Image functions

''<a name="graphics"></a>
''@H:GRAPHICS AND IMAGE FUNCTIONS
''
''There is a single bitmap object, which can be initialised from an image file or as a new mutable bitmap.
''There is a single canvas object, which can be initialised on any view, or on a mutable bitmap.
''Both the bitmap and canvas objects may be reinitialised as many times as needed.
''Rectangles are assumed to be the names of a BasicLib array of rank 4 with the x,y coordinates of two points.
''The array items are ordered as left(0), top(1) of the upper left point and, right(2) and bottom(3) of the lower right point.
''Points are assumed to be consecutive pairs of x,y coordinates in an array ordered as x(2n+0) and y(2n+1).
''The drawings will only be updated after a call to ParentView.Invalidate.

''@N:BitmapHeight As returnvalue
''Get the height of the current bitmap.
Sub BitmapHeight As String
	Return TheBitmap.Height
End Sub

''@N:BitmapInit(dir, filename)
''(Re)initialise the bitmap to a graphic file.
Sub BitmapInit(dir As String, fileName As String)
	TheBitmap.Initialize(dir, fileName)
End Sub

''@N:BitmapInitImage(imageviewname)
''(Re)initialise the bitmap to the bitmap of an ImageView.
Sub BitmapInitImage(imageviewname As String)
	Dim v As View
	v = ViewMapGet(imageviewname.ToLowerCase)
	If v.IsInitialized And v Is ImageView Then
		Dim i As ImageView
		i = v
		TheBitmap = i.Bitmap
	End If
End Sub

''@N:BitmapInitMutable(width, height)
''(Re)initialise the bitmap to a mutable bitmap.
Sub BitmapInitMutable(width As String, height As String)
	TheBitmap.InitializeMutable(width, height)
End Sub

''@N:BitmapWidth As returnvalue
''Get the width of the current bitmap.
Sub BitmapWidth As String
	Return TheBitmap.Width
End Sub

''@N:CanvasInit(viewname)
''(Re)initialise the canvas object on any View.
Sub CanvasInit(viewname As String)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If v.IsInitialized Then
		TheCanvas.Initialize(v)
	End If
End Sub

''@N:CanvasInit2
''The one canvas can also be reinitialised on a mutable Bitmap if the sole Bitmap object is one.
Sub CanvasInit2
	If TheBitmap.IsInitialized Then
		TheCanvas.Initialize2(TheBitmap)
	End If
End Sub

''@N:DrawBitmap(srcrectarrayname, destrectarrayname) As returnvalue
''Draws the present bitmap.
''SrcRect - The rectangular area of the Bitmap that will be drawn.
''DestRect - The rectangular area that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmap(srcrectarrayname As String, destrectarrayname As String) As String
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = BlibGetArray(srcrectarrayname)
	rd = BlibGetArray(destrectarrayname)
	If rs.Length <> 4 Or rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	TheCanvas.DrawBitmap(TheBitmap, rsrc, rdest)
	Return True
End Sub

''@N:DrawBitmapFlipped(srcrectarrayname, destrectarrayname, vertically, horizontally) As returnvalue
''Draws the present bitmap either horizontally, vertically or both.
''SrcRect - The rectangular area of the Bitmap that will be drawn.
''DestRect - The rectangular area that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmapFlipped(srcrectarrayname As String, destrectarrayname As String, vertically As String, horizontally As String) As String
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = BlibGetArray(srcrectarrayname)
	rd = BlibGetArray(destrectarrayname)
	If rs.Length <> 4 Or rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	TheCanvas.DrawBitmapFlipped(TheBitmap, rsrc, rdest, vertically, horizontally)
	Return True
End Sub

''@N:DrawBitmapRotated(srcrectarrayname, destrectarrayname, degrees) As returnvalue
''Draws the present bitmap rotated.
''SrcRect - The rectangular area of the Bitmap that will be drawn.
''DestRect - The rectangular area that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmapRotated(srcrectarrayname As String, destrectarrayname As String, degrees As String) As String
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = BlibGetArray(srcrectarrayname)
	rd = BlibGetArray(destrectarrayname)
	If rs.Length <> 4 Or rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	TheCanvas.DrawBitmapRotated(TheBitmap, rsrc, rdest, degrees)
	Return True
End Sub

''@N:DrawCircle(x, y, radius, color, filled, strokewidth)
''Draws a circle.
Sub DrawCircle(x As String, y As String, radius As String, Color As String, filled As String, strokewidth As String)
	TheCanvas.DrawCircle(x, y, radius, Color, filled, strokewidth)
	End Sub

''@N:DrawColor(color)
''Fills the entire canvas with the given color.
Sub DrawColor(Color As String)
	TheCanvas.DrawColor(Color)
End Sub

''@N:DrawLine(x1, y1, x2, y2, color, strokewidth)
''Draws a line.
Sub DrawLine(x1 As String, y1 As String, x2 As String, y2 As String, Color As String, strokewidth As String)
	TheCanvas.DrawLine(x1, y1, x2, y2, Color, strokewidth)
End Sub

''@N:DrawOval(rectarrayname, radius, color, filled, strokewidth) As returnvalue
''Draws an ellipse.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawOval(rectarrayname As String, Color As String, filled As String, strokewidth As String) As String
	Dim r As Rect
	Dim ra(0) As String
	ra = BlibGetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	TheCanvas.DrawOval(r, Color, filled, strokewidth)
	Return True
End Sub

''@N:DrawRotatedOval(rectarrayname, radius, color, filled, strokewidth, degrees) As returnvalue
''Draws a rotated  ellipse.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawOvalRotated(rectarrayname As String, Color As String, filled As String, strokewidth As String, degrees As String) As String
	Dim r As Rect
	Dim ra(0) As String
	ra = BlibGetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	TheCanvas.DrawOvalRotated(r, Color, filled, strokewidth, degrees)
	Return True
End Sub

''@N:DrawPath(pointsarrayname, color, filled, strokewidth) As returnvalue
''Draws a set of connected lines from the points provided in a named array.
''Returns false if less than two points are in the array otherwise returns true.
Sub DrawPath(pointsarrayname As String, Color As String, filled As String, strokewidth As String) As String
	Dim p As Path
	Dim pts(0) As String
	pts = BlibGetArray(pointsarrayname)
	If pts.Length < 4 Then
		Return False
	End If
	p.Initialize(pts(0), pts(1))
	For I = 2 To pts.Length - 2 Step 2
		p.LineTo(pts(I), pts(I + 1))
	Next
	TheCanvas.DrawPath(p, Color, filled, strokewidth)
	Return True
End Sub

''@N:DrawPoint(x, y, color)
''Sets a single pixel to the specified color.
Sub DrawPoint(x As String, y As String, Color As String)
	TheCanvas.DrawPoint(x, y, Color)
End Sub

''@N:DrawRect(rectarrayname, color, filled, strokewidth) As returnvalue
''Draws a rectangle from the points provided in a named array.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawRect(rectarrayname As String, Color As String, filled As String, strokewidth As String) As String
	Dim r As Rect
	Dim ra(0) As String
	ra = BlibGetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	TheCanvas.DrawRect(r, Color, filled, strokewidth)
	Return True
End Sub

''@N:DrawRectRotated(rectarrayname, color, filled, strokewidth, degrees) As returnvalue
''Draws a rotated rectangle from the points provided in a named array and a specified angle.
''Returns false if more or less than two  points are in the array otherwise returns true.
Sub DrawRectRotated(rectarrayname As String, Color As String, filled As String, strokewidth As String, degrees As String) As String
	Dim r As Rect
	Dim ra(0) As String
	ra = BlibGetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	TheCanvas.DrawRectRotated(r, Color, filled, strokewidth, degrees)
	Return True
End Sub

''@N:DrawText(text, x, y, textsize, textcolor, align)
''Draw text. Align is one of the following values: "LEFT", "CENTER", "RIGHT".
Sub DrawText(Text As String, x As String, y As String, textsize As String, Color As String, align As String)
	TheCanvas.DrawText(Text, x, y, TheTypeface, textsize, Color, align.ToUpperCase)
End Sub

''@N:DrawTextRotated(text, x, y, textsize, textcolor, align, degrees)
''Draw text. Align is one of the following values: "LEFT", "CENTER", "RIGHT".
Sub DrawTextRotated(Text As String, x As String, y As String, textsize As String, Color As String, align As String, degrees As String)
	TheCanvas.DrawTextRotated(Text, x, y, TheTypeface, textsize, Color, align.ToUpperCase, degrees)
End Sub


#End Region


#Region ImageView functions

''<a name="imageview"></a>
''@H:IMAGEVIEW AND SCALEIMAGEVIEW FUNCTIONS
''
''ImageView supports these functions in addition to the Shared View functions.

''@N:LoadImageViewBitmap(imageviewname)
''Assign the current Bitmap contents to the specified ImageView.
Sub LoadImageViewBitmap(imageviewname As String)
	Dim v As View
	v = ViewMapGet(imageviewname.ToLowerCase)
	If v.IsInitialized And v Is ImageView Then
		Dim i As ImageView
		i = v
		i.Bitmap = TheBitmap
	End If
End Sub

''@N:LoadImageView(imageviewname, dir, filename)
''Load an image into the specified ImageView using LoadBitmapResize.
''The image aspect ratio is maintained and the image is scaled to fit the ImageView.
''The gravity of the ImageView is set to CENTER.
Sub LoadImageView(imageviewname As String, dirname As String, filename As String)
	Dim v As View
	v = ViewMapGet(imageviewname.ToLowerCase)
	If v.IsInitialized And v Is ImageView Then
		Dim i As ImageView
		i = v
		i.Gravity  = Gravity_Center
		Dim bmp As Bitmap = LoadBitmapResize(dirname, filename, i.Width, i.Height, True)
		i.Bitmap = bmp		 
	End If
End Sub

''@N:LoadImageViewFill(imageviewname, dir, filename)
''Load an image into the specified ImageView using LoadBitmapResize.
''The image aspect ratio is not maintained and the image is stretched to fill the ImageView.
''The gravity of the ImageView is set to CENTER.
Sub LoadImageViewFill(imageviewname As String, dirname As String, filename As String)
	Dim v As View
	v = ViewMapGet(imageviewname.ToLowerCase)
	If v.IsInitialized And v Is ImageView Then
		Dim i As ImageView
		i = v
		i.Gravity  = Gravity_Center
		Dim bmp As Bitmap = LoadBitmapResize(dirname, filename, i.Width, i.Height, False)
		i.Bitmap = bmp
	End If
End Sub

''@N:SetImageViewGravity(imageviewname, dir, filename)
''Set the gravity of the ImageView. imggravity should be one of the Gravity constants.
Sub SetImageViewGravity(imageviewname As String, imggravity As String)
	Dim v As View
	v = ViewMapGet(imageviewname.ToLowerCase)
	If v.IsInitialized And v Is ImageView Then
		Dim i As ImageView
		i = v
		i.Gravity  = imggravity
	End If
End Sub

''
''
''ScaleImageView supports these functions in addition to the Shared View functions.

''@N:GetCenter(scaleimageviewname) As returnvalue
''Gets a comma separated string of the X and Y pixel values of the full image point which is at the centre of the view.
''This can only be set programatically by SetScaleAndCenter or SetScaleAndCenterPixels.
Sub GetCenter(scaleimageviewname As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.CenterX & "," & i.CenterY
	End If
	Return -1
End Sub

''@N:GetIsReady(scaleimageviewname) As returnvalue
''It takes a litle time to load an image.
''Gets whether the view Is initialised, has dimensions And will display an image.
''Returns True if the view is ready to display an image and accept touch gestures.
Sub GetIsReady(scaleimageviewname As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.IsReady
	End If
	Return -1
End Sub

''@N:GetScale(scaleimageviewname) As returnvalue
''Gets the present scale (zoom) level for the displayed image as set by the user.
''This can only be programmatically set by SetScaleAndCenter or SetScaleAndCenterPixels.
Sub GetScale(scaleimageviewname As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.Scale
	End If
	Return -1
End Sub

''@N:GetMaxZoom(scaleimageviewname) As returnvalue
''Gets the maximum zoom level for the displayed image. The default is 2.0.
''The minimum zoom is automatically set to fit the entire image to the view
Sub GetMaxZoom(scaleimageviewname As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.MaxZoom
	End If
	Return -1
End Sub

''@N:GetSrcHeight(scaleimageviewname) As returnvalue
''Get the original full-size height of the image in pixels.
''Note that this does not take any applied rotation into account.
Sub GetSrcHeight(scaleimageviewname As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.SrcHeight
	End If
	Return -1
End Sub

''@N:GetSrcWidth(scaleimageviewname) As returnvalue
''Get the original full-size width of the image in pixels.
''Note that this does not take any applied rotation into account.
Sub GetSrcWidth(scaleimageviewname As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.SrcHeight
	End If
	Return -1
End Sub

''@N:LoadScaleImageView(scaleimageviewname, dir, filename)
''Load an image from a file saved on the device file system into the view.
''This method can display JPG and PNG images of any size.
''In order to support huge images without running out of memory, a sub-sampled base layer is first loaded.
''Higher resolution tiles are loaded for the visible area as the user zooms in.
''This cannot load a file from FileDirAssets as ScaleImageView needs random access to the file while displaying it.
''An image file in FileDirAssets must be copied elsewhere to use it with a ScaleImageView.
Sub LoadScaleImageView(scaleimageviewname As String, dirname As String, filename As String)
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		If dirname.CharAt(dirname.Length-1) <> "/" Then dirname = dirname & "/"
		i.ImageFile = dirname & filename 
	End If
End Sub

''@N:Recycle(scaleimageviewname)
''Releases all resources the view is using and resets the state, nulling any fields that use significant memory.
''After you have called this method, the view can be re-used by setting a new image.
''Settings are remembered but state (scale and center) is forgotten.
Sub Recycle(scaleimageviewname As String)
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		i.Recycle
	End If
End Sub

''@N:SetMaxZoom(scaleimageviewname, maxzoom) 
''Sets the maximum zoom level for the displayed image. The default is 2.0.
''The minimum zoom is automatically set to fit the entire image to the view
Sub SetMaxZoom(scaleimageviewname As String, maxzoom As String)
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		i.MaxZoom = maxzoom
	End If
End Sub

''@N:SetPanLimit(scaleimageviewname, panlimit)
''Sets the image pan limit to one of the PAN_LIMIT values.
''PAN_LIMIT_INSIDE is 1. Don't allow the image to be panned off screen.
''As much of the image As possible Is always displayed, centered in the view when it Is smaller.
''PAN_LIMIT_OUTSIDE is 2, Allow the image to be panned until it is just off screen, but no further.
''The edge of the image will stop when it is flush with the screen edge.
''PAN_LIMIT_CENTER is 3.This is the default
''Allow the image to be panned until a corner reaches the center of the screen but no further.
''Useful when you need to pan any spot on the image to the exact center of the screen.
Sub SetPanLimit(scaleimageviewname As String, panlimit As String)
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		i.PanLimit = panlimit
	End If
End Sub

''@N:SetScaleAndCenter(scaleimageviewname, scale, x, y, duration) As returnvalue
''Set the scale (zoom) of the displayed image and center it on the point (x,y).
''x And y are width and height factor values of the full image size between 0 and 1.
''PanLimit should be set to PAN_LIMIT_CENTER if any point is to be centered.
''Duration sets the duration of the transition in milliseconds.
''Returns False if the image is not ready and the transition was not made otherwise True.
Sub SetScaleAndCenter(scaleimageviewname As String, scale As String, x As String, y As String, duration As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		' there is a bug in ScaleImageView where SetScaleAndCenter does not return a value like SetScaleAndCenterPixels does
		' so we synthesize it with the same check here because we won't fix the bug any time soon
		If Not(i.IsReady) Then Return False
		i.SetScaleAndCenter(scale, x, y, duration)
		Return True
	End If
	Return False
End Sub

''@N:SetScaleAndCenterPixels(scaleimageviewname, scale, x, y, duration) As returnvalue
''Set the scale (zoom) of the displayed image and center it on the point (x,y).
''x And y are full image size x And y pixel values.
''PanLimit should be set to PAN_LIMIT_CENTER if any point is to be centered.
''Duration sets the duration of the transition in milliseconds.
''Returns False If the image is not ready and the transition was not made otherwise True.
Sub SetScaleAndCenterPixels(scaleimageviewname As String, scale As String, x As String, y As String, duration As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Return i.SetScaleAndCenterPixels(scale, x, y, duration)
	End If
	Return False
End Sub

''@N:SourceXYtoViewXY(scaleimageviewname, sourcex, sourcey) As returnvalue
''Returns a comma separated string of the X and Y pixel position on the view of the specified point of the full size image.
''If the image coordinates are currently off screen, the view coordinates will also be outside the view
Sub SourceXYtoViewXY(scaleimageviewname As String, sourcex As String, sourcey As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Dim xy() As Float = i.SourceXYtoViewXY(sourcex, sourcey)
		Return NumberFormat2(xy(0), 1, 0, 0, False) & "," & NumberFormat2(xy(1), 1, 0, 0, False)
	End If
	Return False
End Sub

''@N:ViewXYtoSourceXY(scaleimageviewname, viewx, viewey) As returnvalue
''Returns a comma separated string of the X and Y pixel position on the full size image of the specified point of the view.
Sub ViewXYtoSourceXY(scaleimageviewname As String, viewx As String, viewy As String) As String
	Dim v As View
	v = ViewMapGet(scaleimageviewname.ToLowerCase)
	If v.IsInitialized And v Is ScaleImageView Then
		Dim i As ScaleImageView
		i = v
		Dim xy() As Float = i.ViewXYtoSourceXY(viewx, viewy)
		Return NumberFormat2(xy(0), 1, 0, 0, False) & "," & NumberFormat2(xy(1), 1, 0, 0, False)
	End If
	Return False
End Sub

#End Region


#Region ListView functions

''<a name="listview"></a>
''@H:LISTVIEW FUNCTIONS
''
''ListView supports these functions in addition to the Shared View and ListView and Spinner functions.

''@N:GetLabel(listviewname, labelname)
''Makes the ListView.SingleLineLayout.Label accessible as a Label view.
''The layout functions of the ListView items may be changed using the label functions.
Sub GetLabel(listviewname As String, labelname As String)
	Dim v As View
	v = ViewMapGet(listviewname.ToLowerCase)
	If v.IsInitialized And v Is ListView Then
		Dim l As ListView
		l = v
		ViewMap.Put(labelname, l.SingleLineLayout.Label)
	End If
End Sub

''@N:SetFastScrollEnabled(listviewname, scrollstate)
''Sets whether the fast scroll icon will appear when the user scrolls the list. The default Is False.
Sub SetFastScrollEnabled(name As String, state As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is ListView Then
		Dim l As ListView
		l = v
		l.FastScrollEnabled = state		
	End If
End Sub

''@N:SetItemHeight(listviewname, itemheight)
''Sets the ItemHeight of the SingleLineLayout in a ListView.
Sub SetItemHeight(name As String, height As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is ListView Then
		Dim l As ListView
		l = v
		l.SingleLineLayout.ItemHeight = height		
	End If
End Sub

''@N:SetLayoutBackgroundColor(listviewname, cornerradius, backgroundcolor)
''Set the ListView.SingleLineLayout.Background property of the ListView to a ColorDrawable.
Sub SetLayoutBackgroundColor(name As String, radius As String, Color As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is ListView Then
		Dim C As ColorDrawable
		C.Initialize(Color, radius)
		Dim l As ListView
		l.SingleLineLayout.Background = C
	End If
End Sub

''@N:SetLayoutBackgroundColorGradient(listviewname, orientation, cornerradius, colorsarrayname) As returnvalue
''Set the ListView.SingleLineLayout.Background property of the ListView to a GradientDrawable.
''Returns false if less than two colors are in the array or name not found otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right to Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right to Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left to Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left to Bottom-Right)
Sub SetLayoutBackgroundColorGradient(name As String, Orientation As String, radius As String, colorsarrayname As String) As String
	Dim cols(0) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	cols = BlibGetArray(colorsarrayname)
	If v.IsInitialized And v Is ListView And cols.Length >= 2 Then
		Dim l As ListView
		Dim G As GradientDrawable
		Dim colints(cols.Length) As Int
		For I = 0 To cols.Length - 1
			colints(I) = cols(I)
		Next
		G.Initialize(Orientation, colints)
		G.CornerRadius = radius
		l = v
		l.SingleLineLayout.Background = G
		Return True
	End If
	Return False
End Sub

''@N:SetScrollColor(listviewname, color)
''Sets the background color that will be used while scrolling the ListView.
Sub SetScrollColor(name As String, Color As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is ListView Then
		Dim l As ListView
		l = v
		l.ScrollingBackgroundColor = Color		
	End If
End Sub

#End Region


#Region ListView and Spinner functions

''<a name="listandspin"></a>
''@H:LISTVIEW AND SPINNER FUNCTIONS
''
''ListView and Spinner support these functions in addition to the Shared View and ListView and Spinner functions.

''@N:AddItem(viewname, item)
''Add an item to a ListView or Spinner.
Sub AddItem(name As String, item As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.Add(item)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.AddSingleLine(item)		
		End If
	End If
End Sub

''@N:AddAll(viewname, itemsarrayname)
''Add an array of items to a ListView or Spinner.
Sub AddAll(name As String, itemsarrayname As String)
	Dim v As View
	Dim ia(0) As String
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			ia = BlibGetArray(itemsarrayname)
			S.AddAll(ia)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			ia = BlibGetArray(itemsarrayname)
			For I = 0 To ia.Length - 1
				l.AddSingleLine(ia(I))
			Next
		End If
	End If
End Sub

''@N:Clear(viewname)
''Clears the items from a ListView or Spinner.
Sub Clear(name As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.Clear
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.Clear
		End If
	End If
End Sub

''@N:GetItemAt(viewname, index) As returnvalue
''Returns the item at the specified index from a ListView or Spinner.
''In earlier versions this was called GetItem but this conflicts with B4AScript intrinsic GeItem.
Sub GetItemAt(name As String, index As String) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			Return S.GetItem(index)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			Return l.GetItem(index)
		End If
	End If
	Return ""
End Sub

''@N:GetSize(viewname) As returnvalue
''Returns the number of items in a ListView or Spinner.
Sub GetSize(name As String) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			Return S.Size
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			Return l.Size
		End If
	End If
	Return -1
End Sub

''@N:RemoveAt(viewname, index)
''Removes the item at the specified index from a ListView or Spinner.
Sub RemoveAt(name As String, index As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.RemoveAt(index)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.RemoveAt(index)
		End If
	End If
End Sub

#End Region


#Region Phone functions

''<a name="phone"></a>
''@H:PHONE FUNCTIONS
''
''Functions that control certain aspects of the device behaviour.

''@N:KeepAlive(isactive, brightscreen)
''KeepAlive allows you to prevent the device from turning off the screen.
''Once you call KeepAlive(True, ...) the phone screen will stay on till you call KeepAlive(False, ...).
''BrightScreen is used with KeepAlive(True, ...) to determine whether to keep the screen bright or dimmed.
''It is important to eventually call KeepAlive(False, ...).
''The recommended usage is to call KeepAlive(True, ...) in Activity_Resume And call KeepAlive(False, ...) in Activity_Pause.
''Note that the user can still turn off the screen by pressing the power button.
Sub KeepAlive(isactive As String, brightscreen As String)
	If isactive Then
		ThePhoneWakeState.KeepAlive(brightscreen)
	Else
		ThePhoneWakeState.ReleaseKeepAlive
	End If
End Sub

''@N:PartialLock(isactive)
''Calling PartialLock(True) acquires a partial lock on the device.
''This will prevent the CPU from going to sleep, even if the user presses the power button.
''Make sure to call PartialLock(False) eventually to release this lock.
Sub PartialLock(isactive As String)
	If isactive Then
		ThePhoneWakeState.PartialLock
	Else
		ThePhoneWakeState.ReleasePartialLock
	End If
End Sub

''@N:Shell(command, argsarrayname) As returnvalue
''Runs a native shell command. Many commands are inaccessible because of OS security restrictions.
''Calling Shell will block the calling thread until the shell process completes.
''command - the command To run.
''argsarrayname - the name of an array containing additional arguments, pass an empty array if none.
''Returns the contents of the StdOut and StdErr streams of the process that ran the command as would be seen in a console.
Sub Shell(command As String, argsarrayname As String) As String
	Dim sb As StringBuilder
	Dim pargs() As String = Blib.GetArray(argsarrayname)
	sb.Initialize
	If pargs.Length = 0 Then
		ThePhone.Shell(command, Null, sb, sb)
	Else
		ThePhone.Shell(command, pargs, sb, sb)
	End If	
	Return sb.ToString
End Sub

''@N:ShellAsync(command, argsarrayname, callback, params) As returnvalue
''Runs a native shell command. Many commands are inaccessible because of OS security restrictions.
''Calling Shell will block the calling thread until the shell process completes.
''command - the command To run.
''argsarrayname - the name of an array containing additional arguments, pass an empty array if none.
''callback is the name of the Sub to be called when the shell command completes.
''paramsarrayname is the name of an array containing the parameter values to be passed back to the callback function.
''Returns stdOut in paramsarrayname(0), stdErr in paramsarrayname(1) and the process exit value in paramsarrayname(2)  
Sub ShellAsync(command As String, argsarrayname As String, callback As String, paramsarrayname As String)
	Dim sb As StringBuilder
	Dim pargs() As String = Blib.GetArray(argsarrayname)
	Dim params() As String = BlibGetArray(paramsarrayname)
	sb.Initialize
	If pargs.Length = 0 Then
		Wait For (ThePhone.ShellAsync(command, Null)) Complete (Success As Boolean, ExitValue As Int, StdOut As String, StdErr As String)
	Else
		Wait For (ThePhone.ShellAsync(command, pargs)) Complete (Success As Boolean, ExitValue As Int, StdOut As String, StdErr As String)
	End If
	params(0) = StdOut
	params(1) = StdErr
	params(3) = ExitValue
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:Vibrate(milliseconds)
''Causes the device to vibrate for the specified number of milliseconds.
Sub Vibrate(milliseconds As String)
	ThePhoneVibrate.Vibrate(milliseconds)
End Sub

#End Region


#Region Regex functions

''<a name="regex"></a>
''@H:REGULAR EXPRESSION FUNCTIONS
''
''Functions that enable the use of regular expressions.
''There is a single Matcher object that can be set by RegexMatcher and RegexMatcher2.
''The Matcher can be invoked using the MatcherXxxx functions.
''
''These pattern constants can optionally modify the regular expression match behaviour.
''They may be used instead of hard coding numeric values.
''These options can be combined by addition.
''
''@Regex_CaseInsensitive = 2
''@Regex_Multiline = 8

Sub Regex_Multiline As String
	Return  Regex.MULTILINE
End Sub

Sub Regex_CaseInsensitive As String
	Return Regex.CASE_INSENSITIVE
End Sub

''@N:RegexIsMatch(pattern, text) As returnvalue
''Tests whether the given text is a match for the given pattern and returns a Boolean value.
''The whole text should match the pattern. Use RegexMatcher if you are looking for a substring that matches the pattern.
''Example: If RegexIsMatch("\d\d\d", EditText1.Text) = False Then ...
''The Java code calls Pattern.matcher(Text).matches().
Sub RegexIsMatch(Pattern As String, Text As String) As String
	Return Regex.IsMatch(Pattern, Text)
End Sub

''@N:RegexIsMatch2(pattern, options, text) As returnvalue
''Same as RegexIsMatch with the additional pattern options.
''The Java code calls Pattern.matcher(Text).matches().
Sub RegexIsMatch2(Pattern As String, Options As String, Text As String) As String
	Return Regex.IsMatch2(Pattern, Options, Text)
End Sub


''@N:RegexMatcher(pattern, text)
''Sets the one Matcher object which can then be used to find matches of the given pattern in the text.
''Example:
''Text = "This is an interesting sentence with two numbers: 123456 and 7890."
''Pattern = "\d+" 'one or more digits
''RegexMatcher(Pattern, Text)
''Do While MatcherFind
''	msgbox("Found: " & MatcherMatch)
''Loop
''The Java code calls Pattern.matcher(Text).
Sub RegexMatcher(Pattern As String, Text As String)
	TheMatcher =  Regex.Matcher(Pattern, Text)
End Sub

''@N:RegexMatcher2(pattern, options, text)
''Same as RegexMatcher with the additional pattern options.
''The Java code calls Pattern.matcher(Text).
Sub RegexMatcher2(Pattern As String, Options As String, Text As String)
	TheMatcher =  Regex.Matcher2(Pattern, Options, Text)
End Sub

''@N:RegexReplace(pattern, text, template) As returnvalue
''Replaces all the matches in Text based on the specified Pattern And Template.
''Example:
''Msgbox(RegexReplace("\d", "1 2 3 4", "-$0-")) '-1- -2- -3- -4-
''Returns a new string with the replacements made.
''The Java code calls Pattern.matcher(Text).replaceAll(Template).
Sub RegexReplace(Pattern As String, Text As String, Template As String) As String
	Return Regex.Replace(Pattern, Text, Template)
End Sub

''@N:RegexReplace2(pattern, options, text, template) As returnvalue
''Same as RegexReplace with the additional pattern options.
''The Java code calls Pattern.matcher(Text).replaceAll(Template).
Sub RegexReplace2(Pattern As String, Options As String, Text As String, Template As String) As String
	Return Regex.Replace2(Pattern, Options, Text, Template)
End Sub

''@N:RegexSplit(arrayname, pattern, text)
''Splits the given Text around matches of the Pattern.
''Note that trailing empty matches will be removed.
''Example:
''Dim components() As String
''Regex.Split("components", ",", "abc,def,,ghi") : returns: "abc", "def", "", "ghi"
''Regex.Split("components, "\|", "abd|def||ghi") : the pipe needs to be escaped as it has special meaning in Regex.
''The results will be available in the specified array.
''The array does not need to be declared with Dim, if it does not already exist it will be created.
''A common mistake is to try to use a reference to the array, arrayname is the name of the array as a String.
''The Java code calls Pattern.split(Text).
Sub RegexSplit(ArrayName As String, Pattern As String, Text As String)
	Dim Splits() As String = Regex.Split(Pattern, Text)
	Blib.ShareArray(ArrayName, Splits)
End Sub

''@N:RegexSplit2(arrayname, pattern, options, text)
''Same as RegexSplit with the additional pattern options.
''The Java code calls Pattern.split(Text).
Sub RegexSplit2(ArrayName As String, Pattern As String, Options As String, Text As String)
	Dim Splits() As String = Regex.Split2(Pattern, Options, Text)
	Blib.ShareArray(ArrayName, Splits)
End Sub

''
''
''The following Matcher functions need to have set a Matcher by invoking RegexMatcher or RegexMatcher2.

''@N:MatcherFind As returnvalue
''Searches for the next sub-string that matches the pattern. Returns True if a match is found.
''The Java code calls Matcher.find().
Sub MatcherFind As String
	Return TheMatcher.Find
End Sub

''@N:MatcherGetEnd(index) As returnvalue
''Returns the end offset of the specified captured group.
''Use MatcherGetEnd(0) to get the end offset of the whole match.
''The Java code calls Matcher.end(index).
Sub MatcherGetEnd(Index As String) As String
	Return TheMatcher.GetEnd(Index)
End Sub

''@N:MatcherGetStart(index) As returnvalue
''Returns the start offset of the specified captured group.
''Use MatcherGetStart(0) to get the start offset of the whole match.
''The Java code calls Matcher.start(index).
Sub MatcherGetStart(index As String) As String
	Return TheMatcher.GetStart(index)
End Sub

''@N:MatcherGroup(index) As returnvalue
''Returns the value of the specified captured group.
''MatcherGroup(0) returns the whole match.
''The Java code calls Matcher.group(index).
Sub MatcherGroup(Index As String) As String
	Return TheMatcher.Group(Index)
End Sub

''@N:MatcherGroupCount As returnvalue
''Returns the number of capturing groups in the pattern.
''Note that the number returned does not include MatcherGroup(0) which is the whole match.
''The Java code calls Matcher.groupCount().
Sub MatcherGroupCount As String
	Return TheMatcher.GroupCount
End Sub

''@N:MatcherMatch As returnvalue
''Returns the matched value. This is the same as calling MatcherGroup(0).
''The Java code calls Matcher.group().
Sub MatcherMatch As String
	Return TheMatcher.Match
End Sub

#End Region


#Region ProgressBar functions

''<a name="progressbar"></a>
''@H:PROGRESSBAR FUNCTIONS
''
''ProgressBar supports these functions in addition to the Shared View functions.

''@N:GetIndeterminate(progressbarname) As returnvalue
''Returns the current ProgressBar Indeterminate state, True or False.
Sub GetIndeterminate(progressbarname As String) As String
	Dim v As View
	v = ViewMapGet(progressbarname.ToLowerCase)
	If v.IsInitialized And v Is ProgressBar Then
		Dim S As ProgressBar
		S = v
		Return S.Indeterminate
	End If
	Return False
End Sub

''@N:GetProgress(progressbarname) As returnvalue
''Returns the current ProgressBar Progress value between 0 and 100.
Sub GetProgress(progressbarname As String) As String
	Dim v As View
	v = ViewMapGet(progressbarname.ToLowerCase)
	If v.IsInitialized And v Is ProgressBar Then
		Dim S As ProgressBar
		S = v
		Return S.Progress
	End If
	Return -1
End Sub

''@N:SetIndeterminate(progressbarname, indeterminate)
''Sets the current ProgressBar Indeterminate state, either True or False.
Sub SetIndeterminate(progressbarname As String, indeterminate As String)
	Dim v As View
	v = ViewMapGet(progressbarname.ToLowerCase)
	If v.IsInitialized And v Is ProgressBar Then
		Dim S As ProgressBar
		S = v
		S.Indeterminate = indeterminate
	End If
End Sub

''@N:SetProgress(progressbarname, progress)
''Sets the current ProgressBar Progress value. Should be between 0 and 100.
Sub SetProgress(progressbarname As String, progress As String)
	Dim v As View
	v = ViewMapGet(progressbarname.ToLowerCase)
	If v.IsInitialized And v Is ProgressBar Then
		Dim S As ProgressBar
		S = v
		S.Progress = progress
	End If
End Sub

#End Region


#Region ScrollView functions

''<a name="scrollview"></a>
''@H:SCROLLVIEW FUNCTIONS
''
''Scrollviews support these functions in addition to the Shared View functions.
''Scrollview functions work on ScrollView, HorizontalScrollView and ScrollView2D.

''@N:AdoptPanel(scrollviewname, panelname)
''AddPanel is already in use to addd a new Panel view so we called this AdoptPanel instead.
''This adds panelname to the internal Panel of the ScrollView resizing the internal Panel to match.
''This allows a ScrollView Panel to be laid out in the Designer.
Sub AdoptPanel(scrollviewname As String, panelname As String)
	Dim v As View, p As Panel
	v = ViewMapGet(scrollviewname.ToLowerCase)
	p = ViewMapGet(panelname.ToLowerCase)	
	If v.IsInitialized And (v Is ScrollView Or v Is HorizontalScrollView Or v Is ScrollView2D) Then
		p.RemoveView
		If v Is ScrollView Then
			Dim S As ScrollView
			S = v
			S.Panel.Width = p.Width
			S.Panel.Height = p.Height
			S.Panel.AddView(p, 0, 0, p.Width, p.Height)
		Else If v Is HorizontalScrollView Then
			Dim H As HorizontalScrollView
			H = v
			H.Panel.Width = p.Width
			H.Panel.Height = p.Height
			H.Panel.AddView(p, 0, 0, p.Width, p.Height)
		Else
			Dim S2 As ScrollView2D
			S2 = v
			S2.Panel.Width = p.Width
			S2.Panel.Height = p.Height
			S2.Panel.AddView(p, 0, 0, p.Width, p.Height)
		End If
	End If
End Sub

''@N:FullScroll(scrollviewname, bottom)
''Scrolls the ScrollView to the top or bottom.
''True scrolls to the bottom, False scrolls to the top.
Sub FullScroll(scrollviewname As String, bottom As String)
	Dim v As View
	v = ViewMapGet(scrollviewname.ToLowerCase)
	If v.IsInitialized And (v Is ScrollView Or v Is HorizontalScrollView Or v Is ScrollView2D) Then
		If v Is ScrollView Then
			Dim S As ScrollView
			S = v
		S.FullScroll(bottom)
		Else If v Is HorizontalScrollView Then
			Dim h As HorizontalScrollView
			h = v
			h.FullScroll(bottom)
		Else
			Dim S2 As ScrollView2D
			S2 = v
			S2.FullScroll(2, bottom, False)
		End If
	End If
End Sub

''@N:GetPanel(scrollviewname, panelname)
''Makes the ScrollView Panel accessible as a named Panel View.
''The panel is the base ScrollView Panel, not one added by AdoptPanel. 
''You can add views directly to this Panel or by using SetParent.
Sub GetPanel(scrollviewname As String, panelname As String)
	Dim v As View
	v = ViewMapGet(scrollviewname.ToLowerCase)
	If v.IsInitialized And (v Is ScrollView Or v Is HorizontalScrollView Or v Is ScrollView2D) Then
		If v Is ScrollView Then
			Dim S As ScrollView
			S = v
			ViewMap.Put(panelname.ToLowerCase, S.Panel)
		Else If v Is HorizontalScrollView Then
			Dim h As HorizontalScrollView
			h = v
			ViewMap.Put(panelname.ToLowerCase, h.Panel)
		Else
			Dim S2 As ScrollView2D
			S2 = v
			ViewMap.Put(panelname.ToLowerCase, S2.Panel)
		End If
	End If
End Sub

''@N:GetScrollPosition(scrollviewname) As returnvalue
''Returns the current ScrollView ScrollPosition.
''For a ScrollView2D this is a comma separated string with the horizontal and then the vertical position.
Sub GetScrollPosition(scrollviewname As String) As String
	Dim v As View
	v = ViewMapGet(scrollviewname.ToLowerCase)
	If v.IsInitialized And (v Is ScrollView Or v Is HorizontalScrollView Or v Is ScrollView2D) Then
		If v Is ScrollView Then
			Dim S As ScrollView
			S = v
			Return S.ScrollPosition
		Else If v Is HorizontalScrollView Then
			Dim h As HorizontalScrollView
			h = v
			Return h.ScrollPosition
		Else
			Dim S2 As ScrollView2D
			S2 = v
			Return S2.HorizontalScrollPosition & "," & S2.VerticalScrollPosition
		End If
	End If
	Return -1
End Sub

''@N:SetScrollPosition(scrollviewname, position)
''Sets the current ScrollView, HorizontalScrollView or ScrollView2D scroll position.
''For a ScrollView2D position is a comma separated string with the horizontal and then the vertical position.
''For a ScrollView2D if position is a single integer it then sets only the horizontal position.
Sub SetScrollPosition(scrollviewname As String, value As String)
	Dim v As View
	v = ViewMapGet(scrollviewname.ToLowerCase)
	If v.IsInitialized And (v Is ScrollView Or v Is HorizontalScrollView Or v Is ScrollView2D) Then
		If v Is ScrollView Then
			Dim S As ScrollView
			S = v
			S.ScrollPosition = value
		Else If v Is HorizontalScrollView Then
			Dim h As HorizontalScrollView
			h = v
			h.ScrollPosition = value
		Else
			Dim S2 As ScrollView2D
			S2 = v
			Dim P() As String = Regex.Split(",", value)
			S2.HorizontalScrollPosition = P(0)
			If P.Length > 1 Then
				S2.VerticalScrollPosition = P(1)
			End If
		End If
	End If
End Sub

#End Region

#Region SeekBar functions

''<a name="seekbar"></a>
''@H:SEEKBAR FUNCTIONS
''
''SeekBar supports these functions in addition to the Shared View functions.

''@N:GetMax(seekbarname) As returnvalue
''Returns the current SeekBar Max value. The default is 100.
Sub GetMax(seekbarname As String) As String
	Dim v As View
	v = ViewMapGet(seekbarname.ToLowerCase)
	If v.IsInitialized And v Is SeekBar Then
		Dim S As SeekBar
		S = v
		Return S.Max
	End If
	Return -1
End Sub

''@N:GetValue(seekbarname) As returnvalue
''Returns the current SeekBar value. The minimum value is always zero.
Sub GetValue(seekbarname As String) As String
	Dim v As View
	v = ViewMapGet(seekbarname.ToLowerCase)
	If v.IsInitialized And v Is SeekBar Then
		Dim S As SeekBar
		S = v
		Return S.Value
	End If
	Return -1
End Sub

''@N:SetMax(seekbarname, maxvalue)
''Sets the current SeekBar Max value. The default is 100.
Sub SetMax(seekbarname As String, maxvalue As String)
	Dim v As View
	v = ViewMapGet(seekbarname.ToLowerCase)
	If v.IsInitialized And v Is SeekBar Then
		Dim S As SeekBar
		S = v
		S.Max = maxvalue
	End If
End Sub

''@N:SetValue(seekbarname, value)
''Sets the current SeekBar Value. Should be between 0 and Max.
Sub SetValue(seekbarname As String, value As String)
	Dim v As View
	v = ViewMapGet(seekbarname.ToLowerCase)
	If v.IsInitialized And v Is SeekBar Then
		Dim S As SeekBar
		S = v
		S.value = value
	End If
End Sub

#End Region


#Region Spinner functions

''<a name="spinner"></a>
''@H:SPINNER FUNCTIONS
''
''Spinner supports these functions in addition to the Shared View and ListView and Spinner functions.
''Spinner also supports SetTextColor.

''@N:GetSelectedIndex(spinnername) As returnvalue
''Returns the index of the selected item of a Spinner. Returns -1 if no item is selected.
Sub GetSelectedIndex(name As String) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Spinner Then
		Dim S As Spinner
		S = v	
		Return S.SelectedIndex
	End If
	Return -1
End Sub

''@N:GetSelectedItem(spinnername) As returnvalue
''Returns the the selected item of a Spinner. Returns "" if no item is selected.
Sub GetSelectedItem(name As String) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Spinner Then
		Dim S As Spinner
		S = v
		Return S.SelectedItem
	End If
	Return ""
End Sub

''@N:SetDropdownBackgroundColor(spinnername, color)
''Sets the dropdown background colour.
''The color should be set before adding items
Sub SetDropdownBackgroundColor(name As String, color As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized  And v Is Spinner Then
		Dim S As Spinner
		S = v
		S.DropdownBackgroundColor = color
	End If
End Sub

''@N:SetDropdownTextColor(spinnername, color)
''Sets the dropdown text colour.
''The color should be set before adding items
Sub SetDropdownTextColor(name As String, color As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized  And v Is Spinner Then
		Dim S As Spinner
		S = v
		S.DropdownTextColor = color
	End If
End Sub

''@N:SetSelectedIndex(spinnername, index)
''Selects the item at the specified index of a Spinner. Pass -1 if no item is selected.
Sub SetSelectedIndex(name As String, index As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Spinner Then
		Dim S As Spinner
		S = v
		S.SelectedIndex = index
	End If
End Sub

#End Region


#Region TabHost functions

''<a name="tabhost"></a>
''@H:TABHOST
''
''TabHost supports these functions in addition to the Shared View functions.

''@N:AddTab(tabpanelname, tabtitle, tabhostname)
''Add a Tab and a new associated Panel to a TabHost.
''The tabpanelname may be used to add views to the Tab.
Sub AddTab(tabpanelname As String, tabtitle As String, tabhostname As String)
	Dim v As View
	v = ViewMapGet(tabhostname.ToLowerCase)
	If v.IsInitialized And v Is TabHost Then
		Dim T As TabHost
		T = v
		Dim p As Panel
		p.Initialize("Panel")
		p.Tag = tabpanelname	
		ViewMap.Put(tabpanelname.ToLowerCase, p)	
		T.AddTab2(tabtitle, p)
	End If
End Sub

''@N:AddTabPanel(tabpanelname, tabtitle, tabhostname)
''Add a Tab and an existing Panel, that may already have a layout loaded, to a TabHost.
''The tabpanelname may still be used to add more views to the Tab.
Sub AddTabPanel(tabpanelname As String, tabtitle As String, tabhostname As String)
	Dim v As View
	v = ViewMapGet(tabhostname.ToLowerCase)
	If v.IsInitialized And v Is TabHost Then
		Dim T As TabHost
		T = v
		Dim p As Panel = ViewMapGet(tabpanelname.ToLowerCase)
		T.AddTab2(tabtitle, p)
	End If
End Sub


''@N:GetCurrentTab(tabhostname) As returnvalue
''Returns the index of the current tab page.
Sub GetCurrentTab(tabhostname As String) As String
	Dim v As View
	v = ViewMapGet(tabhostname.ToLowerCase)
	If v.IsInitialized And v Is TabHost Then
		Dim T As TabHost
		T = v
		Return T.CurrentTab
	End If
	Return -1
End Sub

''@N:GetTabCount(tabhostname) As returnvalue
''Returns the number of tab pages.
Sub GetTabCount(tabhostname As String) As String
	Dim v As View
	v = ViewMapGet(tabhostname.ToLowerCase)
	If v.IsInitialized And v Is TabHost Then
		Dim T As TabHost
		T = v
		Return T.TabCount
	End If
	Return -1
End Sub

''@N:SetCurrentTab(tabhostname, tabnumber)
''Selects the current tab page.
Sub SetCurrentTab(tabhostname As String, tabnumber As String)
	Dim v As View
	v = ViewMapGet(tabhostname.ToLowerCase)
	If v.IsInitialized And v Is TabHost Then
		Dim T As TabHost
		T = v
		T.CurrentTab = tabnumber
	End If
End Sub

#End Region


#Region Table functions

''<a name="table"></a>
''@H:TABLE
''
''Table supports these functions.
''Table also supports Left, Right, Top, Bottom, Width, Height and Visible.
''These primarily exist so that autoscaling and designer scripts will work on Table as well as regular views.

''@N:AddRow(tablename, itemsarrayname)
''Add a row of items to a table.
Sub AddRow(tablename As String, itemsarrayname As String)
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		Dim i() As String = BlibGetArray(itemsarrayname)
		T = v
		T.AddRow(i)
	End If
End Sub

''@N:GetCell(tablename, col, row) As returnvalue
''Returns the contrents of the cell at col and row in the table.
Sub GetCell(tablename As String, col As String, row As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Return T.GetCell(col, row)
	End If
	Return ""
End Sub

''@N:GetEnableSort(tablename) As returnvalue
''Gets whether the table will sort itself when a column header is clicked.
''The default for a table is True.
Sub GetEnableSort(tablename As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Return T.EnableSort
	End If
	Return False
End Sub

''@N:GetHeader(tablename, col) As returnvalue
''Returns the contents of the header of col in the table.
Sub GetHeader(tablename As String, col As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Return T.GetHeader(col)
	End If
	Return ""
End Sub

''@N:GetHeaders(tablename) As returnvalue
''Returns the contents of all the headers the table as a comma separated string.
Sub GetHeaders(tablename As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Dim H() As String = T.GetHeaders
		Dim HS As String = ""
		For i = 0 To H.Length - 1
			HS = HS  &  H(i) & ","
		Next
		HS = HS.SubString2(0, HS.Length-1)
	End If
	Return HS
End Sub

''@N:GetNumberOfRows(tablename) As returnvalue
''Returns the numbers of rows in tablename.
Sub GetNumberOfRows(tablename As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Return T.RowCount
	End If
	Return -1
End Sub

''@N:JumpToRow(tablename, row)
''Makes the given row visible by scrolling the table to it..
Public Sub JumpToRow(tablename As String, row As Int)
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		T.JumpToRow(row)
	End If	
End Sub

''@N:LoadTableFromCSV(tablename, dir, filename, headersexist) As returnvalue
''Clear the previous table and loads the CSV file to the table.
''Headersexist should be True if the first line in the CSV contains the header text for the table.
''SetHeaderTitles, if needed, and SetColumnWidths need to be called after LoadTableFromCSV as this resets the table to the defaults.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Public Sub LoadTableFromCSV(tablename As String, dir As String, filename As String, headersexist As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	Try
		If v Is Table2D Then
			Dim T As Table2D
			T = v
			T.LoadTableFromCSV(dir, filename, headersexist)
			Return ""
		End If
		Return tablename & " not found or not a Table."
	Catch
		Return LastException.Message
	End Try
End Sub

''@N:Refresh(tablename)
''Clear the table and re-initialize it empty with the specified number of columns.
Public Sub Refresh(tablename As String, columns As String)
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		T.Refresh
	End If
End Sub

''@N:ResizeTable(tablename, columns)
''Clear the table and re-initialize it empty with the specified number of columns.
Public Sub ResizeTable(tablename As String, columns As String)
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		T.ResizeTable(columns)
	End If
End Sub

''@N:RestoreData(tablename) As returnvalue
''Restore any saved data for tablename checking that the data exists and that the column count of data and table are equal.
''Returns True if the data is restored otherwise False.
Public Sub RestoreData(tablename As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Dim L As List = GlobalVarsMap.Get(tablename.ToLowerCase)
		If L = Null Then Return False
		If L.Size > 0 Then
			Dim S() As String = L.Get(0)
			If S.Length <> T.ColumnCount Then
				Return False
			End If		
		End If
		T.Data = L
		T.Refresh
		Return True
	End If
	Return False
End Sub

''@N:SaveData(tablename) As returnvalue
''Save the data for tablename in a Process Global so it can be restored when required.
''Note that this saves only the data in the rows of the table, not the headers column widths or number of columns.
''Nor does it save the sort type of each column. This needs to to be saved separately in some manner.
''Returns True if saved otherwise False.
Public Sub SaveData(tablename As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		GlobalVarsMap.Put(tablename.ToLowerCase, T.Data)
		Return True
	End If
	Return False
End Sub

''@N:SaveTableToCSV(tablename, dir, filename) As returnvalue
''Saves the table to a CSV file.
''The saved CSV file will include the column header texts.
''Returns an empty string if successful otherwise the exception message of the exception that was raised.
Public Sub SaveTableToCSV(tablename As String, dir As String, filename As String) As String
	Try
		Dim v As Object
		v = ViewMapGet(tablename.ToLowerCase)
		If v Is Table2D Then
			Dim T As Table2D
			T = v
			T.SaveTableToCSV(dir, filename)
			Return ""
		End If
		Return tablename & " not found or not a Table."
	Catch
		Return LastException.Message
	End Try
End Sub


''@N:SetEnableSort(tablename, sortstate)
''Sets whether the table will sort itself when a column header is clicked.
''The default for a table is True.
Sub SetEnableSort(tablename As String, sortstate As String)
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		T.EnableSort = sortstate
	End If
End Sub

''@N:SetColSortType(tablename, column, sortnumeric)
''Sets the type of sort for a column.  sortnumeric False is alphabetic, True is numeric.
''The default sort type for all columns is alphanumeric.
Sub SetColSortType(tablename As String, column As String, numeric As String)
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		T.SetColSortType(column, numeric)
	End If
End Sub

''@N:SetColumnWidths(tablename, widths) As returnvalue
''Sets the individual column widths.
''Widths is a comma separated string of the widths of each column inpixels and should be scaled from dips using g_scale.
''Returns False if the number of header items is not the same as number of columns otherwise returns True.
Sub SetColumnWidths(tablename As String, widths As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Dim h() As String = Regex.Split(",", widths)
		Dim hn(h.Length) As Int
		For i = 0 To h.Length - 1
			hn(i) = h(i)
		Next		
		Return T.SetColumnWidths(hn)
	End If
	Return False
End Sub

''@N:SetHeaders(tablename, headers) As returnvalue
''Sets the text of the headers in the table.
''Headers is a comma separated string of the text of each header.
''Returns False if the number of header items is not the same as number of columns otherwise returns True.
Sub SetHeaders(tablename As String, headers As String) As String
	Dim v As Object
	v = ViewMapGet(tablename.ToLowerCase)
	If v Is Table2D Then
		Dim T As Table2D
		T = v
		Dim h() As String = Regex.Split(",", headers)
		Return T.SetHeaders(h)
	End If
	Return False
End Sub

#End Region


#Region TextView functions

''<a name="textview"></a>
''@H:TEXTVIEW FUNCTIONS
''
''Views containing text support these functions in addition to the Shared View functions.

''@N:CreateTypeface(typeface, style)
''There is one Typeface but it can be reinitialised as required.
''The Typeface constants below may be used, or use the following case-insensitive values.
''Typeface - "Default", "Monospace", "Serif", "Sans_Serif"
''Style - 0 Normal : 1 Bold : 2 Italic : 3 Bold_Italic
Sub CreateTypeface(face As String, style As String)
	face = face.ToLowerCase
	If face = "monospace" Then
		TheTypeface = Typeface.CreateNew(Typeface.MONOSPACE, style)
	Else If face = "serif" Then
		TheTypeface = Typeface.CreateNew(Typeface.SERIF, style)
	Else If face = "sans_serif" Then
		TheTypeface = Typeface.CreateNew(Typeface.SANS_SERIF, style)
	Else
		TheTypeface = Typeface.CreateNew(Typeface.DEFAULT, style)
	End If
End Sub

''@N:GetText(viewname) As returnvalue
''Get the Text property, if any, of the named view.
''For a ToggleButton will return the text appropriate for the state of the button.
Sub GetText(name As String) As String
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Label Then
		Dim l As Label
		l = v
		Return l.Text
	End If
	Return ""
End Sub

''@N:SetGravity(viewname, gravity)
''Set the Gravity property, if any, of the named view.
''The Gravity constants may be used'
''Gravity_None, Gravity_Top, Gravity_Bottom, Gravity_Left, Gravity_Right, Gravity_Center
''Gravity_CenterHorizontal or Gravity_HCenter, Gravity_CenterVertical or Gravity_VCenter, Gravity_Fill
''or use the following numeric values.
''NO_GRAVITY = 0; TOP = 48 (0x30) ; BOTTOM = 80 (0x50; LEFT = 3; RIGHT = 5; CENTER = 17 (0x11)
''CENTER_HORIZONTAL = 1; CENTER_VERTICAL = 16 (0x10) ; FILL = 119 (0x77)
Sub SetGravity(name As String, gravityvalue As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Label Then
		Dim l As Label
		l = v
		l.Gravity = gravityvalue			
	End If
End Sub

''@N:SetText(viewname, text)
''Set the Text property, if any, of the named view.
''Although this will set the displayed text of a ToggleButton when the state changes
''the text set by SetTextOff/On appropriate to the state of the button will be displayed.
Sub SetText(name As String, Text As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Label Then
		Dim l As Label
		l = v
		l.Text = Text			
	End If
End Sub

''@N:SetTextColor(viewname, color)
''Set the TextColor property, if any, of the named view.
''This works for Label, Buttons etc. as well as Spinner
Sub SetTextColor(name As String, Color As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Label Then
		Dim l As Label
		l = v
		l.TextColor = Color
	else if v Is Spinner Then
		Dim s As Spinner
		s = v
		s.TextColor = Color
	End If	
End Sub

''@N:SetTextSize(viewname, size)
''Set the TextSize property, if any, of the named view.
''This works for Label, Buttons etc. as well as Spinner
Sub SetTextSize(name As String, size As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Label Then
		Dim l As Label
		l = v
		l.TextSize = size
	else	If v.IsInitialized And v Is Spinner Then
		Dim s As Spinner
		s = v
		s.TextSize = size
	End If
End Sub

''@N:SetTypeface(viewname)
''Set the Typeface property, if any, of the named view to the current typeface.
Sub SetTypeface(name As String)
	Dim v As View
	v = ViewMapGet(name.ToLowerCase)
	If v.IsInitialized And v Is Label Then
		Dim l As Label
		l = v
		l.Typeface = TheTypeface	
	End If
End Sub

' ''@N:TextHeight(viewname, text) As returnvalue
'	''Calculates the height of the text in a label or edittext.
'
'	Sub TextHeight(name As String, text As String) As String
'		Dim su As StringUtils
'		Dim v As View
'		v = ViewMapGet(name.ToLowerCase)
'		If Not(v.IsInitialized) Then Return -1
'		If Not(v Is Label) Then Return -1
'		Dim lbl As Label
'		lbl = v
'		Return su.MeasureMultilineTextHeight(lbl, text)
'	End Sub


#End Region


#Region Timer functions

''<a name="timer"></a>
''@H:TIMER FUNCTIONS
''
''There is one timer and the Timer Tick events are vectored to "Sub timer_tick".

''@N:SetTimerEnabled(enabled)
''Enable or disable the Timer.
''The Timer is automatically disabled on activity pause and, if it was running when paused, re-enabled on activity resume.
Sub SetTimerEnabled(enabled As String)
	Timer1.enabled = enabled
End Sub

''@N:SetTimerInterval(interval)
''Set the timer interval in milliseconds.
Sub SetTimerInterval(interval As String)
	Timer1.interval = interval
End Sub

'Call the script "Sub timer_tick" when the timer Tick event is raised 
Sub Timer_Tick
	If Blib.CanCall("timer_tick") Then
		Blib.Call("timer_tick", Null)
	End If
End Sub

#End Region


#Region User Interaction Functions

''<a name="user"></a>
''@H:USER INTERACTION FUNCTIONS
''
''These functions are implemented using modal dialogs.
''While the dialogs are shown only messages that draw the UI are processed.
''Most other events cannot be raised while a modal dialog is shown.
''The use of modal dialogs may cause exceptions in some circumstances.
''Their use is deprecated for all but the most trivial programs where exceptions would merely be an annoyance.
''See the description under Async Functions for the later Async implementation of dialogs which avoids modality.
''
''Many dialogs offer a choice of three buttons whose text can be customised.
''  positive - The text to show For the "positive" button. Pass "" to hide the button.
''  cancel - The text to show For the "cancel" button. Pass "" to hide the button.
''  negative - The text to show For the "negative" button. Pass "" to hide the button.

''@N:CallDoEvents
''Allow the message loop to run, lets views repaint themselves.
Sub CallDoEvents
	DoEvents
End Sub

''@N:Dialog reponse codes
''These values returned from dialogs indicate the user's response.
''
''@DialogResponse_Positive
''@DialogResponse_Cancel
''@DialogResponse_Negative
Sub DialogResponse_Positive As String
	Return DialogResponse.POSITIVE
End Sub

Sub DialogResponse_Cancel As String
	Return DialogResponse.CANCEL
End Sub

Sub DialogResponse_Negative As String
	Return DialogResponse.NEGATIVE
End Sub
''
''These dialogs allow interaction with the user.

''@N:GetInput As returnvalue
''Get the user input from the latest InputBox, InputDate or InputTime modal dialog.
Sub GetInput As String
	Return input
End Sub

''@N:InputBox(prompt, title) As returnvalue
''Show a modal dialog box and prompt the user for data.
''The dialog will show one OK button.
''prompt is displayed below the title and can be used to give a hint to the user.
''title is displayed at the top of the dialog.
''inputtype is set to Type_Text
''Does not return a DialogResponse value, instead returns the input text which is also available by calling GetInput.
Sub InputBox(prompt As String, title As String) As String
	Dim I As InputDialog
	Dim response As String
	I.InputType = Type_Text
	response = I.Show(prompt, title, "OK", "", "", Null)
	input = I.input
	Return input
End Sub

''@N:InputBox2(prompt, title, positive, cancel, negative, inputtype) As returnvalue
''Show a modal dialog box and prompt the user for data.
''prompt is displayed below the title and can be used to give a hint to the user.
''title is displayed at the top of the dialog.
''inputtype sets the value of the InputBox InputType property and must be one of the InputBox type codes
''Returns a DialogResponse value with the input text available by calling GetInput.
Sub InputBox2(prompt As String, title As String, Positive As String, Cancel As String, Negative As String, Inputtype As String) As String
	Dim I As InputDialog
	Dim response As String
	I.InputType = Inputtype
	response = I.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = I.input
	Return response
End Sub

''@N:InputBox InputType codes
''
''@Type_Decimal - Signed decimal value including a decimal point
''@Type_Integer - Unsigned integer value
''@Type_SignedInteger - Signed integer value
''@Type_Phone - Any characters valid in a US phone number
''@Type_Text - Normal text- the default
Sub Type_Decimal As String
	Return 8192 + 4096 + 2
End Sub

Sub Type_Integer As String
	Return 2 
End Sub

Sub Type_SignedInteger As String
	Return 4096 + 2
End Sub

Sub Type_Phone As String
	Return 3
End Sub

Sub Type_Text As String
	Return 1
End Sub

''@N:InputCustom(viewname, title, positive, cancel, negative) As returnvalue
''Allows a custom dialog to be presented to the user.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''viewname - the name of a single view to display in the dialog, most probably a panel
''title - the text in the dialog's title bar.
''Returns a DialogResponse value.
''Example:
''REM first add your panel.
''AddPanel("mypanel", 0, 0, pwidth, pheight, "")
''REM change the panel background colour if required
''SetColor("mypanel", 0, cLightGray)
''REM next, add all the desired views to the panel like this
''AddLabel("mylabel", 0, 0, 60 * g_scale, 30 * g_scale, "mypanel")
''SetText("mylabel", "label text")
''REM now remove the panel from the activity
''RemoveView("mypanel")
''REM now call InputCustom
''sel = InputCustom("mypanel","A Title", "Yes", "Cancel", "No")
Sub InputCustom(name As String, title As String, positive As String, cancel As String, negative As String) As String
	Dim v As View
	Dim ret As Int
	v = ViewMapGet(name.ToLowerCase)
	If Not(v.IsInitialized) Then
		 Return DialogResponse.cancel
	End If
	v.RemoveView		'just in case we forgot to in b4script code
	Dim vis As Boolean
	vis = v.Visible	
	If Not(vis) Then 'if panel hidden, unhide to show in the dialog then hide again after
		v.Visible = True
	End If
	Dim cd As CustomDialog2
	cd.AddView(v, v.Width, v.Height)
	ret = cd.Show(title, positive, cancel, negative, Null)
	v.Visible = False
	Return ret
End Sub

''@N:InputDate(prompt, title, startdateticks, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user for a date.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''InputDate will not display correctly in landscape mode on most devices.
''In this case InputDate2 can be used instead.
''Returns a DialogResponse value with the input value avalable to GetInput as a ticks value.
Sub InputDate(prompt As String, title As String, startdateticks As String, Positive As String, Cancel As String, Negative As String) As String
	Dim d As DateDialog
	Dim response As String
	d.DateTicks = startdateticks 
	response = d.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = d.DateTicks
	Return response
End Sub

''@N:InputDate2(title, startyear, endyear, showdate, showmonth, showyear, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user for a date. 
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Day and month numbers start at 1.
''This is simplistic allowing 31 days every month as we can't manipulate a modal dialog once it is shown.
''This does a rough check for validity, suffixing the GetInput value with "?" if the day number is too big for the month
''Returns a DialogResponse value with the 'dd/MM/yyyy' value available to GetInput as a string
Sub InputDate2(title As String, StartYear As String, EndYear As String, DateShown As String, MonthShown As String, YearShown As String, Positive As String, Cancel As String, Negative As String) As String
	Dim daysinmonth() As Int = Array As Int(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
	Dim T As DateDialog2
	T.Initialize(StartYear, EndYear)
	Dim response As String
	T.Day = DateShown
	T.Month = MonthShown
	T.Year = YearShown 
	response = T.Show(title, Positive, Cancel, Negative)
	input = NumberFormat(T.Day, 2, 0) & "/" & NumberFormat(T.Month, 2, 0) & "/" & T.Year
	Dim days As Int = daysinmonth(T.Month-1)
	If T.Month = 2 And T.Year Mod 4 = 0 Then 'Feb and leap year
		days = 29
	End If
	If T.Day > days Then input = input & "?"	
	Return response
End Sub

''@N:InputFile(filepath, filename, filefilter, title, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user for a path or file name.
''The colour of the text in the dialog can be specified with SetInputFileColor.
''The size of the text in the dialog can be specified with SetInputTextSize.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Returns a DialogResponse value with the input values available to GetInput as a comma separated string.
''The first part is the file path and the last part is file name. If the user selected a path the file name is an  empty string.
Sub InputFile(filepath As String, filename As String, filefilter As String, title As String, Positive As String, Cancel As String, Negative As String) As String
	Dim F As FileDialog	
	Dim response As String
	F.TextColor = InputFileColor
	If InputFileTextSize > 0 Then F.TextSize = InputFileTextSize
	F.filepath = filepath
	F.ChosenName = filename
	F.filefilter = filefilter
	response = F.Show(title, Positive, Cancel, Negative, Null)
	input = F.filepath & "," & F.ChosenName
	Return response	
End Sub

''@N:SetInputFileColor(color As String)
''Set the colour used for the text of the InputFile and AsyncInputFile dialogs
Sub SetInputFileColor(color As String)
	InputFileColor = color
End Sub

''@N:SetInputFileTextSize(size As String)
''Set the size of the displayed text of the InputFile and AsyncInputFile dialogs as "scaled pixel" units. 
''This size is adjusted based on the current Density and user font size preference.
''To return to the default value set this to 0.
Sub SetInputFileTextSize(size As String)
	InputFileTextSize = size
End Sub

''@N:InputListBox(itemarrayname, title, selecteditem) As returnvalue
''Show a modal dialog box and prompt the user to select an item.
''selecteditem is the index of the item that will first be selected or -1 if no item should be preselected.
''Returns the index of the selected item or DialogResponse_Cancel if the user pressed on the back key.
Sub InputListBox(itemarrayname As String, title As String, selecteditem As String) As String
	Dim l As List
	l.Initialize
	Dim ia(0) As String
	ia = BlibGetArray(itemarrayname)
	For I = 0 To ia.Length - 1
		l.Add(ia(I))
	Next
	Return InputList(l, title, selecteditem)
End Sub

''@N:InputMultiListBox(itemarrayname, title) As returnvalue
''Show a modal dialog box and prompt the user to select one or more items.
''Returns a comma separated list of indices selected that may be separated with StrSplit.
''Returns an empty string ("") if the Back button was pressed or no items were selected.
Sub InputMultiListBox(itemarrayname As String, title As String) As String
	Dim l As List
	Dim ret, comma As String
	l.Initialize
	Dim ia(0) As String
	ia = BlibGetArray(itemarrayname)
	For I = 0 To ia.Length - 1
		l.Add(ia(I))
	Next
	l = InputMultiList(l, title)
	ret = ""
	comma = ""
	For I = 0 To l.Size - 1
		ret = ret & comma & l.Get(I)
		comma = ","
	Next
	Return ret
End Sub

''@N:InputNumber(showsign, digits, number, title, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user for an integer number.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''If ShowSign is True the sign of the number corresponds to the sign entered by the user.
''Returns a DialogResponse value with the input number available to GetInput.
Sub InputNumber(showsign As String, digits As String, number As String, title As String, Positive As String, Cancel As String, Negative As String) As String
	Dim n As NumberDialog
	Dim response As String
	n.showsign = showsign
	n.digits = digits
	n.number = number
	response = n.Show(title, Positive, Cancel, Negative, Null)
	input = n.number
	Return response	
End Sub

''@N:InputTime(prompt, title, starttimeticks, as24hours, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user for a time.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Due to an Android bug InputTime will not display correctly in landscape mode on most devices.
''In this case InputTime2 can be used instead.
''Returns a DialogResponse value with the input value available to GetInput as a ticks value.
Sub InputTime(prompt As String, title As String, starttimeticks As String, as24hrs As String, Positive As String, Cancel As String, Negative As String) As String
	Dim T As TimeDialog
	Dim response As String
	T.TimeTicks = starttimeticks
	T.Is24Hours = as24hrs
	response = T.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = T.TimeTicks
	Return response
End Sub

''@N:InputTime2(prompt, title, showhour, showminute, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user for a time. The time is always in 24 hour format.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Returns a DialogResponse value with the time available to GetInput as a string formatted as 'HH:mm'.
''The literal string result avoids issues with Daylight Saving Time if ticks were used and Time used to parse it.
''InputTime appears to massage its ticks value to suit the present DST setting so Time can be used to parse its return.
Sub InputTime2(title As String, HourShown As String, MinuteShown As String, Positive As String, Cancel As String, Negative As String) As String
	Dim T As TimeDialog2
	T.Initialize
	Dim response As String
	T.Hour = HourShown
	T.Minute = MinuteShown
	response = T.Show(title, Positive, Cancel, Negative)
	input = T.Hour & ":" & T.Minute
	Return response
End Sub

''@N:MessageBox(msg, title)
''Show a modal message box with the specified message and title.
''The dialog will show one OK button.
''MessageBox does not return a DialogResponse value.
''The intrinsic Msgbox is similar but the title parameter is optional.
Sub MessageBox(message As String, title As String) 
	Msgbox(message, title)
End Sub

''@N:MessageBox2(message, title, positive, cancel, negative) As returnvalue
''Show a modal dialog box and prompt the user to make a selection.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Returns a DialogResponse value.
Sub MessageBox2(message As String, title As String, Positive As String, Cancel As String, Negative As String) As String
	Dim response As String
	response = Msgbox2(message, title, Positive, Cancel, Negative, Null)
	Return response	
End Sub

''@N:ProgressHide
''Hide a non-modal progress dialog.
Sub ProgressHide
	ProgressDialogHide
End Sub

''@N:ProgressShow(text, usercancel)
''Show a non-modal progress dialog.
''Shows a dialog with a circular spinning bar and the specified text.
''Unlike Msgbox And InputList methods, the code will not block.
''You should call ProgressDialogHide to remove the dialog.
''If usercancel is True The dialog will also be removed If the user presses on the Back key.
Sub ProgressShow(text As String, usercancel As String)
	ProgressDialogShow2(text, usercancel)
End Sub

''@N:ShowToast(message, longduration)
''Shows a toast message. Setting longduration to true will cause the toast message to stay on the screen longer.
Sub ShowToast(msg As String, longtime As String)
	ToastMessageShow(msg, longtime)
End Sub

#End Region


#Region Async Functions

''<a name="async"></a>
''@H:ASYNC USER INTERACTION FUNCTIONS
''
''These functions expose non-modal equivalents to the modal dialogs as well as the asynchronous Sleep.
''
''In later versions of B4A DoEvents and modal dialogs are deprecated and Sleep and non-modal dialogs are recommended.
''DoEvents shares the same low level mechanism as the modal dialogs implementation.
''This modality mechanism can lead to stability issues with later versions of Android which have more complex message processing. 
''The purpose of the modality mechanism was to allow the UI to be updated while the Main thread is busy.
''It accesses the process message queue and runs some of the waiting messages.
''As Android evolved, the handling of the message queue became more sophisticated and fragile.
''The reasons for deprecating DoEvents and modal dialogs (such as Msgbox And InputList) are:
''  1. It is a major source of instability issues. It can lead to hard to debug crashes or ANR (Application Not Responding) dialogs.
''  2. There are better ways to keep the Main thread free. For example use the asynchronous SQL methods instead of the synchronous methods.
''  3. It doesn't do what many developers expect it to do as it only handles UI related messages. Most events are not be raised from a modal call.
''It is now possible to call Sleep or an async dialog to pause the current sub and resume it after the waiting messages are processed.
''The non-modal mechansim is completely different from the modality mechanism.
''It doesn't block the thread and pump only some messages, instead it preserves the sub state and returns to the message loop.
''Unlike the modal mechanism with non-modality all messages will be processed and other events will be raised.
''With that said, DoEvents and modal dialogs are still there and existing applications will work exactly as before but may have problems.
''
''All the Async functions below return immediately to the calling Sub having set up the sleep or dialog to be run by the messsage loop.
''Unlike in B4A further program statements can follow the Async call and will be immediately executed.
''Once the calling Sub, and any in a call chain that invoked it, returns the message loop will then process the sleep or dialog.
''When the sleep time has elapsed or the dialog is closed then the message loop will invoke the callback Sub with the specified parameters.
''If the callback does not exist then no error is raised.
''It can be occasionally useful to pass, say, an empty string when a callback is not required.
''
''The Async functions parameter lists are an extension of those of their modal counterparts.
''Each function usually has three extra parameters, MsgboxAsync has two.
''  cancellable - if True then the dialog can be cancelled by clicking on the back key or outside the dialog.
''  callback - the name of the Sub to be called when the dialog is dismissed or the sleep expires.
''  paramsarrayname - the name of an array containing the parameter values to be passed to the callback function.
''Where an input value is available by GetInput from a modal dialog it is also available to the non-modal counterpart.
''
''Many dialogs offer a choice of three buttons whose text can be customised.
''  positive - the text to show For the "positive" button. Pass "" to hide the button.
''  cancel - the text to show For the "cancel" button. Pass "" to hide the button.
''  negative - the text to show For the "negative" button. Pass "" to hide the button.
''
''The examples in asynctest.b4s in the BasicIDE Script folder show how asynchronous dialogs and sleep can be implemented.
''You may need to keep what would be local values in global variables or arrays as local variable values will be lost.
''The paramsarrayname parameter array may be used to hold local values that will be returned to the callback Sub.
''The paramsarrayname array should be declared with the same number of elements as there are parameters in the callback Sub.
''Except for AsyncMsgbox paramsarrayname(0) will always be overwritten to pass a DialogResponse or value to the callback Sub.
''As there may be more than one outstanding callback at any one time care should be taken when reusing a parametername array.
''As a convenience if the callback Sub takes no or only the result parameter then an empty string may be passed as paramsarrayname.
''If no callback Sub is required then an empty string may be passed as callback.

''@N:AsyncInputBox(prompt, title, callback, paramsarrayname)
''Show a modal dialog box and prompt the user for data.
''The dialog will show one OK button.
''title is displayed at the top of the dialog.
''prompt is displayed below the title and can be used to give a hint to the user.
''The value of the InputBox InputType property is set to Type_Text.
''The callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Does not return a DialogResponse value, instead returns the input in paramsarrayname(0) which is also available by calling GetInput.
Sub AsyncInputBox(prompt As String, title As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim ID As InputDialog
	ID.InputType = Type_Text
	Dim o As Object = ID.ShowAsync(prompt, title, "OK", "", "", Null, True)
	Wait For (o) Dialog_Result(Result As Int)
	params(0) = ID.input
	input = ID.input
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputBox2(prompt, title, positive, cancel, negative, inputtype, cancellable, callback, paramsarrayname)
''Show a modal dialog box and prompt the user for data.
''title is displayed at the top of the dialog.
''prompt is displayed below the title and can be used to give a hint to the user.
''inputtype sets the value of the InputBox InputType property and must be one of the InputBox type codes
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''The cancellable, callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Returns a DialogResponse value in paramsarrayname(0) with the input value available to GetInput as a string
Sub AsyncInputBox2(prompt As String, title As String, Inputtype As String, Positive As String, Cancel As String, Negative As String,  _
			cancellable As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim ID As InputDialog
	ID.InputType = Inputtype
	Dim o As Object = ID.ShowAsync(prompt, title, Positive, Cancel, Negative, Null ,cancellable)
	Wait For (o) Dialog_Result(Result As Int)
	params(0) = Result
	input = ID.input
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''
''@Type_Decimal - Signed decimal value including a decimal point
''@Type_Integer - Unsigned integer value
''@Type_SignedInteger - Signed integer value
''@Type_Phone - Any characters valid in a US phone number
''@Type_Text - Normal text- the default

''@N:AsyncInputCustom(viewname, title, positive, cancel, negative, cancellable, callback, paramsarrayname) 
''Show a non-modal custom dialog. 
''viewname, probably a Panel though there is no check for this, is the name of the view to be displayed by the custom dialog.
''title is displayed at the top of the dialog.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''The cancellable, callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Returns a DialogResponse value to the callback function in paramsarrayname(0) 
''Other results can be retrieved from the views on the displayed Panel
''Example:
''REM first add your panel.
''AddPanel("mypanel", 0, 0, pwidth, pheight, "")
''REM change the panel background colour if required
''SetColor("mypanel", 0, cLightGray)
''REM next, add all the desired views to the panel like this
''AddLabel("mylabel", 0, 0, 60 * g_scale, 30 * g_scale, "mypanel")
''SetText("mylabel", "label text")
''REM now remove the panel from the activity
''RemoveView("mypanel")
''REM now call InputCustom
''Dim param(1)
''AsyncInputCustom('mypanel', 'The Title' 'Yes', 'Cancel', 'No', True, 'callbacksubname', 'param')
Sub AsyncInputCustom(viewname As String, title As String, positive As String, cancel As String, negative As String,  _
			cancellable As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim v As View
	v = ViewMapGet(viewname.ToLowerCase)
	If Not(v.IsInitialized) Then
		 Return
	End If
	v.RemoveView 'just in case we forgot to in b4script code
	Dim vis As Boolean
	vis = v.Visible 
	If Not(vis) Then 'if panel hidden, unhide to show in the dialog then hide again after
		 v.Visible = True
	End If
	Dim cd As CustomDialog2
	cd.AddView(v, v.Width, v.Height)
	Dim o As Object = cd.ShowAsync(title, positive, cancel, negative, Null, cancellable)
	Wait For (o) Dialog_Result(Result As Int)
	v.Visible = False
	params(0) = Result
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputDate2(title, startyear, endyear, showdate, showmonth, showyear, positive, cancel, negative, cancellable, callback, paramsarrayname)
''Show a non-modal dialog box and prompt the user for a date. 
''title is displayed at the top of the dialog.
''startyear and endyear determine the available year range.
''showdate, showmonth and showyear specify the date selected when the dialog is shown.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''The cancellable, callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Day and month numbers start at 1.
''Returns a DialogResponse value in paramsarrayname(0) with the 'dd/MM/yyyy' value available to GetInput as a string
''The advantage of this over the modal InputDate2 is that the number of days are dynamically adjusted according to the selected month and year.
Sub AsyncInputDate2(title As String, StartYear As String, EndYear As String, DateShown As String, MonthShown As String, YearShown As String, _
			Positive As String, Cancel As String, Negative As String, cancellable As String, callback As String, paramsarrayname As String)
	' copy the parameter array contents
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim DD As DateDialog2
	DD.Initialize(StartYear, EndYear)
	DD.Day = DateShown
	DD.Month = MonthShown
	DD.Year = YearShown
	Dim o As Object = DD.ShowAsyncComplete(title, Positive, Cancel, Negative, cancellable)
	Wait For (o) Complete(response As Int)
	input = NumberFormat(DD.Day, 2, 0) & "/" & NumberFormat(DD.Month, 2, 0) & "/" & DD.Year
	params(0) = response
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputFile(filepath, filename, filefilter, title, positive, cancel, negative, cancellable, callback, paramsarrayname)
''Show a modal dialog box and prompt the user for a path or file name.
''title is displayed at the top of the dialog.
''The colour of the text in the dialog can be specified with SetInputFileColor.
''The size of the text in the dialog can be specified with SetInputTextSize.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''The cancellable, callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Gets or sets the filter values of the dialog.
''The filter can be a single value ".txt" or a comma separated list of values ".jpg,.png".
''Note that spaces in filter values are significant and are not ignored.
''If a filename contains the text of a filter value the File will be displayed.
''A value of an empty string, the default, will show all files.
''Returns a DialogResponse value in Params(0) with the input values available to GetInput as a comma separated string.
''The first part is the file path and the last part is file name. If the user selected a path the file name is an  empty string.
Sub AsyncInputFile(filepath As String, filename As String, filefilter As String, title As String, Positive As String, Cancel As String, Negative As String, _
			cancellable As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim F As FileDialog
	F.TextColor = InputFileColor
	If InputFileTextSize > 0 Then F.TextSize = InputFileTextSize
	F.filepath = filepath
	F.ChosenName = filename
	F.filefilter = filefilter
	Try
		Dim o As Object = F.ShowAsync(title, Positive, Cancel, Negative, Null, cancellable)
		Wait For (o) Dialog_Result(response As Int)	
		input = F.filepath & "," & F.ChosenName
		params(0) = response
	Catch
		params(0) = DialogResponse_Cancel
		input = LastException.Message		
	End Try
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputListBox(itemarrayname, title, selecteditem, cancellable, callback, paramsarrayname)
''Show a modal dialog box and prompt the user to select an item.
''itemarrayname is the name of an array containing the items to display.
''title is displayed at the top of the dialog.
''selecteditem is the index of the item that will first be selected or -1 if no item should be preselected.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Returns the index of the selected item in Params(0) or DialogResponse_Cancel if the user pressed on the back key.
Sub AsyncInputListBox(itemarrayname As String, title As String, selecteditem As String, _
			cancellable As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim l As List
	l.Initialize
	Dim ia(0) As String
	ia = BlibGetArray(itemarrayname)
	For I = 0 To ia.Length - 1
		l.Add(ia(I))
	Next
	InputListAsync(l, title, selecteditem, cancellable)		
	Wait For InputList_Result (Index As Int)
	params(0) = Index
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputMultiMapBox(keysarrayname, valuesarrayname, title, cancellable, callback, paramsarrayname)
''Show a non-modal dialog with a list of items and checkboxes. The user can select multiple items.
''This is the non-modal replacement for the modal MultiListBox.
''title is displayed at the top of the dialog.
''keysarrayname is an array of items to display.
''valuesarrayname is an array of the state, True or False, of the checkbox for each item.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''Sets valuesarrayname to show the state, True or False, of the checkboxes selected by the user.
''Returns the number of selected items in Params(0).
''The dialog is closed by pressing on the "Ok" button.
Sub AsyncInputMultiMapBox(keysarrayname As String, valuesarrayname As String, title As String, _
				cancellable As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim m As Map
	m.Initialize
	Dim ka(0) As String
	ka = BlibGetArray(keysarrayname)
	Dim va(0) As String
	va = BlibGetArray(valuesarrayname)
	For i = 0 To ka.Length - 1
		m.Put(ka(i), va(i)) ' dialog will cast string to boolean value
	Next
	InputMapAsync(m, title, cancellable)
	Wait For InputMap_Result	
	Dim count As Int = 0
	For i = 0 To ka.Length - 1
		ka(i) = m.GetKeyAt(i)
		va(i) = m.GetValueAt(i)
		If va(i) Then count = count + 1
	Next
	params(0) = count
	Blib.ShareArray(keysarrayname, ka)
	Blib.ShareArray(valuesarrayname, va)	
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputNumber(showsign, digits, number, title, positive, cancel, negative, cancellable, callback, paramsarraynam)
''Show a modal dialog box and prompt the user for an integer number.
''title is displayed at the top of the dialog.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''showsign if True makes the sign of the number correspond to the sign entered by the user.
''Returns a DialogResponse value in Params(0) with the input number available to GetInput.
Sub AsyncInputNumber(showsign As String, digits As String, number As String, title As String, Positive As String, Cancel As String, Negative As String, _
			cancellable As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim n As NumberDialog
	n.showsign = showsign
	n.digits = digits
	n.number = number
	Dim o As Object = n.ShowAsync(title, Positive, Cancel, Negative, Null, cancellable)
	Wait For (o) Dialog_Result(Result As Int)
	input = n.number
	params(0) = Result
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncInputTime2(title, showhour, showminute, positive, cancel, negative, cancellable, callback, paramsarrayname)
''Show a non-modal dialog box and prompt the user for a time. The time is always in 24 hour format.
''title is displayed at the top of the dialog.
''showhour and showminute specify the time selected when the dialog is shown.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''The cancellable, callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Returns a DialogResponse value in paramsarrayname(0) with the time available to GetInput as a string formatted as 'HH:mm'.
''The literal string result avoids issues with Daylight Saving Time if ticks were used and Time used to parse it.
''InputTime appears to massage its ticks value to suit the present DST setting so Time can be used to parse its return.
Sub AsyncInputTime2(title As String, HourShown As String, MinuteShown As String, Positive As String, Cancel As String, Negative As String, _ 
			cancellable As String, callback As String, paramsarrayname As String	)
	' copy the parameter array contents
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Dim TD As TimeDialog2
	TD.Initialize
	TD.Hour = HourShown
	TD.Minute = MinuteShown
	Dim o As Object = TD.ShowAsyncComplete(title, Positive, Cancel, Negative, cancellable)
	Wait For (o) Complete(response As Int)
	input = TD.Hour & ":" & TD.Minute
	params(0) = response
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncMsgbox(msg, title, callback, paramsarrayname)
''Show a non-modal message box with the specified message and title.
''The dialog will show one OK button.
''message is the dialog message.
''title is the dialog title.
''The callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''AsyncMsgbox does not return a DialogResponse value. Callback is called when AsyncMsgbox is closed.
Sub AsyncMsgbox(msg As String, title As String, callback As String, paramsarrayname As String)
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	MsgboxAsync(msg, title)
	Wait For Msgbox_Result (Result As Int)
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncMsgbox2(msg, title, positive, cancel, negative, cancellable, callback, paramsarrayname)
''Show a non-modal message box with the specified message and title.
''message is the dialog message.
''title is the dialog title.
''Set the positive, cancel and negative parameters to the desired button text or leave blank to omit the button.
''The cancellable, callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
''Returns a DialogResponse value in paramsarrayname(0).
Sub AsyncMsgbox2(msg As String, title As String, positive As String, cancel As String, negative As String, cancellable As String,callback As String, paramsarrayname As String)
	' copy the parameter array contents
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Msgbox2Async(msg, title, positive, cancel, negative, Null, cancellable)
	Wait For Msgbox_Result (Result As Int)
	params(0) = Result
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

''@N:AsyncSleep(delay, callback, paramsarrayname)
''Invoke the callback after the specified time has elapsed.
''delay is the length of time to sleep in milliseconds.
''The callback and paramsarrayname parameters are as described in the ASYNC USER INTERACTION introduction above.
Sub AsyncSleep(delay As String, callback As String, paramsarrayname As String)
	' copy the parameter array contents
	Dim params() As String = BlibGetAsyncArray(paramsarrayname)
	Sleep(delay)
	If Blib.CanCall(callback) Then
		Blib.Call(callback, params)
	End If
End Sub

#End Region


#Region Debugging Functions

''<a name="debugging"></a>
''@H:DEBUGGING FUNCTIONS
''
''The BreakXxxx functions below rely on a modal dialog to halt program execution while debugging.
''At the moment these are available and for their use here cause no problems.
''However if modality problems are experienced DebugSnapShot, AsyncMsgbox and AsyncMsgbox2 are alternatives.

''@N:Blog(message)
''Logs the provided message to the B4A IDE Log window.
''The project must be running in Debug mode in the B4A IDE or with
'''#BridgeLogger: True' in the Main module and running in Release mode in the B4A IDE.
Sub Blog(message As String)
	Log(message)
End Sub

''@N:Break
''Halt the program and display the local and global variable values and any Print output.
''This is the same as setting the break line to the line following this statement.
''Only one breakpoint can be active at any one time so this overwrites any Break set by BreakAt.
Sub Break
	Blib.BreakAtLine = Blib.LineNumber + 1
End Sub

''@N:BreakAt(linenumber)
''Halt the program before executing the specified line and display the local and global variable values and any Print output.
''This is the same as setting the break line to the line number specified.
''Only one breakpoint can be active at any one time.
''A breakpoint set by BreakAt can be disabled by invoking BreakAt(0).
Sub BreakAt(linenumber As String)
	Blib.BreakAtLine = linenumber
End Sub

''@N:BreakAndPrint(message)
''Halt the program and display the local and global variable values and any Print output.
''This is the same as calling Break except that message is added to the Print output as though Printed.
Sub BreakAndPrint(message As String)
	Blib_Message(message, "Print")
	Break
End Sub

''@N:BreakAndPrintIf(break, message)
''Halt the program and display the local and global variable values and any Print output if boolbreak is True.
''This is the same as calling BreakIf except that message is added to the Print output as though Printed if lbreak is True.
Sub BreakAndPrintIf(boolBreak As String, message As String)
	Blib.BreakAtLine = 0
	If boolBreak Then
		Blib_Message(message, "Print")
		Break
	End If
End Sub

''@N:BreakIf(break)
''Halt the program and display the local and global variable values and any Print output if boolbreak is True.
''This is the same as setting the break line to the line following this statement if break is True otherwise it is set to 0.
''Only one breakpoint can be active at any one time so this overwrites any Break set by BreakAt.
Sub BreakIf(boolbreak As String)
	Blib.BreakAtLine = 0
	If boolbreak Then
		Break
	End If
End Sub

''@N:DebugSnapShot(message, showglobals)
''Display the local, and optionally global, variable values and any Print output in a non-modal dialog.
''If showglobals is false then global variables are not included, this can be useful if there are many globals.
''message will be prepended to the variable and Print data.
''Unlike the BreakXxxx  functions this is not a modal display and is provided for use if modality problems are experienced.
''The program will carry on running while the dialog is displayed.
''The non-modal AsyncMsgbox and AsyncMsgbox2 can also be used for displaying debug data if modality problems are experienced.
Sub DebugSnapShot(message As String, showglobals As String)
	Dim msg As String = message & CRLF & CRLF & GetVariableVals(showglobals)	
	MsgboxAsync(msg, "Debug Snapshot")
End Sub

#End Region


#Region Color constants

''<a name="colors"></a>
''@H:COLOR NAMES AND CONSTANTS 
''
''These additional color constants return the color codes for the named color.
''
''@cDarkGray
''@cLightGray
''@cMagenta
''@cTransparent

Sub cDarkGray As String
	Return Colors.DarkGray
End Sub

Sub cLightGray As String
	Return Colors.LightGray
End Sub

Sub cMagenta As String
	Return Colors.Magenta
End Sub

Sub cTransparent As String
	Return Colors.Transparent
End Sub

''@N:GetColourName(colourvalue)
''Returns the properly cased HTML or X11 name for a colour from its value.
''colourvalue is the integer value of the colour.
''The alpha value of colourvalue is ignored.
''Returns an empty string if colourvalue does not match a named colour.
Sub GetColourName(colourvalue As String) As String
	Return ColourNames.GetName(colourvalue)
End Sub

''@N:GetColourNameAt(index)
''Returns the properly cased HTML or X11 name for a colour at index position in the list of colours.
''The colour names are in alphabetical order.
''This function can be used with GetColourNumbers to iterate through all the supported colour names.
Sub GetColourNameAt(index As String) As String
	Return ColourNames.GetNameAt(index)
End Sub

''@N:GetnumberOfColours
''Returns the number of colours in the list of colours.
Sub GetnumberOfColours As String
	Return ColourNames.GetNumberOfColours
End Sub

''@N:GetNamedColour(name, alpha)
''Returns the signed integer representing a colour from its HTML or X11 name.
''name is the name of the required colour.
''alpha specifies the Alpha value of the returned colour value.
''Returns Black with the specified alpha value if the colour name does not exist.
Sub GetNamedColour(name As String, alpha As String ) As String
	Return ColourNames.GetColour(name, alpha)
End Sub

#End Region


#Region Keycode functions

''<a name="key"></a>
''@H:KEYCODE FUNCTIONS AND CONSTANTS
''
''Pass the KeyCode value from the Activity_KeyPress event to any of these functions
''They will Return True or False depending upon whether the passed KeyCode is contained within that particular set.
''
''@Key_isNumber(KeyCode)
''Numeric keys are: 0123456789
''
''@Key_isAlpha(KeyCode)
'' Alpha keys are: ABCDEFGHIJKLMNOPQRSTUVWXYZ
''
''@Key_isSymbol(KeyCode)
'' Symbol keys are: '@/,=(-.+#^);\*
''
''@Key_isKeyboard(KeyCode)
''Keyboard keys are:  AltLeft AltRight Clear Del Enter Num ShiftLeft ShiftRight Space Symbol
''
''@Key_isDPad(KeyCode)
''DPad Keys are: Left Center Right Up Down
''
''@Key_isMedia(KeyCode)
''Media keys are:  FastForward Next Play/Pause Rewind Stop Mute
''
''@Key_isDevice(KeyCode)
''Device keys are : Back Call Camera EndCall Envelope Explorer Focus Grave HeadsetHook Home 
''&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;Menu Notification Search SoftLeft SoftRight VolumeUp VolumeDown

Sub Key_isNumber(KeyCode As String) As String
	Dim isnum As Boolean
	isnum = True
	Select KeyCode
		Case KeyCodes.KEYCODE_0
		Case KeyCodes.KEYCODE_1
		Case KeyCodes.KEYCODE_2
		Case KeyCodes.KEYCODE_3
		Case KeyCodes.KEYCODE_4
		Case KeyCodes.KEYCODE_5
		Case KeyCodes.KEYCODE_6
		Case KeyCodes.KEYCODE_7
		Case KeyCodes.KEYCODE_8
		Case KeyCodes.KEYCODE_9
		Case Else
			isnum = False
	End Select
	Return isnum
End Sub

Sub Key_isAlpha(KeyCode As String) As String
	Dim isalpha As Boolean
	isalpha = True
	Select KeyCode
		Case KeyCodes.KEYCODE_A
		Case KeyCodes.KEYCODE_B
		Case KeyCodes.KEYCODE_C
		Case KeyCodes.KEYCODE_D
		Case KeyCodes.KEYCODE_E
		Case KeyCodes.KEYCODE_F
		Case KeyCodes.KEYCODE_G
		Case KeyCodes.KEYCODE_H
		Case KeyCodes.KEYCODE_I
		Case KeyCodes.KEYCODE_J
		Case KeyCodes.KEYCODE_K
		Case KeyCodes.KEYCODE_L
		Case KeyCodes.KEYCODE_M
		Case KeyCodes.KEYCODE_N
		Case KeyCodes.KEYCODE_O
		Case KeyCodes.KEYCODE_P
		Case KeyCodes.KEYCODE_Q
		Case KeyCodes.KEYCODE_R
		Case KeyCodes.KEYCODE_S
		Case KeyCodes.KEYCODE_T
		Case KeyCodes.KEYCODE_U
		Case KeyCodes.KEYCODE_V
		Case KeyCodes.KEYCODE_W
		Case KeyCodes.KEYCODE_X
		Case KeyCodes.KEYCODE_Y
		Case KeyCodes.KEYCODE_Z
		Case Else
			isalpha = False
	End Select
	Return isalpha
End Sub

Sub Key_isSymbol(KeyCode As String) As String
	Dim issym As Boolean
	issym = True
	Select KeyCode
		Case KeyCodes.KEYCODE_APOSTROPHE
		Case KeyCodes.KEYCODE_AT
		Case KeyCodes.KEYCODE_BACKSLASH
		Case KeyCodes.KEYCODE_COMMA
		Case KeyCodes.KEYCODE_EQUALS
		Case KeyCodes.KEYCODE_LEFT_BRACKET
		Case KeyCodes.KEYCODE_MINUS
		Case KeyCodes.KEYCODE_PERIOD
		Case KeyCodes.KEYCODE_PLUS
		Case KeyCodes.KEYCODE_POUND
		Case KeyCodes.KEYCODE_POWER
		Case KeyCodes.KEYCODE_RIGHT_BRACKET
		Case KeyCodes.KEYCODE_SEMICOLON
		Case KeyCodes.KEYCODE_SLASH
		Case KeyCodes.KEYCODE_STAR
		Case Else
			issym = False
	End Select
	Return issym
End Sub

Sub Key_isKeyboard(KeyCode As String) As String
	Dim iskey As Boolean
	iskey = True
	Select KeyCode
		Case KeyCodes.KEYCODE_ALT_LEFT
		Case KeyCodes.KEYCODE_ALT_RIGHT
		Case KeyCodes.KEYCODE_CLEAR
		Case KeyCodes.KEYCODE_DEL
		Case KeyCodes.KEYCODE_ENTER
		Case KeyCodes.KEYCODE_NUM
		Case KeyCodes.KEYCODE_SHIFT_LEFT
		Case KeyCodes.KEYCODE_SHIFT_RIGHT
		Case KeyCodes.KEYCODE_SPACE
		Case KeyCodes.KEYCODE_SYM
		Case Else
			iskey = False
	End Select
	Return iskey
End Sub

Sub Key_isDPad(KeyCode As String) As String
	Dim ispad As Boolean
	ispad = True
	Select KeyCode
		Case KeyCodes.KEYCODE_DPAD_CENTER
		Case KeyCodes.KEYCODE_DPAD_DOWN
		Case KeyCodes.KEYCODE_DPAD_LEFT
		Case KeyCodes.KEYCODE_DPAD_RIGHT
		Case KeyCodes.KEYCODE_DPAD_UP
		Case Else
			ispad = False
	End Select
	Return ispad
End Sub

Sub Key_isMedia(KeyCode As String) As String
	Dim ismed As Boolean
	ismed = True
	Select KeyCode
		Case KeyCodes.KEYCODE_MEDIA_FAST_FORWARD
		Case KeyCodes.KEYCODE_MEDIA_NEXT
		Case KeyCodes.KEYCODE_MEDIA_PLAY_PAUSE
		Case KeyCodes.KEYCODE_MEDIA_PREVIOUS
		Case KeyCodes.KEYCODE_MEDIA_REWIND
		Case KeyCodes.KEYCODE_MEDIA_STOP
		Case KeyCodes.KEYCODE_MUTE
		Case Else
			ismed = False
	End Select
	Return ismed
End Sub

Sub Key_isDevice(KeyCode As String) As String
	Dim isdev As Boolean
	isdev = True
	Select KeyCode
		Case KeyCodes.KEYCODE_BACK
		Case KeyCodes.KEYCODE_CALL
		Case KeyCodes.KEYCODE_CAMERA
		Case KeyCodes.KEYCODE_ENDCALL
		Case KeyCodes.KEYCODE_ENVELOPE
		Case KeyCodes.KEYCODE_EXPLORER	'not sure bout this one???
		Case KeyCodes.KEYCODE_FOCUS		'or this one???
		Case KeyCodes.KEYCODE_GRAVE		'have no idea bout this one???
		Case KeyCodes.KEYCODE_HEADSETHOOK
		Case KeyCodes.KEYCODE_HOME
		Case KeyCodes.KEYCODE_MENU
		Case KeyCodes.KEYCODE_NOTIFICATION
		Case KeyCodes.KEYCODE_SEARCH
		Case KeyCodes.KEYCODE_SOFT_LEFT
		Case KeyCodes.KEYCODE_SOFT_RIGHT
		Case KeyCodes.KEYCODE_VOLUME_DOWN
		Case KeyCodes.KEYCODE_VOLUME_UP
		Case Else
			isdev = False
	End Select
	Return isdev
End Sub

''
''
''Pass a KeyCode to these functions to get the ASCII value of a key as returned by Asc().
''Whether a KeyCode is a letter, number or symbol can be checked using the KeyCode functions above.
''KeyCodes for 0 to 9 are integer values 7 to 16.
''KeyCodes for letters A to Z are integer values 29 to 54.
''
''@ KeyToAsciiUpper(KeyCode)
''@ KeyToAsciiLower(KeyCode)
''@ KeyToNumberKey(KeyCode)

Sub KeyToAsciiUpper(KeyCode As String) As String
	Return KeyCode + 36
End Sub

Sub KeyToAsciiLower(KeyCode As String) As String
	Return KeyCode + 67
End Sub

Sub KeyToNumberKey(KeyCode As String) As String
	Return KeyCode + 19
End Sub

''
''
''KeyCode constants:
''Note that not all KeyCode constants are supported.
''Whether a KeyCode is a letter, number or symbol can be checked using the KeyCode functions above.
''KeyCodes for 0 to 9 are integer values 7 to 16.
''KeyCodes for letters A to Z are integer values 29 to 54.
''
''@Key_AltLeft
''@Key_AltRight
''@Key_Back
''@Key_Call
''@Key_Camera
''@Key_Clear
''@Key_Del
''@Key_DPadCenter
''@Key_DPadDown
''@Key_DPadLeft
''@Key_DPadRight
''@Key_DPadUp
''@Key_EndCall
''@Key_Enter
''@Key_Envelope
''@Key_Explorer
''@Key_Focus
''@Key_Grave
''@Key_HeadSetHook
''@Key_Home
''@Key_MediaFastForward
''@Key_MediaNext
''@Key_MediaPlayPause
''@Key_MediaPrevious
''@Key_MediaRewind
''@Key_MediaStop
''@Key_Menu
''@Key_Mute
''@Key_Notification
''@Key_Num
''@Key_Search
''@Key_ShiftLeft
''@Key_ShiftRight
''@Key_SoftLeft
''@Key_SoftRight
''@Key_Sym
''@Key_Tab
''@Key_Unknown
''@Key_VolumeDown
''@Key_VolumnUp

Sub Key_AltLeft As String
	Return KeyCodes.KEYCODE_ALT_LEFT
End Sub

Sub Key_AltRight As String
	Return KeyCodes.KEYCODE_ALT_RIGHT
End Sub

Sub Key_Back As String
	Return KeyCodes.KEYCODE_BACK
End Sub

Sub Key_Call As String
	Return KeyCodes.KEYCODE_CALL
End Sub

Sub Key_Camera As String
	Return KeyCodes.KEYCODE_CAMERA
End Sub

Sub Key_Clear As String
	Return KeyCodes.KEYCODE_CLEAR
End Sub

Sub Key_Del As String
	Return KeyCodes.KEYCODE_DEL
End Sub

Sub Key_DPadCenter As String
	Return KeyCodes.KEYCODE_DPAD_CENTER
End Sub

Sub Key_DPadDown As String
	Return KeyCodes.KEYCODE_DPAD_DOWN
End Sub

Sub Key_DPadLeft As String
	Return KeyCodes.KEYCODE_DPAD_LEFT
End Sub

Sub Key_DPadRight As String
	Return KeyCodes.KEYCODE_DPAD_RIGHT
End Sub

Sub Key_DPadUp As String
	Return KeyCodes.KEYCODE_DPAD_UP
End Sub

Sub Key_EndCall As String
	Return KeyCodes.KEYCODE_ENDCALL
End Sub

Sub Key_Enter As String
	Return KeyCodes.KEYCODE_ENTER
End Sub	

Sub Key_Envelope As String
	Return KeyCodes.KEYCODE_ENVELOPE
End Sub

Sub Key_Explorer As String
	Return KeyCodes.KEYCODE_EXPLORER
End Sub

Sub Key_Focus As String
	Return KeyCodes.KEYCODE_FOCUS
End Sub

Sub Key_Grave As String
	Return KeyCodes.KEYCODE_GRAVE
End Sub

Sub Key_HeadSetHook As String
	Return KeyCodes.KEYCODE_HEADSETHOOK
End Sub

Sub Key_Home As String
	Return KeyCodes.KEYCODE_HOME
End Sub

Sub Key_MediaFastForward As String
	Return KeyCodes.KEYCODE_MEDIA_FAST_FORWARD
End Sub

Sub Key_MediaNext As String
	Return KeyCodes.KEYCODE_MEDIA_NEXT
End Sub

Sub Key_MediaPlayPause As String
	Return KeyCodes.KEYCODE_MEDIA_PLAY_PAUSE
End Sub

Sub Key_MediaPrevious As String
	Return KeyCodes.KEYCODE_MEDIA_PREVIOUS
End Sub

Sub Key_MediaRewind As String
	Return KeyCodes.KEYCODE_MEDIA_REWIND
End Sub

Sub Key_MediaStop As String
	Return KeyCodes.KEYCODE_MEDIA_STOP
End Sub

Sub Key_Menu As String
	Return KeyCodes.KEYCODE_MENU
End Sub

Sub Key_Mute As String
	Return KeyCodes.KEYCODE_MUTE
End Sub

Sub Key_Notification As String
	Return KeyCodes.KEYCODE_NOTIFICATION
End Sub

Sub Key_Num As String
	Return KeyCodes.KEYCODE_NUM
End Sub

Sub Key_Search As String
	Return KeyCodes.KEYCODE_SEARCH
End Sub

Sub Key_ShiftLeft As String
	Return KeyCodes.KEYCODE_SHIFT_LEFT
End Sub

Sub Key_ShiftRight As String
	Return KeyCodes.KEYCODE_SHIFT_RIGHT
End Sub

Sub Key_SoftLeft As String
	Return KeyCodes.KEYCODE_SOFT_LEFT
End Sub

Sub Key_SoftRight As String
	Return KeyCodes.KEYCODE_SOFT_RIGHT
End Sub

Sub Key_Sym As String
	Return KeyCodes.KEYCODE_SYM
End Sub

Sub Key_Tab As String
	Return KeyCodes.KEYCODE_TAB
End Sub

Sub Key_Unknown As String
	Return KeyCodes.KEYCODE_UNKNOWN
End Sub

Sub Key_VolumeDown As String
	Return KeyCodes.KEYCODE_VOLUME_DOWN
End Sub

Sub Key_VolumnUp As String
	Return KeyCodes.KEYCODE_VOLUME_UP
End Sub

#End Region


#Region Gravity constants
''<a name="gravity"></a>
''@H:GRAVITY CONSTANTS
''
''These gravity constants return gravity values needed by functions for justifying text and images.
''They may be used instead of hard coding numeric values.
''
''@Gravity_None
''@Gravity_Top
''@Gravity_Bottom
''@Gravity_Left
''@Gravity_Right
''@Gravity_Center
''@Gravity_CenterHorizontal
''@(also Gravity_HCenter)
''@Gravity_CenterVertical
''@(also Gravity_VCenter)
''@Gravity_Fill

Sub Gravity_None As String
	Return Gravity.NO_GRAVITY
End Sub

Sub Gravity_Top As String
	Return Gravity.TOP
End Sub

Sub Gravity_Bottom As String
	Return Gravity.BOTTOM
End Sub

Sub Gravity_Left As String
	Return Gravity.LEFT
End Sub

Sub Gravity_Right As String
	Return Gravity.RIGHT
End Sub

Sub Gravity_Center As String
	Return Gravity.CENTER
End Sub

Sub Gravity_CenterHorizontal As String
	Return Gravity.CENTER_HORIZONTAL
End Sub

Sub Gravity_HCenter As String
	Return Gravity.CENTER_HORIZONTAL
End Sub

Sub Gravity_CenterVertical As String
	Return Gravity.CENTER_VERTICAL
End Sub

Sub Gravity_VCenter As String
	Return Gravity.CENTER_VERTICAL
End Sub

Sub Gravity_Fill As String
	Return Gravity.FILL
End Sub

#End Region


#Region Typeface constants

''<a name="typeface"></a>
''@H:TYPEFACE CONSTANTS
''
''These typeface constants return the values needed for the typeface functions.
''They may be used instead of hard coding numeric values.
''
''@FontDefault
''@FontMonospace
''@FontSerif
''@FontSansSerif
''@StyleNormal
''@StyleBold
''@StyleItalic
''@StyleBoldItalic

Sub FontDefault As String
	Return "default"
End Sub

Sub FontMonospace As String
	Return "monospace"
End Sub

Sub FontSerif As String
	Return "serif"
End Sub

Sub FontSansSerif As String
	Return "sans_serif"
End Sub

Sub StyleNormal As String
	Return Typeface.STYLE_NORMAL
End Sub

Sub StyleBold As String
	Return Typeface.STYLE_BOLD
End Sub

Sub StyleItalic As String
	Return Typeface.STYLE_ITALIC
End Sub

Sub StyleBoldItalic As String
	Return Typeface.STYLE_BOLD_ITALIC
End Sub

#End Region


#Region Sensor constants

''<a name="csensors"></a>
''@H:SENSOR CONSTANTS
''
''These sensor constants return the integer identifiers needed for the different sensor types.
''They may be used instead of hard coding numeric values.
''
''@cAccelerometer = 1
''@cMagnetic = 2
''@cOrientation = 3
''@cGyroscope = 4
''@cLight = 5
''@cPressure = 6 
''@cTemperature = 7
''@cProximity = 8
''@cGravity = 9
''
''Here are some values for less common sensors that might be present
''cLinearAcceleration = 10
''cRotationVector = 11
''cRelativeHumidity = 12
''cAmbientTemperature = 13
''cMagneticFieldUncalibrated = 14
''cGameRotationVector = 15
''cGyroscopeUncalibrated = 16
''cSignificantMotion = 17
''cStepDetector = 18
''cStepCounter = 19
''cGeoMagneticRotationVector = 20
''cHeartRate = 21
''cStationaryDetect = 29
''cMotionDetect = 30
''cHeartBeat = 31
''cLowLatencyOffbodyDetect = 34
''cAccelerometerUncalibrated = 35


Sub cAccelerometer As String
	Return 1
End Sub

Sub cMagnetic As String
	Return 2
End Sub

Sub cOrientation As String
	Return 3
End Sub

Sub cGyroscope As String
	Return 4
End Sub

Sub cLight As String
	Return 5
End Sub

Sub cPressure As String
	Return 6
End Sub

Sub cTemperature As String
	Return 7
End Sub

Sub cProximity As String
	Return 8
End Sub

Sub cGravity As String
	Return 9
End Sub

#End Region


#Region AddNewSysCalls

' Call once after Blib.Initialize to add the new functions
Sub AddNewSysCalls
	'
	' System functions included with BasicLibIDE
	'
	' General functions
	Blib.AddSysCalls(Array As String( _
		"ClipboardGetText", _
		"ClipboardHasText", _
		"ClipboardSetText", _
		"CloseApplication", _
		"IfThenElse", _
		"cNumbers", _
		"cCaseInsensitive", _ 
		"HideKeyboard"))
	' String, numeric and logical functions
	Blib.AddSysCalls(Array As String( _
		"FormatNumber", _
		"FormatNumber2", _
		"IntFromHex", _
		"IntToBinary", _
		"IntToHex", _
		"ParseInt", _
		"SBAppend", _
		"SBInitialize", _
		"SBInsert", _
		"SBLength", _
		"SBRemove", _
		"SBToString", _ 
		"ShiftLeft", _ 
		"ShiftRight", _ 
		"ShiftRightUnsigned", _ 
		"StrTrim"))
' Activity functions
	Blib.AddSysCalls(Array As String( _
		"ActivityFinish", _
		"CanCall", _
		"Chain", _
		"CloseAfterThis", _
		"CloseMenu", _
		"GetActivityHeight", _
		"GetActivityWidth", _	
		"GetAllViews", _								
		"GetFirstTime", _
		"GetLayoutValues", _
		"GetOrientation", _
		"GetRestarting", _
		"GetScreenScale", _
		"OpenMenu", _
		"ResetState", _
		"RestartActivity", _
		"RestoreState", _
		"SaveState", _
		"SetActivityBackground", _
		"SetActivityTitle", _
		"SetOrientation", _
		"SetActivityTitleColor"))		
	' Array functions
	Blib.AddSysCalls(Array As String( _
		"FillArray", _
		"SearchArray", _
		"SortArray", _
		"SortArrays2"))
	'File functions
	Blib.AddSysCalls(Array As String( _
		"FileCopy", _
		"FileDelete", _
		"FileDirAssets", _
		"FileDirDefaultExternal", _
		"FileDirInternal", _
		"FileDirInternalCache", _
		"FileDirRootExternal", _
		"FileExists", _
		"FileGetPath", _
		"FileIsDirectory", _
		"FileExternalWritable", _
		"FileListFiles", _
		"FileMakeDir", _
		"FileReadList", _
		"FileReadString", _
		"FileRename", _
		"FileWriteList", _
		"FileWriteString", _
		"FileSafeDirDefaultExternal"))
	' Add View Tunctions and Events
	Blib.AddSysCalls(Array As String( _
		"AddButton", _
		"AddCheckBox", _
		"AddEditText", _
		"AddHorizontalScrollView", _
		"AddImageView", _
		"AddLabel", _
		"AddListView", _
		"AddMenuItem", _
		"AddPanel", _
		"AddProgressBar", _
		"AddRadioButton", _
		"AddScaleImageView", _
		"AddScrollView", _
		"AddScrollView2D", _
		"AddSeekBar", _
		"AddSpinner", _
		"AddTabHost", _
		"AddTable2D", _
		"AddToggleButton", _
		"RemoveAllViewsEntirely", _
		"RemoveView", _
		"RemoveViewEntirely"))
	' Shared View functions
	Blib.AddSysCalls(Array As String( _
		"BringToFront", _
		"GetBottom", _
		"GetElevation", _
		"GetEnabled", _
		"GetHeight", _
		"GetLeft", _
		"GetPadding", _
		"GetParent", _
		"GetRight", _
		"GetTop", _
		"GetVisible", _
		"GetWidth", _
		"Invalidate", _
		"IsView", _
		"RequestFocus", _
		"SendToBack", _
		"SetBackground", _
		"SetBackgroundGradient", _
		"SetBackgroundImage", _
		"SetBottom", _
		"SetColor", _
		"SetElevation", _
		"SetEnabled", _
		"SetHeight", _
		"SetLeft", _
		"SetPadding", _ 
		"SetParent", _
		"SetRight", _
		"SetTop", _
		"SetVisible", _
		"SetWidth"))
	' CheckBox, RadioButton and ToggleButton functions
	Blib.AddSysCalls(Array As String( _
		"GetChecked", _
		"SetChecked", _
		"SetTextOn", _
		"SetTextOff"))
	' Edittext functions
	Blib.AddSysCalls(Array As String( _
		"GetSelectionStart", _
		"SelectAll", _
		"SelectText", _
		"SetForceDoneButton", _
		"SetHint", _
		"SetHintColor", _
		"SetInputType", _
		"SetPasswordMode", _
		"SetSelectionStart", _
		"SetSingleLine", _
		"SetWrap"))
	' Graphics functions
	Blib.AddSysCalls(Array As String( _
		"BitmapHeight", _
		"BitmapInit", _
		"BitmapInitImage", _
		"BitmapInitMutable", _
		"BitmapWidth", _
		"CanvasInit", _
		"CanvasInit2", _
		"DrawBitmap", _
		"DrawBitmapFlipped", _
		"DrawBitmapRotated", _
		"DrawCircle", _
		"DrawColor", _
		"DrawLine", _
		"DrawOval", _
		"DrawOvalRotated", _
		"DrawPath", _
		"DrawPoint", _
		"DrawRect", _
		"DrawRectRotated", _
		"DrawText", _
		"DrawTextRotated"))
	' ImageView and ScaleImageView functions
	Blib.AddSysCalls(Array As String( _
		"LoadImageView", _ 
		"LoadImageViewBitmap", _
		"LoadImageViewFill", _
		"SetImageViewGravity", _
		"GetCenter", _ 
		"GetIsReady", _ 
		"GetMaxZoom", _
		"GetScale", _
		"GetSrcHeight", _
		"GetSrcWidth", _
		"LoadScaleImageView", _
		"Recycle", _
		"SetMaxZoom", _
		"SetPanLimit", _
		"SetScaleAndCenter", _
		"SetScaleAndCenterPixels", _
		"SourceXYtoViewXY", _
		"ViewXYtoSourceXY"))
	' Listview functions
	Blib.AddSysCalls(Array As String( _
		"GetLabel", _
		"SetFastScrollEnabled", _
		"SetItemHeight", _									 
		"SetLayoutBackgroundColor", _
		"SetLayoutBackgroundColorgradient", _
		"SetScrollColor"))
	' Listview & spinner functions
	Blib.AddSysCalls(Array As String( _
		"AddItem", _
		"AddAll", _
		"Clear", _
		"GetItemAt", _
		"GetSize", _
		"RemoveAt"))
	' Phone functions
	Blib.AddSysCalls(Array As String( _
		"KeepAlive", _
		"PartialLock", _
		"Shell", _
		"ShellAsync", _
		"Vibrate"))		
	' ProgressBar functions
	Blib.AddSysCalls(Array As String( _
		"GetIndeterminate", _
		"GetProgress", _
		"SetIndeterminate", _
		"SetProgress"))		
	' Regular Expression functions
	Blib.AddSysCalls(Array As String( _
		"MatcherFind", _
		"MatcherGetEnd", _
		"MatcherGetStart", _
		"MatcherGroup", _
		"MatcherGroupCount", _
		"MatcherMatch", _
		"Regex_Multiline", _
		"Regex_CaseInsensitive", _
		"RegexIsMatch", _
		"RegexIsMatch2", _
		"RegexMatcher", _
		"RegexMatcher2", _
		"RegexReplace", _
		"RegexReplace2", _
		"RegexSplit", _
		"RegexSplit2"))		
	' ScrollView functions
	Blib.AddSysCalls(Array As String( _
		"AdoptPanel", _
		"FullScroll", _
		"GetPanel", _
		"GetScrollPosition", _
		"SetScrollPosition"))
	' SeekBar functions
	Blib.AddSysCalls(Array As String( _
		"GetMax", _
		"GetValue", _
		"SetMax", _
		"SetValue"))
	' Spinner functions
	Blib.AddSysCalls(Array As String( _
		"GetSelectedIndex", _
		"GetSelectedItem", _
		"SetDropdownBackgroundColor", _
		"SetDropdownTextColor", _
		"SetSelectedIndex"))
	' TabHost functions
	Blib.AddSysCalls(Array As String( _
		"AddTab", _
		"AddTabPanel", _
		"GetCurrentTab", _
		"GetTabCount", _
		"SetCurrentTab"))
	' Textview functions
	Blib.AddSysCalls(Array As String( _
		"CreateTypeface", _
		"GetText", _
		"SetGravity", _
		"SetText", _
		"SetTextColor", _
		"SetTextSize", _
		"SetTypeface"))
	' Timer functions
	Blib.AddSysCalls(Array As String( _
		"SetTimerEnabled", _
		"SetTimerInterval"))
	'User interaction functions
	Blib.AddSysCalls(Array As String( _
		"CallDoEvents", _
		"DialogResponse_Positive", _
		"DialogResponse_Cancel", _
		"DialogResponse_Negative", _								 
		"GetInput", _
		"InputBox", _
		"InputBox2", _
		"InputCustom", _
		"InputDate", _
		"InputDate2", _
		"InputFile", _
		"InputListBox", _
		"InputMultiListBox", _
		"InputNumber", _
		"InputTime", _
		"InputTime2", _
		"MessageBox", _
		"MessageBox2", _
		"ProgressHide", _
		"ProgressShow", _
		"SetInputFileColor", _
		"SetInputFileTextSize", _
		"ShowToast", _
		"Type_Decimal", _
		"Type_Integer", _
		"Type_SignedInteger", _
		"Type_Phone", _
		"Type_Text"))
	' Color constants
	Blib.AddSysCalls(Array As String( _
		"GetColourName", _
		"GetColourNameAt", _
		"GetColourNumbers", _
		"GetNamedColour", _
		"cDarkGray", _
		"cLightGray", _
		"cMagenta", _
		"cTransparent"))	
	' KeyCode functions and constants
	Blib.AddSysCalls(Array As String( _
		"Key_isNumber", _
		"Key_isAlpha", _
		"Key_isSymbol", _
		"Key_isKeyboard", _
		"Key_isDPad", _
		"Key_isMedia", _
		"Key_isDevice", _
		"Key_AltLeft", _
		"Key_AltRight", _
		"Key_Back", _
		"Key_Call", _
		"Key_Camera", _
		"Key_Clear", _
		"Key_Del", _
		"Key_DPadCenter", _
		"Key_DPadDown", _
		"Key_DPadLeft", _
		"Key_DPadRight", _
		"Key_DPadUp", _
		"Key_EndCall", _
		"Key_Enter", _
		"Key_Envelope", _
		"Key_Explorer", _
		"Key_Focus", _
		"Key_Grave", _
		"Key_HeadSetHook", _
		"Key_Home", _
		"Key_MediaFastForward", _
		"Key_MediaNext", _
		"Key_MediaPlayPause", _
		"Key_MediaPrevious", _
		"Key_MediaRewind", _
		"Key_MediaStop", _
		"Key_Menu", _
		"Key_Mute", _
		"Key_Notification", _
		"Key_Num", _
		"Key_Search", _
		"Key_ShiftLeft", _
		"Key_ShiftRight", _
		"Key_SoftLeft", _
		"Key_SoftRight", _
		"Key_Sym", _
		"Key_Tab", _
		"Key_Unknown", _
		"Key_VolumeDown", _
		"Key_VolumnUp"))									 
	' Gravity constants
	Blib.AddSysCalls(Array As String( _
		"Gravity_None", _
		"Gravity_Top", _
		"Gravity_Bottom", _
		"Gravity_Left", _
		"Gravity_Right", _
		"Gravity_Center", _
		"Gravity_CenterHorizontal", _
		"Gravity_HCenter", _
		"Gravity_CenterVertical", _
		"Gravity_VCenter", _
		"Gravity_Fill"))
	' Typeface Constants
	Blib.AddSysCalls(Array As String( _
		"FontDefault", _
		 "FontMonospace", _
		 "FontSerif", _
		 "FontSansSerif", _
		 "StyleNormal", _
		 "StyleBold", _
		 "StyleItalic", _
		 "StyleBoldItalic"))
	' Async
	Blib.AddSysCalls(Array As String( _
		"AsyncInputBox", _
		"AsyncInputBox2", _
		"AsyncInputCustom", _
		"AsyncInputDate2", _
		"AsyncInputFile", _
		"AsyncInputListBox", _
		"AsyncInputMultiMapBox", _
		"AsyncInputNumber", _
		"AsyncInputTime2", _
		"AsyncMsgbox", _
		"AsyncMsgbox2", _	
		"AsyncSleep"))
	' Debugging
	Blib.AddSysCalls(Array As String( _
		"Blog", _
		"Break", _
		"BreakAt", _
		"BreakAndPrint", _
		"BreakAndPrintIf", _
		"BreakIf", _
		"DebugSnapShot"))
	' Collections								 
	Blib.AddSysCalls(Array As String( _
		"ListAdd", _
		"ListClear", _
		"ListFromArray", _
		"ListGet", _
		"ListInsertAt", _
		"ListRemoveAt", _
		"ListSort", _
		"ListSize", _
		"ListSortCaseInsensitive", _
		"ListToArray", _
		"MapClear", _
		"MapFromArrays", _
		"MapGet", _
		"MapKeyAt", _
		"MapPut", _
		"MapSize", _
		"MapToArrays", _
		"MapValueAt", _
		"RestoreArray", _							 
		"RestoreGlobal", _							 
		"RestoreValue", _							 
		"SaveArray", _
		"SaveGlobal", _
		"SaveValue"))
	' Table
	Blib.AddSysCalls(Array As String( _
		"AddRow", _
		"GetCell", _
		"GetEnableSort", _
		"GetHeader", _
		"GetHeaders", _
		"GetNumberOfRows", _
		"JumpToRow", _
		"LoadTableFromCSV", _
		"Refresh", _
		"ResizeTable", _
		"RestoreData", _
		"SaveData", _
		"SaveTableToCSV", _
		"SetColSortType", _
		"SetColumnWidths", _
		"SetEnableSort", _
		"SetHeaders"))
	'Sensors
	Blib.AddSysCalls(Array As String( _
		"AddSensor", _
		"GetSensors", _
		"GetSensorValues", _
		"StartSensor", _
		"StopSensor", _		
		"cAccelerometer", _
		"cMagnetic", _
		"cOrientation", _
		"cGyroscope", _
		"cLight", _
		"cPressure", _
		"cTemperature", _
		"cProximity", _
		"cGravity"))
	'GNSS
	Blib.AddSysCalls(Array As String( _
		"GNSSAccuracy", _
		"GNSSAltitude", _
		"GNSSAvailable", _
		"GNSSRunning", _
		"GNSSSats", _
		"GNSSSatAt", _
		"GNSSSatPrn", _
		"GNSSSatsVisible", _
		"GnssBeidou", _
		"GnssGalileo", _
		"GnssGlonass", _
		"GnssGPS", _
		"StartGNSS", _
		"StopGNSS", _
		"NEtoNGR", _
		"NGRtoOSGB36", _
		"OSGB36toNGR", _
		"WGS84toOSGB36", _
		"OSGB36toWGS84", _
		"NewAltitude", _
		"NewLatitude", _
		"NewLongitude", _
		"Easting", _
		"Northing"))
End Sub


#End Region

